/*
	Parser module generated by unicc from parse.par.
	DO NOT EDIT THIS FILE MANUALLY, IT WILL GO AWAY!
*/

#if 2433 == 0
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <locale.h>
#else


#include "unicc.h"

/*
#ifndef UNICC_BOOTSTRAP
#define UNICC_DEBUG 1
#endif
*/

struct _rhs_item
{
	SYMBOL*	sym;
	char*	ident;
};

#ifndef MALLOC_STEP
#define MALLOC_STEP 255
#endif

#define UNICC_GETINPUT				getinput()
#define UNICC_PARSE_ERROR( pcb )	parse_error( pcb )


PARSER*	parser			= (PARSER*)NULL;

static char*	src_ptr;

static int		prec_cnt		= 1; /* Precedence level */
static int		line			= 1; /* Line within source file */
static int		last_code_begin;	 /* Last code begin */
static int		embedded_count	= 0;
static PROD*	current_prod	= (PROD*)NULL;
static SYMBOL*	current_sym		= (SYMBOL*)NULL;
static BOOLEAN	greedy			= TRUE;

extern int	error_count;

char*		strbuf			= (char*)NULL;
char*		regex			= (char*)NULL;

/* DEBUG */
static int getinput( void )
{
	int ch;

	/*
		IMPORTANT:
		We have to watch out for the zero-terminator;
		The parser will in some cases continue fetching
		new characters with UNICC_GETINPUT. If we read
		over the zero terminator, the parser's behavior
		will be undefined, so we may only increment it
		if we're not there!

		(Searching this BUG took at least 4 hours and
		one broken laptop -.- *arghh*)
	*/
	if( ( ch = *(src_ptr) ) )
	{
		src_ptr++;
		return ch;
	}

	return 0;
}

/* Append character to current string */
static void strbuf_append( char ch )
{
	int len;

	len = pstrlen( strbuf );

	if( !strbuf )
		strbuf = (char*)pmalloc( ( MALLOC_STEP + 2 ) * sizeof( char ) );
	else if( len % MALLOC_STEP == 0 )
		strbuf = (char*)prealloc( (char*)strbuf, ( len + MALLOC_STEP + 2 )
			* sizeof( char ) );

	strbuf[len] = ch;
	strbuf[len+1] = '\0';
	strbuf[len+2] = '\0';
}


/* Create a new string */
static void reset_strbuf( void )
{
	if( strbuf )
	{
		*strbuf = '\0';
		*(strbuf+1) = '\0';
	}
}


/* Set precedence and associativiy */
static void set_assoc_and_prec( LIST* symbols, int assoc )
{
	LIST* l;
	SYMBOL* sym;

	for( l = symbols; l; l = l->next )
	{
		sym = l->pptr;
		sym->prec = prec_cnt;
		sym->assoc = assoc;
	}

	list_free( symbols );
	prec_cnt++;
}


static void make_semantic_rhs( PROD* p )
{
	if( current_prod && current_prod->rhs )
		plist_concat( p->sem_rhs, current_prod->rhs );

	plist_concat( p->sem_rhs, p->rhs );
}

static OPT* set_option( plist* opts, char* key, char* val, int line )
{
	OPT*		opt;

	if( !( opt = create_opt( opts, key, (char*)NULL ) ) )
		OUTOFMEM;

	opt->def = val;
	opt->line = line;

	return opt;
}

static void parse_error();


#endif

/* Include parser control block definitions */
#include "parse.h"

/* Action Table */
UNICC_STATIC int _act[ 165 ][ 27 * 3 + 1 ] =
{
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 26, 69,3,429 , 68,3,417 , 67,3,413 , 66,3,401 , 65,3,397 , 64,3,385 , 63,3,381 , 62,3,369 , 61,3,365 , 60,3,353 , 59,3,349 , 58,3,337 , 57,3,333 , 56,3,321 , 55,3,317 , 54,3,309 , 53,3,305 , 52,3,295 , 51,3,291 , 50,3,281 , 49,3,275 , 48,3,263 , 47,3,259 , 46,3,244 , 45,3,247 , 44,3,430  },
	{ 26, 69,3,427 , 68,3,419 , 67,3,411 , 66,3,403 , 65,3,395 , 64,3,387 , 63,3,379 , 62,3,371 , 61,3,363 , 60,3,355 , 59,3,347 , 58,3,339 , 57,3,331 , 56,3,323 , 55,3,315 , 54,3,311 , 53,3,303 , 52,3,299 , 51,3,450 , 50,3,287 , 49,3,449 , 48,3,269 , 47,3,445 , 45,3,253 , 44,3,439 , 43,3,440  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 1, 42,2,12  },
	{ 26, 69,3,429 , 68,3,417 , 67,3,413 , 66,3,401 , 65,3,397 , 64,3,385 , 63,3,381 , 62,3,369 , 61,3,365 , 60,3,353 , 59,3,349 , 58,3,337 , 57,3,333 , 56,3,321 , 55,3,317 , 54,3,309 , 53,3,305 , 52,3,295 , 51,3,291 , 50,3,281 , 49,3,275 , 48,3,263 , 47,3,259 , 46,3,244 , 45,3,247 , 44,3,430  },
	{ 1, 2,3,160  },
	{ 26, 69,3,427 , 68,3,419 , 67,3,411 , 66,3,403 , 65,3,395 , 64,3,387 , 63,3,379 , 62,3,371 , 61,3,363 , 60,3,355 , 59,3,347 , 58,3,339 , 57,3,331 , 56,3,323 , 55,3,315 , 54,3,311 , 53,3,303 , 52,3,299 , 51,3,450 , 50,3,287 , 49,3,449 , 48,3,269 , 47,3,445 , 45,3,253 , 44,3,439 , 43,3,440  },
	{ 1, 46,3,163  },
	{ 1, 0,3,174  },
	{ 1, 42,2,12  },
	{ 4, 68,2,19 , 66,2,21 , 50,3,142 , 4,3,153  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 2, 41,2,27 , 39,2,28  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 4, 68,2,19 , 66,2,21 , 50,3,142 , 4,3,153  },
	{ 1, 69,2,31  },
	{ 1, 69,2,31  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 1, 65,2,33  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 0 },
	{ 26, 69,3,429 , 68,3,417 , 67,3,413 , 66,3,401 , 65,3,397 , 64,3,385 , 63,3,381 , 62,3,369 , 61,3,365 , 60,3,353 , 59,3,349 , 58,3,337 , 57,3,333 , 56,3,321 , 55,3,317 , 54,3,309 , 53,3,305 , 52,3,295 , 51,3,291 , 50,3,281 , 49,3,275 , 48,3,263 , 47,3,259 , 46,3,244 , 45,3,247 , 44,3,430  },
	{ 17, 32,2,37 , 31,2,38 , 30,2,39 , 29,2,40 , 28,2,41 , 27,2,42 , 26,2,43 , 25,2,44 , 24,2,45 , 23,2,46 , 22,2,47 , 21,2,48 , 20,2,49 , 19,2,50 , 18,2,51 , 17,2,52 , 16,2,53  },
	{ 1, 50,3,142  },
	{ 1, 69,2,31  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 38,2,72 , 37,2,73 , 36,2,74 , 35,2,75 , 34,2,76 , 33,2,77  },
	{ 3, 55,2,81 , 53,2,82 , 50,3,142  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 1, 50,3,142  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 2, 50,3,280 , 49,3,279  },
	{ 1, 5,3,152  },
	{ 26, 69,3,429 , 68,3,417 , 67,3,413 , 66,3,401 , 65,3,397 , 64,3,385 , 63,3,381 , 62,3,369 , 61,3,365 , 60,3,353 , 59,3,349 , 58,3,337 , 57,3,333 , 56,3,321 , 55,3,317 , 54,3,309 , 53,3,305 , 52,3,295 , 51,3,291 , 50,3,281 , 49,3,275 , 48,3,263 , 47,3,259 , 46,3,244 , 45,3,247 , 44,3,430  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 0 },
	{ 6, 66,2,89 , 56,2,90 , 55,2,81 , 53,2,82 , 52,2,91 , 50,3,142  },
	{ 6, 66,2,89 , 56,2,90 , 55,2,81 , 53,2,82 , 52,2,91 , 50,3,142  },
	{ 6, 66,2,89 , 56,2,90 , 55,2,81 , 53,2,82 , 52,2,91 , 50,3,142  },
	{ 6, 66,2,89 , 56,2,90 , 55,2,81 , 53,2,82 , 52,2,91 , 50,3,142  },
	{ 6, 66,2,89 , 56,2,90 , 55,2,81 , 53,2,82 , 52,2,91 , 50,3,142  },
	{ 6, 66,2,89 , 56,2,90 , 55,2,81 , 53,2,82 , 52,2,91 , 50,3,142  },
	{ 2, 55,2,81 , 53,2,82  },
	{ 1, 4,3,153  },
	{ 1, 4,3,153  },
	{ 1, 52,2,91  },
	{ 2, 15,2,98 , 14,2,99  },
	{ 2, 15,2,98 , 14,2,99  },
	{ 2, 15,2,98 , 14,2,99  },
	{ 1, 4,3,153  },
	{ 1, 4,3,153  },
	{ 1, 4,3,153  },
	{ 2, 52,2,91 , 50,3,142  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 2, 55,2,81 , 53,2,82  },
	{ 0 },
	{ 0 },
	{ 1, 50,3,142  },
	{ 1, 52,2,91  },
	{ 1, 40,2,104  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 7, 66,2,89 , 56,2,90 , 55,2,81 , 53,2,82 , 52,2,91 , 50,3,142 , 69,1,26  },
	{ 1, 50,3,142  },
	{ 1, 55,2,81  },
	{ 0 },
	{ 1, 62,2,107  },
	{ 7, 66,2,89 , 56,2,90 , 55,2,81 , 53,2,82 , 52,2,91 , 50,3,142 , 69,1,27  },
	{ 7, 66,2,89 , 56,2,90 , 55,2,81 , 53,2,82 , 52,2,91 , 50,3,142 , 69,1,28  },
	{ 7, 66,2,89 , 56,2,90 , 55,2,81 , 53,2,82 , 52,2,91 , 50,3,142 , 69,1,29  },
	{ 7, 66,2,89 , 56,2,90 , 55,2,81 , 53,2,82 , 52,2,91 , 50,3,142 , 69,1,30  },
	{ 7, 66,2,89 , 56,2,90 , 55,2,81 , 53,2,82 , 52,2,91 , 50,3,142 , 69,1,31  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 5, 62,2,107 , 57,2,114 , 56,2,90 , 55,2,81 , 53,2,82  },
	{ 27, 69,3,480 , 68,3,423 , 67,3,479 , 66,3,407 , 65,3,475 , 64,3,391 , 63,3,471 , 62,3,375 , 61,3,467 , 60,3,359 , 59,3,463 , 58,3,343 , 57,3,459 , 56,3,327 , 55,3,127 , 54,2,116 , 53,3,307 , 52,3,453 , 51,3,293 , 50,3,451 , 49,3,277 , 48,3,447 , 47,3,261 , 46,3,246 , 45,3,443 , 44,3,439 , 43,3,440  },
	{ 27, 69,3,431 , 68,3,481 , 67,3,415 , 66,3,477 , 65,3,399 , 64,3,473 , 63,3,383 , 62,3,469 , 61,3,367 , 60,3,465 , 59,3,351 , 58,3,461 , 57,3,335 , 56,3,457 , 55,3,319 , 54,2,117 , 53,3,132 , 52,3,297 , 51,3,289 , 50,3,283 , 49,3,273 , 48,3,265 , 47,3,257 , 46,3,242 , 45,3,249 , 44,3,441 , 43,3,482  },
	{ 4, 13,2,119 , 67,2,120 , 12,2,121 , 11,2,122  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 5, 15,2,98 , 14,2,99 , 55,2,81 , 53,2,82 , 4,3,153  },
	{ 27, 69,3,425 , 68,3,421 , 67,3,409 , 66,3,405 , 65,3,393 , 64,3,389 , 63,3,377 , 62,3,373 , 61,3,361 , 60,3,357 , 59,3,345 , 58,3,341 , 57,3,329 , 56,3,325 , 55,3,456 , 54,3,313 , 53,3,455 , 52,3,301 , 51,3,137 , 50,3,285 , 49,3,271 , 48,3,267 , 47,3,255 , 46,3,240 , 45,3,251 , 44,3,439 , 43,3,440  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 0 },
	{ 1, 4,3,153  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 1, 64,2,125  },
	{ 5, 62,2,107 , 57,2,114 , 56,2,90 , 55,2,81 , 53,2,82  },
	{ 3, 60,2,127 , 59,2,128 , 58,2,129  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 5, 62,2,107 , 57,2,114 , 56,2,90 , 55,2,81 , 53,2,82  },
	{ 26, 69,3,429 , 68,3,417 , 67,3,413 , 66,3,401 , 65,3,397 , 64,3,385 , 63,3,381 , 62,3,369 , 61,3,365 , 60,3,353 , 59,3,349 , 58,3,337 , 57,3,333 , 56,3,321 , 55,3,317 , 54,3,309 , 53,3,305 , 52,3,295 , 51,3,291 , 50,3,281 , 49,3,275 , 48,3,263 , 47,3,259 , 46,3,244 , 45,3,247 , 44,3,430  },
	{ 26, 69,3,429 , 68,3,417 , 67,3,413 , 66,3,401 , 65,3,397 , 64,3,385 , 63,3,381 , 62,3,369 , 61,3,365 , 60,3,353 , 59,3,349 , 58,3,337 , 57,3,333 , 56,3,321 , 55,3,317 , 54,3,309 , 53,3,305 , 52,3,295 , 51,3,291 , 50,3,281 , 49,3,275 , 48,3,263 , 47,3,259 , 46,3,244 , 45,3,247 , 44,3,430  },
	{ 0 },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 0 },
	{ 1, 63,2,135  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 5, 62,2,107 , 57,2,114 , 56,2,90 , 55,2,81 , 53,2,82  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 1, 61,2,138  },
	{ 14, 66,2,89 , 7,2,143 , 6,2,144 , 56,2,90 , 55,2,81 , 53,2,82 , 52,2,91 , 50,3,142 , 4,1,85 , 63,1,85 , 68,1,85 , 69,1,85 , 64,1,85 , 61,1,85  },
	{ 1, 64,2,125  },
	{ 2, 64,2,125 , 61,2,138  },
	{ 1, 68,2,19  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 3, 55,2,81 , 53,2,82 , 50,3,142  },
	{ 5, 62,2,107 , 57,2,114 , 56,2,90 , 55,2,81 , 53,2,82  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 3, 60,3,100 , 59,3,101 , 58,3,102  },
	{ 1, 4,3,153  },
	{ 14, 66,2,89 , 7,2,143 , 6,2,144 , 56,2,90 , 55,2,81 , 53,2,82 , 52,2,91 , 50,3,142 , 4,1,84 , 63,1,84 , 68,1,84 , 69,1,84 , 64,1,84 , 61,1,84  },
	{ 1, 67,2,120  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 0 },
	{ 1, 68,2,19  },
	{ 3, 16,2,53 , 10,2,153 , 9,2,154  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 1, 63,2,135  },
	{ 1, 67,2,120  },
	{ 3, 55,2,81 , 53,2,82 , 50,3,142  },
	{ 0 },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 1, 68,2,19  },
	{ 1, 40,2,104  },
	{ 1, 68,2,19  },
	{ 2, 16,2,53 , 8,2,161  },
	{ 5, 15,2,98 , 14,2,99 , 55,2,81 , 53,2,82 , 4,3,153  },
	{ 0 },
	{ 6, 48,3,158 , 47,3,159 , 3,2,1 , 1,2,2 , 46,3,167 , 45,3,166  },
	{ 4, 66,2,89 , 56,2,90 , 55,2,81 , 53,2,82  },
	{ 1, 40,2,104  },
	{ 5, 15,2,98 , 14,2,99 , 55,2,81 , 53,2,82 , 4,3,153  }
};

/* GoTo Table */
UNICC_STATIC int _go[ 165 ][ 28 * 3 + 1 ] =
{
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,2,4  },
	{ 28, 267,3,170 , 254,3,169 , 253,2,5 , 252,2,6 , 183,3,243 , 181,3,248 , 175,3,260 , 173,3,264 , 167,3,276 , 165,3,282 , 160,3,292 , 158,3,296 , 153,3,306 , 151,3,310 , 147,3,318 , 145,3,322 , 139,3,334 , 137,3,338 , 131,3,350 , 129,3,354 , 123,3,366 , 121,3,370 , 115,3,382 , 113,3,386 , 107,3,398 , 105,3,402 , 99,3,414 , 97,3,418  },
	{ 27, 251,2,7 , 250,2,8 , 249,3,172 , 178,3,254 , 170,3,270 , 162,3,288 , 156,3,300 , 154,3,304 , 150,3,312 , 148,3,316 , 144,3,324 , 140,3,332 , 136,3,340 , 132,3,348 , 128,3,356 , 124,3,364 , 120,3,372 , 116,3,380 , 112,3,388 , 108,3,396 , 104,3,404 , 100,3,412 , 96,3,420 , 92,3,428 , 90,3,433 , 89,3,434 , 84,3,446  },
	{ 2, 330,3,175 , 247,3,176  },
	{ 6, 248,3,238 , 322,2,9 , 321,3,1 , 320,2,10 , 319,2,11 , 195,2,13  },
	{ 26, 267,3,170 , 254,3,168 , 183,3,243 , 181,3,248 , 175,3,260 , 173,3,264 , 167,3,276 , 165,3,282 , 160,3,292 , 158,3,296 , 153,3,306 , 151,3,310 , 147,3,318 , 145,3,322 , 139,3,334 , 137,3,338 , 131,3,350 , 129,3,354 , 123,3,366 , 121,3,370 , 115,3,382 , 113,3,386 , 107,3,398 , 105,3,402 , 99,3,414 , 97,3,418  },
	{ 0 },
	{ 25, 249,3,171 , 178,3,254 , 170,3,270 , 162,3,288 , 156,3,300 , 154,3,304 , 150,3,312 , 148,3,316 , 144,3,324 , 140,3,332 , 136,3,340 , 132,3,348 , 128,3,356 , 124,3,364 , 120,3,372 , 116,3,380 , 112,3,388 , 108,3,396 , 104,3,404 , 100,3,412 , 96,3,420 , 92,3,428 , 90,3,433 , 89,3,434 , 84,3,446  },
	{ 0 },
	{ 0 },
	{ 2, 321,3,0 , 195,2,13  },
	{ 14, 328,2,14 , 326,2,15 , 318,3,6 , 317,2,16 , 316,3,4 , 312,2,17 , 311,2,18 , 300,2,20 , 261,2,22 , 257,2,23 , 244,3,18 , 242,2,24 , 217,3,51 , 207,2,25  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,229  },
	{ 3, 315,2,26 , 194,2,29 , 193,2,30  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,207  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,180  },
	{ 12, 328,2,14 , 326,2,15 , 318,3,5 , 312,2,17 , 311,2,18 , 300,2,20 , 261,2,22 , 257,2,23 , 244,3,18 , 242,2,24 , 217,3,51 , 207,2,25  },
	{ 1, 243,3,19  },
	{ 1, 243,3,20  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,182  },
	{ 2, 295,2,32 , 196,3,72  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,217  },
	{ 1, 260,2,34  },
	{ 28, 267,3,170 , 256,2,35 , 255,2,36 , 254,3,157 , 183,3,243 , 181,3,248 , 175,3,260 , 173,3,264 , 167,3,276 , 165,3,282 , 160,3,292 , 158,3,296 , 153,3,306 , 151,3,310 , 147,3,318 , 145,3,322 , 139,3,334 , 137,3,338 , 131,3,350 , 129,3,354 , 123,3,366 , 121,3,370 , 115,3,382 , 113,3,386 , 107,3,398 , 105,3,402 , 99,3,414 , 97,3,418  },
	{ 19, 310,3,21 , 303,2,54 , 241,2,55 , 240,2,56 , 239,2,57 , 238,2,58 , 237,2,59 , 236,2,60 , 235,2,61 , 234,2,62 , 233,2,63 , 232,2,64 , 230,2,65 , 229,2,66 , 228,2,67 , 227,2,68 , 226,2,69 , 225,2,70 , 221,3,42  },
	{ 5, 328,2,14 , 298,2,71 , 297,3,55 , 261,2,22 , 217,3,56  },
	{ 1, 243,3,9  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,230  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,231  },
	{ 7, 314,3,10 , 192,3,12 , 191,3,13 , 190,3,14 , 189,3,15 , 188,3,16 , 187,3,17  },
	{ 11, 328,2,14 , 325,2,78 , 324,2,79 , 313,3,11 , 308,3,145 , 276,3,121 , 271,2,80 , 261,2,22 , 220,3,123 , 219,3,124 , 217,3,146  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,181  },
	{ 6, 328,2,14 , 300,3,53 , 299,2,83 , 294,2,84 , 261,2,22 , 217,3,51  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,228  },
	{ 1, 259,3,143  },
	{ 0 },
	{ 26, 267,3,170 , 254,3,156 , 183,3,243 , 181,3,248 , 175,3,260 , 173,3,264 , 167,3,276 , 165,3,282 , 160,3,292 , 158,3,296 , 153,3,306 , 151,3,310 , 147,3,318 , 145,3,322 , 139,3,334 , 137,3,338 , 131,3,350 , 129,3,354 , 123,3,366 , 121,3,370 , 115,3,382 , 113,3,386 , 107,3,398 , 105,3,402 , 99,3,414 , 97,3,418  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,183  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,184  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,185  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,186  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,187  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,188  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,189  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,190  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,191  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,192  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,194  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,195  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,196  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,197  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,198  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,199  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,203  },
	{ 1, 302,2,85  },
	{ 12, 329,2,86 , 328,2,14 , 325,3,125 , 324,3,98 , 323,2,87 , 306,2,88 , 301,3,50 , 277,3,97 , 261,2,22 , 231,2,92 , 218,3,93 , 217,3,94  },
	{ 12, 329,2,86 , 328,2,14 , 325,3,125 , 324,3,98 , 323,2,87 , 306,2,93 , 301,3,50 , 277,3,97 , 261,2,22 , 231,2,92 , 218,3,93 , 217,3,94  },
	{ 12, 329,2,86 , 328,2,14 , 325,3,125 , 324,3,98 , 323,2,87 , 306,2,94 , 301,3,50 , 277,3,97 , 261,2,22 , 231,2,92 , 218,3,93 , 217,3,94  },
	{ 12, 329,2,86 , 328,2,14 , 325,3,125 , 324,3,98 , 323,2,87 , 306,2,95 , 301,3,50 , 277,3,97 , 261,2,22 , 231,2,92 , 218,3,93 , 217,3,94  },
	{ 12, 329,2,86 , 328,2,14 , 325,3,125 , 324,3,98 , 323,2,87 , 306,2,96 , 301,3,50 , 277,3,97 , 261,2,22 , 231,2,92 , 218,3,93 , 217,3,94  },
	{ 12, 329,2,86 , 328,2,14 , 325,3,125 , 324,3,98 , 323,2,87 , 306,2,97 , 301,3,50 , 277,3,97 , 261,2,22 , 231,2,92 , 218,3,93 , 217,3,94  },
	{ 7, 325,2,78 , 324,2,79 , 308,3,32 , 276,3,121 , 271,2,80 , 220,3,123 , 219,3,124  },
	{ 4, 326,2,15 , 305,3,33 , 257,2,23 , 244,3,150  },
	{ 4, 326,2,15 , 305,3,34 , 257,2,23 , 244,3,150  },
	{ 2, 323,2,87 , 231,3,35  },
	{ 4, 307,3,45 , 304,3,36 , 223,3,47 , 222,3,48  },
	{ 4, 307,3,45 , 304,3,37 , 223,3,47 , 222,3,48  },
	{ 4, 307,3,45 , 304,3,38 , 223,3,47 , 222,3,48  },
	{ 3, 326,2,15 , 257,2,23 , 244,3,39  },
	{ 3, 326,2,15 , 257,2,23 , 244,3,40  },
	{ 3, 326,2,15 , 257,2,23 , 244,3,41  },
	{ 6, 328,2,14 , 323,2,87 , 297,3,54 , 261,2,22 , 231,2,100 , 217,3,56  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,232  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,233  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,234  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,235  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,236  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,237  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,204  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,205  },
	{ 5, 325,2,78 , 324,2,79 , 276,3,120 , 220,3,123 , 219,3,124  },
	{ 1, 270,2,101  },
	{ 1, 266,2,102  },
	{ 4, 328,2,14 , 300,3,52 , 261,2,22 , 217,3,51  },
	{ 2, 323,2,87 , 231,2,103  },
	{ 1, 224,2,105  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,206  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,193  },
	{ 11, 329,2,86 , 328,2,14 , 325,3,125 , 324,3,98 , 323,2,87 , 301,3,49 , 277,3,97 , 261,2,22 , 231,2,92 , 218,3,93 , 217,3,94  },
	{ 2, 328,3,99 , 261,2,22  },
	{ 1, 325,3,126  },
	{ 1, 263,2,106  },
	{ 1, 216,2,108  },
	{ 11, 329,2,86 , 328,2,14 , 325,3,125 , 324,3,98 , 323,2,87 , 301,3,49 , 277,3,97 , 261,2,22 , 231,2,92 , 218,3,93 , 217,3,94  },
	{ 11, 329,2,86 , 328,2,14 , 325,3,125 , 324,3,98 , 323,2,87 , 301,3,49 , 277,3,97 , 261,2,22 , 231,2,92 , 218,3,93 , 217,3,94  },
	{ 11, 329,2,86 , 328,2,14 , 325,3,125 , 324,3,98 , 323,2,87 , 301,3,49 , 277,3,97 , 261,2,22 , 231,2,92 , 218,3,93 , 217,3,94  },
	{ 11, 329,2,86 , 328,2,14 , 325,3,125 , 324,3,98 , 323,2,87 , 301,3,49 , 277,3,97 , 261,2,22 , 231,2,92 , 218,3,93 , 217,3,94  },
	{ 11, 329,2,86 , 328,2,14 , 325,3,125 , 324,3,98 , 323,2,87 , 301,3,49 , 277,3,97 , 261,2,22 , 231,2,92 , 218,3,93 , 217,3,94  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,201  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,202  },
	{ 12, 325,3,125 , 324,2,79 , 292,2,109 , 277,2,110 , 275,2,111 , 274,2,112 , 273,3,111 , 272,2,113 , 219,3,117 , 216,2,115 , 201,3,116 , 200,3,118  },
	{ 25, 269,3,128 , 268,3,130 , 182,3,245 , 174,3,262 , 166,3,278 , 159,3,294 , 152,3,308 , 142,3,328 , 134,3,344 , 126,3,360 , 118,3,376 , 110,3,392 , 102,3,408 , 94,3,424 , 90,3,437 , 87,3,438 , 85,3,444 , 83,3,448 , 82,3,452 , 81,3,454 , 79,3,460 , 77,3,464 , 75,3,468 , 73,3,472 , 71,3,476  },
	{ 25, 265,3,133 , 264,3,135 , 184,3,241 , 180,3,250 , 176,3,258 , 172,3,266 , 168,3,274 , 164,3,284 , 161,3,290 , 157,3,298 , 146,3,320 , 138,3,336 , 130,3,352 , 122,3,368 , 114,3,384 , 106,3,400 , 98,3,416 , 91,3,432 , 86,3,442 , 80,3,458 , 78,3,462 , 76,3,466 , 74,3,470 , 72,3,474 , 70,3,478  },
	{ 5, 296,2,118 , 211,3,58 , 199,3,57 , 198,3,59 , 197,3,60  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,200  },
	{ 14, 326,2,15 , 325,2,78 , 324,2,79 , 309,3,44 , 308,3,23 , 307,3,24 , 276,3,121 , 271,2,80 , 257,2,23 , 244,3,22 , 223,3,47 , 222,3,48 , 220,3,123 , 219,3,124  },
	{ 25, 262,3,139 , 185,3,239 , 179,3,252 , 177,3,256 , 171,3,268 , 169,3,272 , 163,3,286 , 155,3,302 , 149,3,314 , 143,3,326 , 141,3,330 , 135,3,342 , 133,3,346 , 127,3,358 , 125,3,362 , 119,3,374 , 117,3,378 , 111,3,390 , 109,3,394 , 103,3,406 , 101,3,410 , 95,3,422 , 93,3,426 , 90,3,435 , 88,3,436  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,208  },
	{ 1, 278,2,123  },
	{ 4, 326,2,15 , 305,2,124 , 257,2,23 , 244,3,150  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,223  },
	{ 1, 214,2,126  },
	{ 9, 325,3,125 , 324,2,79 , 277,2,110 , 273,3,110 , 272,2,113 , 219,3,117 , 216,2,115 , 201,3,116 , 200,3,118  },
	{ 3, 202,3,114 , 204,3,112 , 203,3,113  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,224  },
	{ 12, 325,3,125 , 324,2,79 , 292,2,130 , 277,2,110 , 275,2,111 , 274,2,112 , 273,3,111 , 272,2,113 , 219,3,117 , 216,2,115 , 201,3,116 , 200,3,118  },
	{ 25, 267,3,131 , 183,3,243 , 181,3,248 , 175,3,260 , 173,3,264 , 167,3,276 , 165,3,282 , 160,3,292 , 158,3,296 , 153,3,306 , 151,3,310 , 147,3,318 , 145,3,322 , 139,3,334 , 137,3,338 , 131,3,350 , 129,3,354 , 123,3,366 , 121,3,370 , 115,3,382 , 113,3,386 , 107,3,398 , 105,3,402 , 99,3,414 , 97,3,418  },
	{ 25, 267,3,136 , 183,3,243 , 181,3,248 , 175,3,260 , 173,3,264 , 167,3,276 , 165,3,282 , 160,3,292 , 158,3,296 , 153,3,306 , 151,3,310 , 147,3,318 , 145,3,322 , 139,3,334 , 137,3,338 , 131,3,350 , 129,3,354 , 123,3,366 , 121,3,370 , 115,3,382 , 113,3,386 , 107,3,398 , 105,3,402 , 99,3,414 , 97,3,418  },
	{ 3, 302,2,131 , 293,2,132 , 287,3,75  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,225  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,213  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,226  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,227  },
	{ 3, 302,2,131 , 293,2,133 , 287,3,75  },
	{ 2, 291,2,134 , 212,2,136  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,210  },
	{ 10, 325,3,125 , 324,2,79 , 277,2,110 , 274,2,137 , 273,3,111 , 272,2,113 , 219,3,117 , 216,2,115 , 201,3,116 , 200,3,118  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,220  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,221  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,222  },
	{ 1, 215,3,119  },
	{ 16, 329,2,86 , 328,2,14 , 325,3,125 , 324,3,98 , 323,2,87 , 301,2,139 , 286,2,140 , 281,2,141 , 280,2,142 , 277,3,97 , 261,2,22 , 231,2,92 , 218,3,93 , 217,3,94 , 209,3,91 , 208,3,92  },
	{ 1, 214,2,145  },
	{ 2, 215,3,95 , 214,2,145  },
	{ 4, 290,3,66 , 289,2,146 , 288,3,64 , 242,2,147  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,212  },
	{ 10, 328,2,14 , 325,2,78 , 324,2,79 , 308,3,77 , 276,3,121 , 271,2,80 , 261,2,22 , 220,3,123 , 219,3,124 , 217,3,76  },
	{ 9, 325,3,125 , 324,2,79 , 277,2,110 , 273,3,110 , 272,2,113 , 219,3,117 , 216,2,115 , 201,3,116 , 200,3,118  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,209  },
	{ 2, 327,2,148 , 210,3,90  },
	{ 5, 326,2,15 , 305,3,149 , 285,2,149 , 257,2,23 , 244,3,150  },
	{ 14, 329,2,86 , 328,2,14 , 325,3,125 , 324,3,98 , 323,2,87 , 301,2,139 , 280,2,150 , 277,3,97 , 261,2,22 , 231,2,92 , 218,3,93 , 217,3,94 , 209,3,91 , 208,3,92  },
	{ 2, 279,3,89 , 211,2,151  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,215  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,216  },
	{ 2, 302,2,131 , 287,3,74  },
	{ 2, 290,3,65 , 242,2,147  },
	{ 4, 303,2,152 , 221,3,42 , 206,3,69 , 205,3,70  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,214  },
	{ 2, 291,2,155 , 212,2,136  },
	{ 2, 279,3,88 , 211,2,151  },
	{ 8, 328,2,14 , 325,2,78 , 324,2,79 , 276,3,105 , 261,2,22 , 220,3,123 , 219,3,124 , 217,3,104  },
	{ 1, 302,2,156  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,218  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,219  },
	{ 4, 284,3,81 , 283,2,157 , 282,3,79 , 242,2,158  },
	{ 1, 224,2,159  },
	{ 2, 284,3,80 , 242,2,158  },
	{ 3, 303,2,160 , 221,3,42 , 213,2,162  },
	{ 14, 326,2,15 , 325,2,78 , 324,2,79 , 309,3,71 , 308,3,23 , 307,3,24 , 276,3,121 , 271,2,80 , 257,2,23 , 244,3,22 , 223,3,47 , 222,3,48 , 220,3,123 , 219,3,124  },
	{ 1, 302,2,163  },
	{ 4, 330,3,175 , 247,3,177 , 246,2,3 , 245,3,211  },
	{ 5, 329,2,86 , 325,3,125 , 324,3,98 , 277,3,97 , 218,3,86  },
	{ 1, 224,2,164  },
	{ 14, 326,2,15 , 325,2,78 , 324,2,79 , 309,3,87 , 308,3,23 , 307,3,24 , 276,3,121 , 271,2,80 , 257,2,23 , 244,3,22 , 223,3,47 , 222,3,48 , 220,3,123 , 219,3,124  }
};

/* Default productions per state */
UNICC_STATIC int _def_prod[ 165 ] =
{
	179, 162, 165, 178, 3, 161, -1, 164, -1, -1, 2, 8, 179, -1, 179, 179, 7, -1, -1, 179, 73, 179, 144, 155, 43, -1, -1, 179, 179, -1, -1, 179, 63, 179, 141, -1, 154, 179, 179, 179, 179, 179, 179, 179, 179, 179, 179, 179, 179, 179, 179, 179, 179, 179, 173, 138, 138, 138, 138, 138, 138, -1, 151, 151, 138, 46, 46, 46, -1, -1, -1, 138, 179, 179, 179, 179, 179, 179, 179, 179, 122, 129, 134, 62, 138, -1, 179, 179, 138, -1, -1, 140, -1, 138, 138, 138, 138, 138, 179, 179, -1, -1, -1, -1, 179, 25, -1, 179, 96, 151, 179, 107, 109, 115, 179, -1, -1, -1, 173, 179, 179, 179, 179, 173, 78, 179, -1, 179, 179, 179, -1, 138, 61, -1, 68, 179, -1, 108, 179, 103, 151, 138, 106, 179, 179, 173, 67, 43, 179, 78, 106, -1, 173, 179, 179, 83, -1, 82, 43, 25, 173, 179, -1, -1, 25
};

#if !0
/* DFA selection table */
UNICC_STATIC int _dfa_select[ 165 ] =
{
	0, 1, 2, 3, 4, 1, 5, 2, 6, -1, 4, 7, 8, 9, 10, 11, 7, 12, 12, 13, 14, 15, 16, 17, 18, 19, 12, 20, 21, 22, 23, 0, 24, 24, 16, 25, 17, 26, 26, 26, 26, 26, 26, 27, 28, 28, 29, 30, 30, 30, 31, 31, 31, 32, 33, 26, 26, 26, 26, 26, 26, 34, 35, 35, 29, 36, 36, 36, 37, 37, 37, 38, 39, 39, 39, 39, 39, 39, 40, 41, 42, 2, 2, 24, 43, 33, 44, 45, 46, 19, 47, 2, 48, 46, 46, 46, 46, 46, 49, 49, 50, 2, 2, 51, 52, 53, 2, 54, 55, 56, 57, 58, 59, 60, 57, 50, 61, 61, 62, 62, 62, 62, 62, 55, 63, 64, 50, 65, 65, 65, 66, 40, 67, 68, 69, 21, 23, 59, 70, 44, 58, 40, 71, 71, 71, 40, 69, 72, 71, 73, 71, 23, 33, 74, 74, 75, 33, 75, 76, 77, 33, 78, 79, 33, 80
};
#endif

#if 81
/* DFA index table */
UNICC_STATIC int _dfa_idx[ 81 ][ 276 ] =
{
	{ 0 * 2, 12 * 2, 13 * 2, 14 * 2, 15 * 2, 16 * 2, 18 * 2, 19 * 2, 20 * 2, 21 * 2, 22 * 2, 23 * 2, 24 * 2, 27 * 2 },
	{ 29 * 2, 68 * 2, 69 * 2, 70 * 2, 71 * 2, 72 * 2, 73 * 2, 74 * 2, 75 * 2, 76 * 2, 77 * 2, 78 * 2, 79 * 2, 81 * 2, 82 * 2, 83 * 2, 84 * 2, 85 * 2, 86 * 2, 87 * 2, 88 * 2, 89 * 2, 90 * 2, 91 * 2, 92 * 2, 93 * 2, 94 * 2, 95 * 2 },
	{ 96 * 2, 136 * 2, 137 * 2, 138 * 2, 139 * 2, 140 * 2, 141 * 2, 142 * 2, 143 * 2, 144 * 2, 145 * 2, 146 * 2, 147 * 2, 148 * 2, 149 * 2, 150 * 2, 151 * 2, 152 * 2, 153 * 2, 154 * 2, 155 * 2, 156 * 2, 157 * 2, 158 * 2, 159 * 2, 160 * 2, 161 * 2, 162 * 2 },
	{ 163 * 2, 222 * 2, 223 * 2, 224 * 2, 225 * 2, 226 * 2, 227 * 2, 228 * 2, 237 * 2, 238 * 2, 239 * 2, 240 * 2, 248 * 2, 249 * 2, 250 * 2, 258 * 2, 266 * 2, 274 * 2, 282 * 2, 290 * 2, 298 * 2, 306 * 2, 314 * 2, 322 * 2, 330 * 2, 338 * 2, 346 * 2, 355 * 2, 363 * 2, 371 * 2, 381 * 2, 389 * 2, 397 * 2, 405 * 2, 413 * 2, 421 * 2, 429 * 2, 437 * 2, 445 * 2, 453 * 2, 461 * 2, 462 * 2, 470 * 2, 471 * 2, 472 * 2, 473 * 2, 481 * 2, 482 * 2, 483 * 2, 486 * 2, 494 * 2, 496 * 2, 506 * 2, 508 * 2, 518 * 2, 520 * 2, 530 * 2, 532 * 2, 542 * 2, 546 * 2, 556 * 2, 558 * 2, 570 * 2, 572 * 2, 582 * 2, 584 * 2, 594 * 2, 596 * 2, 606 * 2, 608 * 2, 618 * 2, 620 * 2, 632 * 2, 634 * 2, 644 * 2, 646 * 2, 656 * 2, 658 * 2, 672 * 2, 674 * 2, 686 * 2, 688 * 2, 700 * 2, 702 * 2, 714 * 2, 716 * 2, 726 * 2, 728 * 2, 740 * 2, 742 * 2, 752 * 2, 754 * 2, 764 * 2, 766 * 2, 776 * 2, 778 * 2, 790 * 2, 792 * 2, 802 * 2, 812 * 2, 822 * 2, 832 * 2, 844 * 2, 854 * 2, 864 * 2, 874 * 2, 884 * 2, 894 * 2, 904 * 2, 914 * 2, 924 * 2, 934 * 2, 946 * 2, 958 * 2, 968 * 2, 978 * 2, 987 * 2, 997 * 2, 1007 * 2, 1017 * 2, 1027 * 2, 1037 * 2, 1047 * 2, 1057 * 2, 1067 * 2, 1077 * 2, 1087 * 2, 1097 * 2, 1107 * 2, 1117 * 2, 1127 * 2, 1136 * 2, 1146 * 2, 1155 * 2, 1167 * 2, 1177 * 2, 1187 * 2, 1189 * 2, 1199 * 2, 1201 * 2, 1203 * 2, 1205 * 2, 1215 * 2, 1225 * 2, 1227 * 2, 1237 * 2, 1247 * 2, 1249 * 2, 1251 * 2, 1253 * 2, 1255 * 2, 1265 * 2, 1275 * 2, 1285 * 2, 1295 * 2, 1305 * 2, 1315 * 2, 1325 * 2, 1335 * 2, 1337 * 2, 1347 * 2, 1349 * 2, 1351 * 2, 1353 * 2, 1363 * 2, 1365 * 2, 1375 * 2, 1385 * 2, 1387 * 2, 1389 * 2, 1399 * 2, 1409 * 2, 1419 * 2, 1429 * 2, 1431 * 2, 1441 * 2, 1443 * 2, 1445 * 2, 1447 * 2, 1457 * 2, 1459 * 2, 1469 * 2, 1479 * 2, 1489 * 2, 1499 * 2, 1501 * 2, 1511 * 2, 1513 * 2, 1515 * 2, 1517 * 2, 1527 * 2, 1537 * 2, 1547 * 2, 1557 * 2, 1559 * 2, 1561 * 2, 1571 * 2, 1581 * 2, 1583 * 2, 1585 * 2, 1595 * 2, 1597 * 2, 1599 * 2, 1609 * 2, 1611 * 2, 1613 * 2, 1615 * 2, 1625 * 2, 1635 * 2, 1637 * 2, 1647 * 2, 1657 * 2, 1667 * 2, 1669 * 2, 1671 * 2, 1681 * 2, 1691 * 2, 1693 * 2, 1703 * 2, 1713 * 2, 1723 * 2, 1733 * 2, 1743 * 2, 1753 * 2, 1763 * 2, 1773 * 2, 1783 * 2, 1793 * 2, 1803 * 2, 1813 * 2, 1823 * 2, 1833 * 2, 1843 * 2, 1845 * 2, 1855 * 2, 1865 * 2, 1875 * 2, 1885 * 2, 1895 * 2, 1905 * 2, 1907 * 2, 1917 * 2, 1919 * 2, 1929 * 2, 1939 * 2, 1949 * 2, 1959 * 2, 1969 * 2, 1979 * 2, 1989 * 2, 1999 * 2, 2001 * 2, 2011 * 2, 2021 * 2, 2031 * 2, 2041 * 2, 2051 * 2, 2061 * 2, 2071 * 2, 2081 * 2, 2091 * 2, 2101 * 2, 2111 * 2, 2121 * 2, 2131 * 2, 2141 * 2, 2151 * 2, 2161 * 2, 2171 * 2, 2181 * 2, 2191 * 2, 2201 * 2, 2211 * 2, 2221 * 2, 2231 * 2, 2241 * 2 },
	{ 2251 * 2, 2258 * 2, 2260 * 2, 2261 * 2, 2262 * 2, 2263 * 2, 2264 * 2 },
	{ 2266 * 2, 2268 * 2, 2269 * 2 },
	{ 2271 * 2, 2273 * 2 },
	{ 2274 * 2, 2281 * 2, 2282 * 2, 2283 * 2, 2284 * 2, 2285 * 2 },
	{ 2287 * 2, 2295 * 2, 2296 * 2, 2297 * 2, 2298 * 2, 2299 * 2, 2300 * 2, 2301 * 2, 2302 * 2, 2303 * 2, 2306 * 2, 2308 * 2, 2310 * 2, 2312 * 2, 2314 * 2, 2316 * 2, 2318 * 2, 2320 * 2, 2322 * 2, 2324 * 2 },
	{ 2326 * 2, 2329 * 2, 2330 * 2, 2331 * 2, 2333 * 2, 2335 * 2, 2337 * 2, 2339 * 2, 2341 * 2, 2343 * 2, 2345 * 2, 2347 * 2, 2349 * 2 },
	{ 2351 * 2, 2380 * 2, 2381 * 2, 2382 * 2, 2383 * 2, 2384 * 2, 2385 * 2, 2386 * 2, 2387 * 2, 2388 * 2, 2389 * 2, 2390 * 2, 2391 * 2, 2392 * 2, 2393 * 2, 2394 * 2, 2396 * 2, 2397 * 2, 2398 * 2, 2400 * 2, 2401 * 2, 2402 * 2, 2403 * 2, 2404 * 2, 2405 * 2, 2406 * 2, 2407 * 2, 2408 * 2, 2409 * 2, 2410 * 2, 2411 * 2, 2412 * 2, 2414 * 2, 2416 * 2, 2419 * 2, 2421 * 2, 2424 * 2, 2426 * 2, 2428 * 2, 2430 * 2 },
	{ 2432 * 2, 2448 * 2, 2449 * 2, 2450 * 2, 2451 * 2, 2452 * 2, 2453 * 2, 2454 * 2, 2455 * 2, 2456 * 2, 2457 * 2, 2458 * 2, 2459 * 2, 2460 * 2, 2461 * 2, 2462 * 2, 2465 * 2 },
	{ 2467 * 2, 2469 * 2 },
	{ 2470 * 2, 2499 * 2, 2500 * 2, 2501 * 2, 2502 * 2, 2503 * 2, 2513 * 2, 2514 * 2, 2515 * 2, 2523 * 2, 2531 * 2, 2539 * 2, 2547 * 2, 2555 * 2, 2564 * 2, 2572 * 2, 2580 * 2, 2588 * 2, 2596 * 2, 2604 * 2, 2612 * 2, 2620 * 2, 2628 * 2, 2629 * 2, 2630 * 2, 2631 * 2, 2632 * 2, 2633 * 2, 2634 * 2, 2637 * 2, 2647 * 2, 2649 * 2, 2659 * 2, 2661 * 2, 2671 * 2, 2673 * 2, 2683 * 2, 2685 * 2, 2695 * 2, 2699 * 2, 2711 * 2, 2713 * 2, 2725 * 2, 2727 * 2, 2737 * 2, 2739 * 2, 2747 * 2, 2749 * 2, 2759 * 2, 2761 * 2, 2771 * 2, 2773 * 2, 2783 * 2, 2785 * 2, 2797 * 2, 2799 * 2, 2809 * 2, 2811 * 2, 2821 * 2, 2823 * 2, 2833 * 2, 2835 * 2, 2847 * 2, 2849 * 2, 2859 * 2, 2861 * 2, 2871 * 2, 2873 * 2, 2883 * 2, 2885 * 2, 2897 * 2, 2899 * 2, 2911 * 2, 2913 * 2, 2923 * 2, 2925 * 2, 2935 * 2, 2937 * 2, 2946 * 2, 2956 * 2, 2966 * 2, 2976 * 2, 2986 * 2, 2996 * 2, 3006 * 2, 3016 * 2, 3026 * 2, 3036 * 2, 3046 * 2, 3056 * 2, 3066 * 2, 3075 * 2, 3085 * 2, 3094 * 2, 3104 * 2, 3114 * 2, 3124 * 2, 3134 * 2, 3136 * 2, 3146 * 2, 3148 * 2, 3158 * 2, 3160 * 2, 3170 * 2, 3172 * 2, 3174 * 2, 3176 * 2, 3186 * 2, 3188 * 2, 3198 * 2, 3200 * 2, 3202 * 2, 3212 * 2, 3222 * 2, 3232 * 2, 3242 * 2, 3252 * 2, 3254 * 2, 3264 * 2, 3266 * 2, 3276 * 2, 3278 * 2, 3288 * 2, 3290 * 2, 3292 * 2, 3294 * 2, 3304 * 2, 3314 * 2, 3316 * 2, 3326 * 2, 3336 * 2, 3346 * 2, 3356 * 2, 3358 * 2, 3360 * 2, 3370 * 2, 3372 * 2, 3374 * 2, 3376 * 2, 3386 * 2, 3388 * 2, 3390 * 2, 3400 * 2, 3402 * 2, 3404 * 2, 3406 * 2, 3408 * 2, 3410 * 2, 3412 * 2, 3414 * 2, 3416 * 2, 3426 * 2, 3436 * 2, 3438 * 2, 3440 * 2, 3442 * 2, 3452 * 2, 3454 * 2, 3456 * 2, 3458 * 2, 3468 * 2, 3470 * 2, 3480 * 2, 3490 * 2, 3500 * 2, 3510 * 2, 3520 * 2, 3530 * 2, 3540 * 2, 3550 * 2, 3560 * 2, 3570 * 2, 3572 * 2, 3582 * 2, 3592 * 2, 3602 * 2, 3604 * 2, 3614 * 2, 3616 * 2, 3626 * 2, 3636 * 2, 3638 * 2, 3648 * 2, 3658 * 2 },
	{ 3668 * 2, 3682 * 2, 3683 * 2, 3684 * 2, 3685 * 2, 3686 * 2, 3687 * 2, 3689 * 2, 3690 * 2, 3691 * 2, 3692 * 2, 3693 * 2, 3694 * 2, 3695 * 2, 3696 * 2, 3698 * 2, 3701 * 2 },
	{ 3703 * 2, 3712 * 2, 3713 * 2, 3714 * 2, 3715 * 2, 3716 * 2, 3717 * 2, 3718 * 2, 3719 * 2 },
	{ 3722 * 2, 3752 * 2, 3753 * 2, 3754 * 2, 3755 * 2, 3756 * 2, 3757 * 2, 3758 * 2, 3759 * 2, 3760 * 2, 3761 * 2, 3762 * 2, 3763 * 2, 3764 * 2, 3765 * 2, 3766 * 2, 3767 * 2, 3769 * 2, 3770 * 2, 3771 * 2, 3773 * 2, 3774 * 2, 3775 * 2, 3776 * 2, 3777 * 2, 3778 * 2, 3779 * 2, 3780 * 2, 3781 * 2, 3782 * 2, 3783 * 2, 3784 * 2, 3785 * 2, 3787 * 2, 3789 * 2, 3792 * 2, 3794 * 2, 3797 * 2, 3799 * 2, 3801 * 2, 3803 * 2 },
	{ 3805 * 2, 3844 * 2, 3845 * 2, 3846 * 2, 3847 * 2, 3848 * 2, 3849 * 2, 3850 * 2, 3851 * 2, 3852 * 2, 3853 * 2, 3854 * 2, 3855 * 2, 3857 * 2, 3858 * 2, 3859 * 2, 3860 * 2, 3861 * 2, 3862 * 2, 3863 * 2, 3864 * 2, 3865 * 2, 3866 * 2, 3867 * 2, 3868 * 2, 3869 * 2, 3870 * 2, 3871 * 2 },
	{ 3872 * 2, 3895 * 2, 3905 * 2, 3913 * 2, 3921 * 2, 3929 * 2, 3937 * 2, 3946 * 2, 3954 * 2, 3962 * 2, 3970 * 2, 3978 * 2, 3986 * 2, 3994 * 2, 3995 * 2, 3996 * 2, 3997 * 2, 3998 * 2, 3999 * 2, 4000 * 2, 4002 * 2, 4012 * 2, 4014 * 2, 4024 * 2, 4026 * 2, 4036 * 2, 4038 * 2, 4048 * 2, 4052 * 2, 4064 * 2, 4066 * 2, 4078 * 2, 4080 * 2, 4090 * 2, 4092 * 2, 4100 * 2, 4102 * 2, 4112 * 2, 4114 * 2, 4124 * 2, 4126 * 2, 4136 * 2, 4138 * 2, 4150 * 2, 4152 * 2, 4162 * 2, 4164 * 2, 4174 * 2, 4176 * 2, 4186 * 2, 4188 * 2, 4200 * 2, 4202 * 2, 4212 * 2, 4214 * 2, 4224 * 2, 4226 * 2, 4236 * 2, 4238 * 2, 4248 * 2, 4250 * 2, 4260 * 2, 4262 * 2, 4272 * 2, 4274 * 2, 4283 * 2, 4285 * 2, 4295 * 2, 4305 * 2, 4315 * 2, 4325 * 2, 4335 * 2, 4345 * 2, 4355 * 2, 4365 * 2, 4375 * 2, 4385 * 2, 4395 * 2, 4404 * 2, 4414 * 2, 4423 * 2, 4433 * 2, 4443 * 2, 4445 * 2, 4455 * 2, 4457 * 2, 4467 * 2, 4469 * 2, 4479 * 2, 4489 * 2, 4491 * 2, 4493 * 2, 4495 * 2, 4497 * 2, 4507 * 2, 4509 * 2, 4511 * 2, 4521 * 2, 4531 * 2, 4541 * 2, 4543 * 2, 4553 * 2, 4555 * 2, 4565 * 2, 4567 * 2, 4577 * 2, 4587 * 2, 4589 * 2, 4591 * 2, 4593 * 2, 4595 * 2, 4605 * 2, 4615 * 2, 4617 * 2, 4627 * 2, 4629 * 2, 4631 * 2, 4641 * 2, 4651 * 2, 4653 * 2, 4655 * 2, 4665 * 2, 4667 * 2, 4677 * 2, 4679 * 2, 4681 * 2, 4691 * 2, 4693 * 2, 4703 * 2, 4705 * 2, 4707 * 2, 4717 * 2, 4719 * 2, 4721 * 2, 4731 * 2, 4741 * 2, 4751 * 2, 4761 * 2, 4771 * 2, 4773 * 2, 4775 * 2, 4785 * 2, 4787 * 2, 4789 * 2, 4791 * 2, 4801 * 2, 4811 * 2, 4813 * 2, 4815 * 2, 4817 * 2, 4819 * 2, 4821 * 2, 4831 * 2, 4833 * 2, 4835 * 2, 4837 * 2, 4847 * 2 },
	{ 4857 * 2, 4861 * 2 },
	{ 4862 * 2, 4871 * 2, 4872 * 2, 4873 * 2, 4874 * 2, 4875 * 2, 4876 * 2, 4877 * 2, 4879 * 2, 4880 * 2, 4881 * 2, 4882 * 2, 4883 * 2, 4884 * 2, 4887 * 2, 4889 * 2, 4891 * 2, 4894 * 2, 4896 * 2, 4898 * 2, 4900 * 2, 4902 * 2, 4904 * 2, 4906 * 2, 4908 * 2, 4910 * 2, 4912 * 2, 4914 * 2, 4916 * 2, 4919 * 2, 4921 * 2, 4923 * 2, 4925 * 2, 4927 * 2, 4929 * 2, 4931 * 2, 4933 * 2, 4935 * 2, 4937 * 2, 4939 * 2, 4941 * 2, 4943 * 2, 4945 * 2, 4947 * 2, 4949 * 2, 4951 * 2, 4953 * 2, 4955 * 2, 4957 * 2, 4959 * 2, 4961 * 2, 4963 * 2, 4965 * 2, 4967 * 2, 4969 * 2, 4971 * 2, 4973 * 2, 4975 * 2, 4977 * 2, 4979 * 2, 4981 * 2, 4983 * 2, 4985 * 2, 4987 * 2, 4989 * 2, 4991 * 2 },
	{ 4993 * 2, 5004 * 2, 5005 * 2, 5006 * 2, 5007 * 2, 5008 * 2, 5009 * 2, 5010 * 2, 5011 * 2, 5012 * 2, 5013 * 2 },
	{ 5016 * 2, 5020 * 2, 5022 * 2, 5023 * 2, 5024 * 2, 5025 * 2, 5026 * 2, 5027 * 2, 5029 * 2, 5031 * 2, 5034 * 2, 5036 * 2, 5038 * 2, 5040 * 2, 5042 * 2, 5044 * 2, 5046 * 2, 5048 * 2, 5050 * 2, 5052 * 2, 5054 * 2, 5056 * 2, 5059 * 2, 5061 * 2, 5063 * 2, 5065 * 2, 5067 * 2, 5069 * 2, 5071 * 2, 5073 * 2, 5075 * 2, 5077 * 2, 5079 * 2, 5081 * 2, 5083 * 2, 5085 * 2, 5087 * 2, 5089 * 2, 5091 * 2, 5093 * 2, 5095 * 2, 5097 * 2, 5099 * 2, 5101 * 2, 5103 * 2, 5105 * 2, 5107 * 2, 5109 * 2, 5111 * 2, 5113 * 2, 5115 * 2, 5117 * 2, 5119 * 2, 5121 * 2, 5123 * 2, 5125 * 2, 5127 * 2, 5129 * 2, 5131 * 2 },
	{ 5133 * 2, 5139 * 2, 5140 * 2, 5141 * 2 },
	{ 5142 * 2, 5155 * 2, 5156 * 2, 5157 * 2, 5158 * 2, 5159 * 2, 5161 * 2, 5162 * 2, 5163 * 2, 5164 * 2, 5165 * 2, 5166 * 2, 5167 * 2, 5168 * 2, 5170 * 2, 5173 * 2 },
	{ 5175 * 2, 5177 * 2, 5178 * 2 },
	{ 5180 * 2, 5195 * 2, 5196 * 2, 5197 * 2, 5198 * 2, 5199 * 2, 5200 * 2, 5201 * 2, 5202 * 2, 5203 * 2, 5204 * 2, 5205 * 2, 5206 * 2, 5207 * 2, 5208 * 2 },
	{ 5211 * 2, 5219 * 2, 5220 * 2, 5221 * 2, 5222 * 2, 5223 * 2, 5224 * 2, 5225 * 2, 5226 * 2, 5227 * 2 },
	{ 5230 * 2, 5238 * 2, 5239 * 2, 5240 * 2, 5241 * 2, 5242 * 2, 5243 * 2, 5244 * 2, 5245 * 2, 5246 * 2, 5249 * 2 },
	{ 5251 * 2, 5259 * 2, 5260 * 2, 5261 * 2, 5262 * 2, 5263 * 2, 5264 * 2, 5265 * 2, 5266 * 2, 5267 * 2 },
	{ 5270 * 2, 5278 * 2, 5279 * 2, 5280 * 2, 5281 * 2, 5282 * 2, 5283 * 2, 5284 * 2, 5285 * 2, 5286 * 2, 5287 * 2, 5290 * 2, 5293 * 2 },
	{ 5295 * 2, 5302 * 2, 5303 * 2, 5304 * 2, 5305 * 2, 5306 * 2, 5307 * 2, 5308 * 2, 5309 * 2, 5312 * 2 },
	{ 5314 * 2, 5327 * 2, 5328 * 2, 5329 * 2, 5330 * 2, 5331 * 2, 5339 * 2, 5340 * 2, 5341 * 2 },
	{ 5344 * 2, 5352 * 2 },
	{ 5360 * 2, 5363 * 2, 5364 * 2 },
	{ 5365 * 2, 5368 * 2, 5369 * 2, 5370 * 2 },
	{ 5372 * 2, 5375 * 2, 5376 * 2, 5377 * 2, 5378 * 2, 5381 * 2 },
	{ 5383 * 2, 5385 * 2, 5386 * 2 },
	{ 5388 * 2, 5403 * 2, 5404 * 2, 5405 * 2, 5406 * 2, 5407 * 2, 5408 * 2, 5409 * 2, 5410 * 2, 5411 * 2, 5412 * 2, 5413 * 2, 5414 * 2, 5415 * 2, 5416 * 2 },
	{ 5419 * 2, 5426 * 2, 5427 * 2, 5428 * 2, 5429 * 2, 5430 * 2, 5431 * 2, 5432 * 2, 5433 * 2 },
	{ 5436 * 2, 5458 * 2, 5459 * 2, 5460 * 2, 5461 * 2, 5462 * 2, 5463 * 2, 5464 * 2, 5465 * 2, 5466 * 2, 5467 * 2, 5468 * 2, 5469 * 2, 5470 * 2, 5471 * 2, 5472 * 2, 5473 * 2, 5474 * 2, 5475 * 2, 5476 * 2, 5477 * 2, 5478 * 2, 5479 * 2, 5481 * 2, 5484 * 2, 5486 * 2, 5489 * 2, 5491 * 2, 5493 * 2, 5495 * 2 },
	{ 5497 * 2, 5523 * 2, 5524 * 2, 5525 * 2, 5526 * 2, 5527 * 2, 5528 * 2, 5529 * 2, 5530 * 2, 5531 * 2, 5532 * 2, 5533 * 2, 5534 * 2, 5535 * 2, 5536 * 2, 5537 * 2, 5538 * 2, 5539 * 2, 5540 * 2, 5541 * 2, 5542 * 2, 5543 * 2, 5544 * 2, 5545 * 2, 5546 * 2, 5547 * 2, 5548 * 2, 5550 * 2, 5553 * 2, 5555 * 2, 5558 * 2, 5560 * 2, 5562 * 2, 5564 * 2 },
	{ 5566 * 2, 5573 * 2, 5574 * 2, 5575 * 2, 5576 * 2, 5577 * 2, 5578 * 2 },
	{ 5579 * 2, 5589 * 2, 5590 * 2, 5591 * 2, 5592 * 2, 5593 * 2, 5595 * 2, 5596 * 2, 5597 * 2, 5598 * 2, 5599 * 2, 5600 * 2, 5601 * 2, 5603 * 2, 5606 * 2 },
	{ 5608 * 2, 5634 * 2, 5635 * 2, 5636 * 2, 5637 * 2, 5638 * 2, 5639 * 2, 5640 * 2, 5641 * 2, 5642 * 2, 5643 * 2, 5644 * 2, 5645 * 2, 5646 * 2, 5647 * 2, 5648 * 2, 5649 * 2, 5650 * 2, 5651 * 2, 5652 * 2, 5653 * 2, 5654 * 2, 5655 * 2, 5656 * 2, 5657 * 2, 5658 * 2, 5659 * 2, 5661 * 2, 5664 * 2, 5666 * 2, 5669 * 2, 5671 * 2, 5673 * 2, 5675 * 2 },
	{ 5677 * 2, 5692 * 2, 5693 * 2, 5694 * 2, 5695 * 2, 5696 * 2, 5697 * 2, 5698 * 2, 5699 * 2, 5700 * 2, 5701 * 2, 5703 * 2, 5704 * 2, 5705 * 2, 5706 * 2, 5707 * 2, 5708 * 2, 5709 * 2, 5711 * 2, 5714 * 2 },
	{ 5716 * 2, 5732 * 2, 5733 * 2, 5734 * 2, 5735 * 2, 5736 * 2, 5737 * 2, 5738 * 2, 5739 * 2, 5740 * 2, 5741 * 2, 5742 * 2, 5743 * 2, 5744 * 2, 5745 * 2, 5746 * 2 },
	{ 5749 * 2, 5751 * 2 },
	{ 5752 * 2, 5754 * 2 },
	{ 5755 * 2, 5765 * 2, 5766 * 2, 5767 * 2, 5768 * 2, 5769 * 2, 5770 * 2, 5771 * 2, 5772 * 2, 5773 * 2, 5774 * 2, 5775 * 2 },
	{ 5778 * 2, 5784 * 2, 5785 * 2, 5786 * 2, 5787 * 2, 5788 * 2 },
	{ 5789 * 2, 5793 * 2, 5795 * 2, 5796 * 2, 5797 * 2, 5798 * 2, 5800 * 2 },
	{ 5802 * 2, 5816 * 2, 5817 * 2, 5818 * 2, 5819 * 2, 5820 * 2, 5821 * 2, 5822 * 2, 5823 * 2, 5824 * 2, 5825 * 2, 5826 * 2, 5827 * 2, 5828 * 2, 5829 * 2, 5830 * 2, 5831 * 2, 5834 * 2, 5836 * 2, 5839 * 2 },
	{ 5841 * 2, 5847 * 2, 5848 * 2, 5849 * 2, 5850 * 2, 5851 * 2, 5852 * 2, 5853 * 2, 5855 * 2, 5858 * 2 },
	{ 5860 * 2, 5882 * 2, 5883 * 2, 5884 * 2, 5885 * 2, 5886 * 2, 5887 * 2, 5888 * 2, 5889 * 2, 5890 * 2, 5891 * 2, 5892 * 2, 5893 * 2, 5894 * 2, 5895 * 2, 5896 * 2, 5897 * 2, 5898 * 2, 5899 * 2, 5900 * 2, 5901 * 2, 5902 * 2, 5903 * 2, 5905 * 2, 5908 * 2, 5910 * 2, 5913 * 2, 5915 * 2, 5917 * 2, 5919 * 2 },
	{ 5921 * 2, 5942 * 2, 5943 * 2, 5944 * 2, 5945 * 2, 5946 * 2, 5947 * 2, 5948 * 2, 5949 * 2, 5950 * 2, 5951 * 2, 5952 * 2, 5953 * 2, 5954 * 2, 5955 * 2, 5956 * 2, 5957 * 2, 5958 * 2, 5959 * 2, 5960 * 2, 5961 * 2, 5962 * 2, 5964 * 2, 5967 * 2, 5969 * 2, 5972 * 2, 5974 * 2, 5976 * 2, 5978 * 2 },
	{ 5980 * 2, 5985 * 2, 5986 * 2, 5987 * 2, 5988 * 2, 5989 * 2 },
	{ 5991 * 2, 6011 * 2, 6012 * 2, 6013 * 2, 6014 * 2, 6015 * 2, 6016 * 2, 6017 * 2, 6018 * 2, 6019 * 2, 6020 * 2, 6021 * 2, 6022 * 2, 6023 * 2, 6024 * 2, 6025 * 2, 6026 * 2, 6027 * 2, 6028 * 2, 6029 * 2, 6030 * 2, 6031 * 2, 6034 * 2 },
	{ 6036 * 2, 6043 * 2, 6044 * 2, 6045 * 2, 6046 * 2, 6047 * 2, 6048 * 2, 6049 * 2 },
	{ 6051 * 2, 6063 * 2, 6064 * 2, 6065 * 2, 6066 * 2, 6067 * 2, 6068 * 2, 6069 * 2, 6070 * 2, 6071 * 2, 6072 * 2, 6073 * 2, 6074 * 2 },
	{ 6076 * 2, 6091 * 2, 6092 * 2, 6093 * 2, 6094 * 2, 6095 * 2, 6096 * 2, 6097 * 2, 6098 * 2, 6099 * 2, 6100 * 2, 6101 * 2, 6102 * 2, 6103 * 2, 6104 * 2, 6105 * 2 },
	{ 6107 * 2, 6146 * 2, 6147 * 2, 6148 * 2, 6149 * 2, 6150 * 2, 6151 * 2, 6152 * 2, 6153 * 2, 6154 * 2, 6155 * 2, 6156 * 2, 6157 * 2, 6158 * 2, 6159 * 2, 6160 * 2, 6161 * 2, 6162 * 2, 6163 * 2, 6164 * 2, 6165 * 2, 6166 * 2, 6167 * 2, 6168 * 2, 6169 * 2, 6170 * 2, 6171 * 2 },
	{ 6172 * 2, 6193 * 2, 6194 * 2, 6195 * 2, 6196 * 2, 6197 * 2, 6198 * 2, 6199 * 2, 6200 * 2, 6201 * 2, 6202 * 2, 6203 * 2, 6204 * 2, 6205 * 2, 6206 * 2, 6207 * 2, 6208 * 2, 6209 * 2, 6210 * 2, 6211 * 2, 6212 * 2, 6213 * 2, 6215 * 2, 6218 * 2, 6220 * 2, 6223 * 2, 6225 * 2, 6227 * 2, 6229 * 2 },
	{ 6231 * 2, 6235 * 2, 6236 * 2, 6237 * 2 },
	{ 6238 * 2, 6261 * 2, 6262 * 2, 6263 * 2, 6264 * 2, 6265 * 2, 6266 * 2, 6267 * 2, 6268 * 2, 6269 * 2, 6270 * 2, 6271 * 2, 6272 * 2, 6273 * 2, 6274 * 2, 6275 * 2, 6276 * 2, 6277 * 2, 6278 * 2, 6279 * 2, 6280 * 2, 6281 * 2, 6282 * 2, 6283 * 2, 6285 * 2, 6288 * 2, 6290 * 2, 6293 * 2, 6295 * 2, 6297 * 2, 6299 * 2 },
	{ 6301 * 2, 6318 * 2, 6319 * 2, 6320 * 2, 6321 * 2, 6322 * 2, 6323 * 2, 6324 * 2, 6325 * 2, 6326 * 2, 6327 * 2, 6328 * 2, 6329 * 2, 6330 * 2, 6331 * 2, 6332 * 2, 6333 * 2, 6334 * 2, 6335 * 2, 6338 * 2 },
	{ 6340 * 2, 6342 * 2 },
	{ 6343 * 2, 6346 * 2, 6347 * 2 },
	{ 6348 * 2, 6351 * 2, 6352 * 2 },
	{ 6353 * 2, 6356 * 2, 6357 * 2 },
	{ 6358 * 2, 6385 * 2, 6386 * 2, 6387 * 2, 6388 * 2, 6389 * 2, 6390 * 2, 6391 * 2, 6392 * 2, 6393 * 2, 6394 * 2, 6395 * 2, 6396 * 2, 6397 * 2, 6398 * 2, 6399 * 2, 6400 * 2, 6401 * 2, 6402 * 2, 6403 * 2, 6404 * 2, 6405 * 2, 6406 * 2, 6407 * 2, 6408 * 2, 6409 * 2, 6410 * 2, 6411 * 2, 6413 * 2, 6416 * 2, 6418 * 2, 6421 * 2, 6423 * 2, 6425 * 2, 6427 * 2 },
	{ 6429 * 2, 6452 * 2, 6453 * 2, 6454 * 2, 6455 * 2, 6456 * 2, 6457 * 2, 6458 * 2, 6459 * 2, 6460 * 2, 6461 * 2, 6462 * 2, 6463 * 2, 6464 * 2, 6465 * 2, 6466 * 2, 6467 * 2, 6468 * 2, 6469 * 2, 6470 * 2, 6471 * 2, 6472 * 2, 6473 * 2, 6474 * 2, 6476 * 2, 6479 * 2, 6481 * 2, 6484 * 2, 6486 * 2, 6488 * 2, 6490 * 2 },
	{ 6492 * 2, 6505 * 2, 6515 * 2, 6523 * 2, 6531 * 2, 6539 * 2, 6549 * 2, 6559 * 2, 6567 * 2, 6577 * 2, 6587 * 2, 6597 * 2, 6607 * 2, 6617 * 2, 6627 * 2, 6637 * 2, 6647 * 2, 6657 * 2, 6667 * 2, 6677 * 2, 6687 * 2, 6697 * 2, 6707 * 2, 6717 * 2 },
	{ 6727 * 2, 6733 * 2, 6734 * 2, 6735 * 2, 6736 * 2, 6737 * 2 },
	{ 6738 * 2, 6746 * 2, 6747 * 2, 6748 * 2, 6749 * 2, 6750 * 2, 6751 * 2, 6752 * 2, 6753 * 2, 6754 * 2 },
	{ 6757 * 2, 6762 * 2, 6763 * 2, 6764 * 2, 6765 * 2 },
	{ 6766 * 2, 6777 * 2, 6787 * 2, 6795 * 2, 6803 * 2, 6813 * 2, 6821 * 2, 6831 * 2, 6841 * 2, 6851 * 2, 6861 * 2, 6871 * 2, 6881 * 2, 6891 * 2, 6901 * 2, 6911 * 2, 6921 * 2, 6931 * 2 },
	{ 6941 * 2, 6948 * 2, 6949 * 2, 6950 * 2, 6951 * 2, 6952 * 2, 6953 * 2, 6954 * 2, 6955 * 2, 6957 * 2, 6960 * 2 },
	{ 6962 * 2, 6972 * 2, 6973 * 2, 6974 * 2, 6975 * 2, 6976 * 2, 6977 * 2, 6978 * 2, 6979 * 2, 6980 * 2, 6981 * 2, 6982 * 2 },
	{ 6985 * 2, 6990 * 2, 6991 * 2, 6992 * 2, 6993 * 2 },
	{ 6994 * 2, 7003 * 2, 7004 * 2, 7005 * 2, 7006 * 2, 7007 * 2, 7008 * 2, 7009 * 2, 7010 * 2, 7011 * 2, 7012 * 2, 7014 * 2, 7017 * 2 }
};

/* DFA transition chars */
UNICC_STATIC int _dfa_chars[ 7019 * 2 ] =
{
	9, 9, 10, 10, 13, 13, 32, 32, 35, 35, 47, 47, 64, 64, 91, 91, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 33, 33, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 42, 42, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 35, 35, 36, 36, 39, 39, 40, 40, 41, 41, 42, 42, 43, 43, 46, 46, 48, 57, 58, 58, 59, 59, 60, 60, 61, 61, 62, 62, 63, 63, 64, 64, 92, 92, 124, 124, 65, 90, 95, 95, 97, 122, 1, 8, 11, 12, 14, 31, 37, 38, 44, 45, 47, 47, 91, 91, 93, 94, 96, 96, 123, 123, 125, 65535, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 47, 47, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 0, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 35, 35, 36, 36, 39, 39, 40, 40, 41, 41, 42, 42, 43, 43, 46, 46, 48, 57, 58, 58, 59, 59, 60, 60, 61, 61, 62, 62, 63, 63, 64, 64, 92, 92, 124, 124, 65, 90, 95, 95, 97, 122, 1, 8, 11, 12, 14, 31, 37, 38, 44, 45, 47, 47, 91, 91, 93, 94, 96, 96, 123, 123, 125, 65535, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 35, 35, 36, 36, 38, 38, 39, 39, 40, 40, 41, 41, 42, 42, 43, 43, 45, 45, 46, 46, 47, 47, 58, 58, 59, 59, 60, 60, 61, 61, 63, 63, 64, 64, 91, 91, 99, 99, 100, 100, 101, 101, 102, 102, 103, 103, 105, 105, 108, 108, 109, 109, 110, 110, 111, 111, 112, 112, 114, 114, 115, 115, 119, 119, 124, 124, 65, 90, 95, 95, 97, 98, 104, 104, 106, 107, 113, 113, 116, 118, 120, 122, 1, 8, 11, 12, 14, 31, 37, 37, 44, 44, 48, 57, 62, 62, 92, 94, 96, 96, 123, 123, 125, 65535, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 33, 33, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, -1, -1, -1, -1, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, -1, -1, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 32, 32, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 108, 108, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 107, 109, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, -1, -1, -1, -1, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 105, 105, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 110, 110, -1, -1, 62, 62, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 61, 63, 65535, -1, -1, 115, 115, -1, -1, 61, 61, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 60, 62, 65535, -1, -1, 101, 101, -1, -1, 62, 62, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 61, 63, 65535, -1, -1, 97, 97, 101, 101, 118, 118, -1, -1, 42, 42, 1, 8, 11, 12, 14, 31, 35, 38, 40, 41, 43, 46, 48, 58, 60, 65535, -1, -1, 101, 101, -1, -1, 97, 97, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 96, 98, 110, 112, 65535, -1, -1, 116, 116, -1, -1, 112, 112, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 111, 113, 65535, -1, -1, 99, 99, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 112, 112, -1, -1, 114, 114, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 113, 115, 65535, -1, -1, 97, 97, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 112, 112, -1, -1, 97, 97, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 96, 98, 100, 102, 65535, -1, -1, 116, 116, -1, -1, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 112, 65535, -1, -1, 108, 108, -1, -1, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 112, 65535, -1, -1, 114, 114, -1, -1, 102, 102, 110, 110, 112, 112, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 101, 103, 109, 111, 111, 113, 65535, -1, -1, 117, 117, -1, -1, 99, 99, 114, 114, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 98, 100, 113, 115, 65535, -1, -1, 114, 114, -1, -1, 101, 101, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 104, 106, 65535, -1, -1, 109, 109, -1, -1, 99, 99, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 98, 100, 100, 102, 65535, -1, -1, 111, 111, -1, -1, 104, 104, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 103, 105, 65535, -1, -1, 32, 32, -1, -1, 111, 111, 114, 114, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 112, 113, 115, 65535, -1, -1, 118, 118, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 116, 116, -1, -1, 102, 102, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 101, 103, 65535, -1, -1, 121, 121, -1, -1, 120, 120, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 119, 121, 65535, -1, -1, 112, 112, -1, -1, 102, 102, 120, 120, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 101, 103, 119, 121, 65535, -1, -1, 103, 103, -1, -1, 100, 100, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 99, 101, 65535, -1, -1, 102, 102, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 101, 103, 65535, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 98, 98, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 97, 99, 65535, -1, -1, 101, 101, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 110, 112, 65535, -1, -1, 103, 103, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 102, 104, 65535, -1, -1, 97, 97, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 96, 98, 65535, -1, -1, 102, 102, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 101, 103, 65535, -1, -1, 114, 114, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 113, 115, 65535, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 97, 97, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 96, 98, 65535, -1, -1, 108, 108, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 107, 109, 65535, -1, -1, 97, 97, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 96, 98, 65535, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 45, 45, 97, 97, 1, 8, 11, 12, 14, 31, 35, 38, 40, 44, 46, 46, 48, 58, 60, 96, 98, 65535, -1, -1, 99, 99, 102, 102, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 98, 100, 101, 103, 65535, -1, -1, 104, 104, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 103, 105, 65535, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 32, 32, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 117, 117, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 116, 118, 65535, -1, -1, 100, 100, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 99, 101, 65535, -1, -1, 117, 117, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 116, 118, 65535, -1, -1, 109, 109, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 108, 110, 65535, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 114, 114, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 113, 115, 65535, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 114, 114, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 113, 115, 65535, -1, -1, 108, 108, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 107, 109, 65535, -1, -1, 121, 121, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 120, 122, 65535, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 118, 118, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 117, 119, 65535, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 45, 45, 1, 8, 11, 12, 14, 31, 35, 38, 40, 44, 46, 46, 48, 58, 60, 65535, -1, -1, 32, 32, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 99, 99, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 98, 100, 65535, -1, -1, 32, 32, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 105, 105, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 114, 116, 65535, -1, -1, 99, 99, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 98, 100, 65535, -1, -1, 121, 121, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 120, 122, 65535, -1, -1, 105, 105, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 110, 110, -1, -1, 115, 115, -1, -1, 101, 101, -1, -1, 112, 112, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 111, 113, 65535, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 97, 97, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 112, 65535, -1, -1, 108, 108, -1, -1, 114, 114, -1, -1, 32, 32, -1, -1, 116, 116, -1, -1, 120, 120, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 119, 121, 65535, -1, -1, 103, 103, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 102, 104, 65535, -1, -1, 97, 97, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 96, 98, 65535, -1, -1, 117, 117, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 116, 118, 65535, -1, -1, 100, 100, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 99, 101, 65535, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 114, 114, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 113, 115, 65535, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 105, 105, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 110, 110, -1, -1, 115, 115, -1, -1, 101, 101, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 97, 97, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 112, 65535, -1, -1, 108, 108, -1, -1, 32, 32, -1, -1, 120, 120, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 119, 121, 65535, -1, -1, 103, 103, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 102, 104, 65535, -1, -1, 97, 97, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 96, 98, 65535, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 105, 105, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 110, 110, -1, -1, 115, 115, -1, -1, 101, 101, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 97, 97, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 112, 65535, -1, -1, 103, 103, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 102, 104, 65535, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 105, 105, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 110, 110, -1, -1, 115, 115, -1, -1, 101, 101, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 112, 65535, -1, -1, 103, 103, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 102, 104, 65535, -1, -1, 110, 110, -1, -1, 115, 115, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 110, 110, -1, -1, 115, 115, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 105, 105, -1, -1, 110, 110, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 97, 97, -1, -1, 116, 116, -1, -1, 111, 111, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 105, 105, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 105, 105, -1, -1, 111, 111, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 111, 111, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 114, 114, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 113, 115, 65535, -1, -1, 116, 116, -1, -1, 100, 100, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 99, 101, 65535, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 118, 118, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 117, 119, 65535, -1, -1, 117, 117, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 116, 118, 65535, -1, -1, 103, 103, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 102, 104, 65535, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 105, 105, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 116, 116, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 99, 99, -1, -1, 99, 99, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 98, 100, 65535, -1, -1, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 112, 65535, -1, -1, 118, 118, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 117, 119, 65535, -1, -1, 118, 118, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 117, 119, 65535, -1, -1, 118, 118, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 117, 119, 65535, -1, -1, 108, 108, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 107, 109, 65535, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 35, 35, 64, 64, 91, 91, 65, 90, 95, 95, 97, 122, -1, -1, 33, 33, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, -1, -1, 42, 42, -1, -1, -1, -1, 47, 47, -1, -1, 10, 10, -1, -1, -1, -1, 35, 35, 64, 64, 91, 91, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 47, 47, 108, 108, 109, 109, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 97, 97, -1, -1, 111, 111, -1, -1, 110, 110, -1, -1, 100, 100, -1, -1, 103, 103, -1, -1, 101, 101, -1, -1, 117, 117, -1, -1, 101, 101, -1, -1, 97, 97, -1, -1, 103, 103, -1, -1, 108, 108, 109, 109, -1, -1, -1, -1, -1, -1, 97, 97, -1, -1, 111, 111, -1, -1, 110, 110, -1, -1, 100, 100, -1, -1, 103, 103, -1, -1, 101, 101, -1, -1, 117, 117, -1, -1, 101, 101, -1, -1, 97, 97, -1, -1, 103, 103, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 35, 35, 36, 36, 38, 38, 39, 39, 40, 40, 41, 41, 42, 42, 43, 43, 45, 45, 46, 46, 47, 47, 58, 58, 59, 59, 60, 60, 61, 61, 63, 63, 64, 64, 91, 91, 124, 124, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 61, 61, -1, -1, -1, -1, -1, -1, 62, 62, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 101, 101, -1, -1, 62, 62, -1, -1, 42, 42, 47, 47, -1, -1, 42, 42, -1, -1, 111, 111, 114, 114, -1, -1, 102, 102, -1, -1, 114, 114, -1, -1, 111, 111, -1, -1, 114, 114, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 35, 35, 41, 41, 47, 47, 59, 59, 61, 61, 64, 64, 91, 91, 124, 124, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 42, 42, -1, -1, 59, 59, -1, -1, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 47, 47, 99, 99, 100, 100, 101, 101, 102, 102, 103, 103, 108, 108, 110, 110, 111, 111, 112, 112, 114, 114, 119, 119, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 98, 104, 107, 109, 109, 113, 113, 115, 118, 120, 65535, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 97, 97, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 96, 98, 65535, -1, -1, -1, -1, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 32, 32, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 105, 105, -1, -1, 112, 112, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 111, 113, 65535, -1, -1, 110, 110, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 115, 115, -1, -1, 114, 114, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 113, 115, 65535, -1, -1, 101, 101, -1, -1, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 112, 65535, -1, -1, 97, 97, 101, 101, 118, 118, -1, -1, 99, 99, 114, 114, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 98, 100, 113, 115, 65535, -1, -1, 101, 101, -1, -1, 101, 101, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 104, 106, 65535, -1, -1, 116, 116, -1, -1, 104, 104, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 103, 105, 65535, -1, -1, 99, 99, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 112, 112, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 97, 97, -1, -1, 102, 102, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 101, 103, 65535, -1, -1, 112, 112, -1, -1, 120, 120, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 119, 121, 65535, -1, -1, 116, 116, -1, -1, 102, 102, 120, 120, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 101, 103, 119, 121, 65535, -1, -1, 108, 108, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 114, 114, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 117, 117, -1, -1, 98, 98, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 97, 99, 65535, -1, -1, 114, 114, -1, -1, 101, 101, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 110, 112, 65535, -1, -1, 109, 109, -1, -1, 103, 103, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 102, 104, 65535, -1, -1, 111, 111, -1, -1, 108, 108, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 107, 109, 65535, -1, -1, 32, 32, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 118, 118, -1, -1, 45, 45, 97, 97, 1, 8, 11, 12, 14, 31, 35, 38, 40, 44, 46, 46, 48, 58, 60, 96, 98, 65535, -1, -1, 116, 116, -1, -1, 99, 99, 102, 102, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 98, 100, 101, 103, 65535, -1, -1, 121, 121, -1, -1, 104, 104, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 103, 105, 65535, -1, -1, 112, 112, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 103, 103, -1, -1, 32, 32, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 117, 117, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 116, 118, 65535, -1, -1, 100, 100, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 99, 101, 65535, -1, -1, 109, 109, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 108, 110, 65535, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 114, 114, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 113, 115, 65535, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 108, 108, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 107, 109, 65535, -1, -1, 121, 121, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 120, 122, 65535, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 120, 120, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 119, 121, 65535, -1, -1, 118, 118, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 117, 119, 65535, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 32, 32, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 99, 99, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 98, 100, 65535, -1, -1, 32, 32, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 99, 99, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 98, 100, 65535, -1, -1, 121, 121, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 120, 122, 65535, -1, -1, 97, 97, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 96, 98, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 105, 105, -1, -1, 112, 112, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 111, 113, 65535, -1, -1, 110, 110, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 115, 115, -1, -1, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 112, 65535, -1, -1, 101, 101, -1, -1, 97, 97, -1, -1, 108, 108, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 114, 114, -1, -1, 103, 103, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 102, 104, 65535, -1, -1, 32, 32, -1, -1, 116, 116, -1, -1, 117, 117, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 116, 118, 65535, -1, -1, 100, 100, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 99, 101, 65535, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 97, 97, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 96, 98, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 105, 105, -1, -1, 112, 112, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 111, 113, 65535, -1, -1, 110, 110, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 115, 115, -1, -1, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 112, 65535, -1, -1, 101, 101, -1, -1, 97, 97, -1, -1, 108, 108, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 103, 103, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 102, 104, 65535, -1, -1, 32, 32, -1, -1, 100, 100, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 99, 101, 65535, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 97, 97, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 96, 98, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 105, 105, -1, -1, 110, 110, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 115, 115, -1, -1, 101, 101, -1, -1, 97, 97, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 105, 105, -1, -1, 110, 110, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 115, 115, -1, -1, 101, 101, -1, -1, 110, 110, -1, -1, 115, 115, -1, -1, 110, 110, -1, -1, 115, 115, -1, -1, 105, 105, -1, -1, 110, 110, -1, -1, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 112, 65535, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 97, 97, -1, -1, 116, 116, -1, -1, 111, 111, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 105, 105, -1, -1, 105, 105, -1, -1, 111, 111, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 111, 111, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 114, 114, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 113, 115, 65535, -1, -1, 116, 116, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 117, 117, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 116, 118, 65535, -1, -1, 103, 103, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 102, 104, 65535, -1, -1, 105, 105, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 116, 116, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 99, 99, -1, -1, 99, 99, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 98, 100, 65535, -1, -1, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 112, 65535, -1, -1, 108, 108, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 107, 109, 65535, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 36, 36, 45, 45, 47, 47, 58, 58, 60, 60, 61, 61, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 61, 61, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, 62, -1, -1, 42, 42, 47, 47, -1, -1, 62, 62, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 47, 47, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 35, 35, 36, 36, 38, 38, 39, 39, 40, 40, 41, 41, 42, 42, 43, 43, 45, 45, 46, 46, 47, 47, 48, 57, 58, 58, 59, 59, 60, 60, 61, 61, 63, 63, 64, 64, 91, 91, 124, 124, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 61, 61, -1, -1, -1, -1, -1, -1, 62, 62, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 101, 101, -1, -1, 62, 62, -1, -1, 42, 42, 47, 47, -1, -1, 42, 42, -1, -1, 111, 111, 114, 114, -1, -1, 102, 102, -1, -1, 114, 114, -1, -1, 111, 111, -1, -1, 114, 114, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 35, 35, 36, 36, 39, 39, 40, 40, 41, 41, 42, 42, 43, 43, 46, 46, 48, 57, 58, 58, 59, 59, 60, 60, 61, 61, 62, 62, 63, 63, 64, 64, 92, 92, 124, 124, 65, 90, 95, 95, 97, 122, 1, 8, 11, 12, 14, 31, 37, 38, 44, 45, 47, 47, 91, 91, 93, 94, 96, 96, 123, 123, 125, 65535, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 93, 93, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 99, 99, 100, 100, 101, 101, 102, 102, 108, 108, 110, 110, 111, 111, 112, 112, 114, 114, 119, 119, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 98, 103, 107, 109, 109, 113, 113, 115, 118, 120, 65535, -1, -1, 97, 97, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 96, 98, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 32, 32, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 105, 105, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 110, 110, -1, -1, 112, 112, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 111, 113, 65535, -1, -1, 115, 115, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 101, 101, -1, -1, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 112, 65535, -1, -1, 97, 97, 101, 101, 118, 118, -1, -1, 99, 99, 114, 114, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 98, 100, 113, 115, 65535, -1, -1, 101, 101, -1, -1, 101, 101, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 104, 106, 65535, -1, -1, 116, 116, -1, -1, 104, 104, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 103, 105, 65535, -1, -1, 99, 99, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 112, 112, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 97, 97, -1, -1, 102, 102, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 101, 103, 65535, -1, -1, 112, 112, -1, -1, 120, 120, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 119, 121, 65535, -1, -1, 116, 116, -1, -1, 102, 102, 120, 120, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 101, 103, 119, 121, 65535, -1, -1, 108, 108, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 114, 114, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 117, 117, -1, -1, 98, 98, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 97, 99, 65535, -1, -1, 114, 114, -1, -1, 101, 101, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 110, 112, 65535, -1, -1, 109, 109, -1, -1, 103, 103, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 102, 104, 65535, -1, -1, 111, 111, -1, -1, 108, 108, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 107, 109, 65535, -1, -1, 32, 32, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 118, 118, -1, -1, 102, 102, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 101, 103, 65535, -1, -1, 116, 116, -1, -1, 104, 104, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 103, 105, 65535, -1, -1, 121, 121, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 112, 112, -1, -1, 32, 32, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 103, 103, -1, -1, 117, 117, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 116, 118, 65535, -1, -1, 109, 109, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 108, 110, 65535, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 114, 114, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 113, 115, 65535, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 108, 108, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 107, 109, 65535, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 120, 120, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 119, 121, 65535, -1, -1, 118, 118, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 117, 119, 65535, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 32, 32, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 99, 99, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 98, 100, 65535, -1, -1, 32, 32, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 99, 99, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 98, 100, 65535, -1, -1, 97, 97, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 96, 98, 65535, -1, -1, 105, 105, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 110, 110, -1, -1, 112, 112, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 111, 113, 65535, -1, -1, 115, 115, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 112, 65535, -1, -1, 101, 101, -1, -1, 97, 97, -1, -1, 108, 108, -1, -1, 114, 114, -1, -1, 103, 103, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 102, 104, 65535, -1, -1, 32, 32, -1, -1, 116, 116, -1, -1, 117, 117, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 116, 118, 65535, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 97, 97, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 96, 98, 65535, -1, -1, 105, 105, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 110, 110, -1, -1, 112, 112, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 111, 113, 65535, -1, -1, 115, 115, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 112, 65535, -1, -1, 101, 101, -1, -1, 97, 97, -1, -1, 108, 108, -1, -1, 32, 32, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 97, 97, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 96, 98, 65535, -1, -1, 105, 105, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 110, 110, -1, -1, 115, 115, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 112, 65535, -1, -1, 101, 101, -1, -1, 97, 97, -1, -1, 97, 97, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 96, 98, 65535, -1, -1, 105, 105, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 110, 110, -1, -1, 115, 115, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 101, 101, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 110, 110, -1, -1, 115, 115, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 110, 110, -1, -1, 115, 115, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 105, 105, -1, -1, 110, 110, -1, -1, 115, 115, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 114, 116, 65535, -1, -1, 97, 97, -1, -1, 116, 116, -1, -1, 111, 111, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 117, 117, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 116, 118, 65535, -1, -1, 105, 105, -1, -1, 105, 105, -1, -1, 111, 111, -1, -1, 111, 111, -1, -1, 116, 116, -1, -1, 103, 103, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 102, 104, 65535, -1, -1, 105, 105, -1, -1, 116, 116, -1, -1, 99, 99, -1, -1, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 112, 65535, -1, -1, 108, 108, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 107, 109, 65535, -1, -1, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 47, 47, 99, 99, 105, 105, 115, 115, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 108, 108, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 111, 111, -1, -1, 110, 110, -1, -1, 99, 99, 101, 101, -1, -1, 115, 115, -1, -1, 97, 97, -1, -1, 116, 116, -1, -1, 101, 101, -1, -1, 101, 101, -1, -1, 105, 105, -1, -1, 120, 120, -1, -1, 114, 114, -1, -1, 105, 105, -1, -1, 45, 45, -1, -1, 118, 118, -1, -1, 105, 105, 115, 115, -1, -1, 110, 110, -1, -1, 115, 115, -1, -1, 116, 116, -1, -1, 101, 101, -1, -1, 110, 110, -1, -1, 115, 115, -1, -1, 116, 116, -1, -1, 101, 101, -1, -1, 110, 110, -1, -1, 115, 115, -1, -1, 101, 101, -1, -1, 101, 101, -1, -1, 101, 101, -1, -1, 101, 101, -1, -1, 110, 110, -1, -1, 118, 118, -1, -1, 118, 118, -1, -1, 118, 118, -1, -1, 105, 105, -1, -1, 116, 116, -1, -1, 105, 105, -1, -1, 116, 116, -1, -1, 105, 105, -1, -1, 116, 116, -1, -1, 105, 105, -1, -1, 115, 115, -1, -1, 110, 110, -1, -1, 105, 105, -1, -1, 115, 115, -1, -1, 110, 110, -1, -1, 105, 105, -1, -1, 115, 115, -1, -1, 110, 110, -1, -1, 101, 101, -1, -1, 101, 101, -1, -1, 115, 115, -1, -1, 110, 110, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 34, 34, 39, 39, 47, 47, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 99, 99, 105, 105, 115, 115, -1, -1, 108, 108, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 111, 111, -1, -1, 110, 110, -1, -1, 99, 99, 101, 101, -1, -1, 115, 115, -1, -1, 97, 97, -1, -1, 116, 116, -1, -1, 101, 101, -1, -1, 101, 101, -1, -1, 105, 105, -1, -1, 120, 120, -1, -1, 114, 114, -1, -1, 105, 105, -1, -1, 45, 45, -1, -1, 118, 118, -1, -1, 105, 105, 115, 115, -1, -1, 110, 110, -1, -1, 115, 115, -1, -1, 116, 116, -1, -1, 101, 101, -1, -1, 110, 110, -1, -1, 115, 115, -1, -1, 116, 116, -1, -1, 101, 101, -1, -1, 110, 110, -1, -1, 115, 115, -1, -1, 101, 101, -1, -1, 101, 101, -1, -1, 101, 101, -1, -1, 101, 101, -1, -1, 110, 110, -1, -1, 118, 118, -1, -1, 118, 118, -1, -1, 118, 118, -1, -1, 105, 105, -1, -1, 116, 116, -1, -1, 105, 105, -1, -1, 116, 116, -1, -1, 105, 105, -1, -1, 116, 116, -1, -1, 105, 105, -1, -1, 115, 115, -1, -1, 110, 110, -1, -1, 105, 105, -1, -1, 115, 115, -1, -1, 110, 110, -1, -1, 105, 105, -1, -1, 115, 115, -1, -1, 110, 110, -1, -1, 101, 101, -1, -1, 101, 101, -1, -1, 115, 115, -1, -1, 110, 110, -1, -1, 34, 34, 39, 39, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 45, 45, 47, 47, 58, 58, 60, 60, 61, 61, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 61, 61, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, 62, -1, -1, 42, 42, 47, 47, -1, -1, 62, 62, -1, -1, 42, 42, -1, -1, -1, -1, 93, 93, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 39, 39, 40, 40, 47, 47, 60, 60, 64, 64, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 34, 34, 39, 39, 47, 47, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 47, 47, 59, 59, 91, 91, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 42, 42, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 47, 47, 59, 59, 60, 60, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 47, 47, 59, 59, 111, 111, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 102, 102, 110, 110, -1, -1, 102, 102, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 47, 47, 91, 91, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 42, 42, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 47, 47, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 34, 34, 39, 39, -1, -1, -1, -1, -1, -1, 59, 59, 91, 91, -1, -1, -1, -1, -1, -1, 42, 42, -1, -1, 59, 59, 111, 111, -1, -1, -1, -1, -1, -1, -1, -1, 102, 102, 110, 110, -1, -1, 102, 102, -1, -1, 91, 91, -1, -1, -1, -1, 42, 42, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 39, 39, 40, 40, 46, 46, 47, 47, 60, 60, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 47, 47, 59, 59, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 35, 35, 38, 38, 39, 39, 40, 40, 41, 41, 47, 47, 59, 59, 60, 60, 61, 61, 64, 64, 91, 91, 124, 124, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 101, 101, -1, -1, 42, 42, 47, 47, -1, -1, 42, 42, -1, -1, 111, 111, 114, 114, -1, -1, 102, 102, -1, -1, 114, 114, -1, -1, 111, 111, -1, -1, 114, 114, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 35, 35, 38, 38, 39, 39, 40, 40, 41, 41, 42, 42, 43, 43, 46, 46, 47, 47, 59, 59, 60, 60, 61, 61, 63, 63, 64, 64, 91, 91, 124, 124, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 101, 101, -1, -1, 42, 42, 47, 47, -1, -1, 42, 42, -1, -1, 111, 111, 114, 114, -1, -1, 102, 102, -1, -1, 114, 114, -1, -1, 111, 111, -1, -1, 114, 114, -1, -1, 34, 34, 35, 35, 39, 39, 41, 41, 59, 59, 124, 124, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 45, 45, 47, 47, 58, 58, 60, 60, 61, 61, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 61, 61, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, 62, -1, -1, 42, 42, 47, 47, -1, -1, 62, 62, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 35, 35, 38, 38, 39, 39, 40, 40, 41, 41, 42, 42, 43, 43, 47, 47, 58, 58, 59, 59, 60, 60, 61, 61, 63, 63, 64, 64, 91, 91, 124, 124, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 101, 101, -1, -1, 42, 42, 47, 47, -1, -1, 42, 42, -1, -1, 111, 111, 114, 114, -1, -1, 102, 102, -1, -1, 114, 114, -1, -1, 111, 111, -1, -1, 114, 114, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 39, 39, 40, 40, 45, 45, 46, 46, 47, 47, 58, 58, 59, 59, 61, 61, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 61, 61, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, 62, -1, -1, 42, 42, 47, 47, -1, -1, 62, 62, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 39, 39, 40, 40, 47, 47, 59, 59, 60, 60, 64, 64, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 39, 39, -1, -1, -1, -1, 40, 40, -1, -1, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 35, 35, 41, 41, 47, 47, 59, 59, 124, 124, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 33, 33, 34, 34, 39, 39, 40, 40, 46, 46, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 45, 45, 58, 58, 61, 61, -1, -1, 61, 61, -1, -1, -1, -1, -1, -1, -1, -1, 62, 62, -1, -1, 62, 62, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 34, 34, 35, 35, 39, 39, 41, 41, 47, 47, 59, 59, 91, 91, 111, 111, 124, 124, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 42, 42, -1, -1, 102, 102, 110, 110, -1, -1, 102, 102, -1, -1, 34, 34, 39, 39, 59, 59, 91, 91, 111, 111, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, -1, -1, 102, 102, 110, 110, -1, -1, 102, 102, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 35, 35, 38, 38, 39, 39, 40, 40, 41, 41, 46, 46, 47, 47, 60, 60, 61, 61, 64, 64, 91, 91, 124, 124, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 101, 101, -1, -1, 42, 42, 47, 47, -1, -1, 42, 42, -1, -1, 111, 111, 114, 114, -1, -1, 102, 102, -1, -1, 114, 114, -1, -1, 111, 111, -1, -1, 114, 114, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 35, 35, 38, 38, 39, 39, 40, 40, 41, 41, 47, 47, 60, 60, 61, 61, 64, 64, 91, 91, 124, 124, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 101, 101, -1, -1, 42, 42, 47, 47, -1, -1, 42, 42, -1, -1, 111, 111, 114, 114, -1, -1, 102, 102, -1, -1, 114, 114, -1, -1, 111, 111, -1, -1, 114, 114, -1, -1, 35, 35, 59, 59, 61, 61, 91, 91, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 35, 35, 39, 39, 40, 40, 41, 41, 42, 42, 43, 43, 46, 46, 47, 47, 59, 59, 61, 61, 63, 63, 91, 91, 124, 124, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 42, 42, -1, -1, 35, 35, 41, 41, 59, 59, 61, 61, 91, 91, 124, 124, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, -1, -1, 33, 33, 34, 34, 35, 35, 39, 39, 40, 40, 41, 41, 46, 46, 59, 59, 61, 61, 91, 91, 124, 124, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, -1, -1, 33, 33, 34, 34, 35, 35, 39, 39, 40, 40, 41, 41, 42, 42, 43, 43, 46, 46, 59, 59, 61, 61, 63, 63, 91, 91, 124, 124, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 35, 35, 36, 36, 39, 39, 40, 40, 41, 41, 42, 42, 43, 43, 46, 46, 48, 57, 58, 58, 59, 59, 60, 60, 61, 61, 62, 62, 63, 63, 64, 64, 92, 92, 124, 124, 65, 90, 95, 95, 97, 122, 1, 8, 11, 12, 14, 31, 37, 38, 44, 45, 47, 47, 91, 91, 93, 94, 96, 96, 123, 123, 125, 65535, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 35, 35, 38, 38, 39, 39, 40, 40, 47, 47, 59, 59, 60, 60, 61, 61, 64, 64, 91, 91, 124, 124, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 101, 101, -1, -1, 42, 42, 47, 47, -1, -1, 42, 42, -1, -1, 111, 111, 114, 114, -1, -1, 102, 102, -1, -1, 114, 114, -1, -1, 111, 111, -1, -1, 114, 114, -1, -1, 35, 35, 59, 59, 61, 61, -1, -1, -1, -1, -1, -1, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 35, 35, 38, 38, 39, 39, 40, 40, 41, 41, 46, 46, 47, 47, 59, 59, 60, 60, 61, 61, 64, 64, 91, 91, 124, 124, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 101, 101, -1, -1, 42, 42, 47, 47, -1, -1, 42, 42, -1, -1, 111, 111, 114, 114, -1, -1, 102, 102, -1, -1, 114, 114, -1, -1, 111, 111, -1, -1, 114, 114, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 35, 35, 39, 39, 40, 40, 41, 41, 46, 46, 47, 47, 59, 59, 61, 61, 91, 91, 124, 124, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 42, 42, -1, -1, 41, 41, -1, -1, -1, -1, 59, 59, 124, 124, -1, -1, -1, -1, -1, -1, 41, 41, 124, 124, -1, -1, -1, -1, -1, -1, 35, 35, 59, 59, -1, -1, -1, -1, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 35, 35, 38, 38, 39, 39, 40, 40, 41, 41, 42, 42, 43, 43, 46, 46, 47, 47, 58, 58, 59, 59, 60, 60, 61, 61, 63, 63, 64, 64, 91, 91, 124, 124, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 101, 101, -1, -1, 42, 42, 47, 47, -1, -1, 42, 42, -1, -1, 111, 111, 114, 114, -1, -1, 102, 102, -1, -1, 114, 114, -1, -1, 111, 111, -1, -1, 114, 114, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 35, 35, 38, 38, 39, 39, 40, 40, 41, 41, 47, 47, 58, 58, 59, 59, 60, 60, 61, 61, 64, 64, 91, 91, 124, 124, 65, 90, 95, 95, 97, 122, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 101, 101, -1, -1, 42, 42, 47, 47, -1, -1, 42, 42, -1, -1, 111, 111, 114, 114, -1, -1, 102, 102, -1, -1, 114, 114, -1, -1, 111, 111, -1, -1, 114, 114, -1, -1, 103, 103, 110, 110, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 102, 104, 109, 112, 65535, -1, -1, 114, 114, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 113, 115, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 112, 65535, -1, -1, 112, 112, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 111, 113, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 45, 45, 1, 8, 11, 12, 14, 31, 35, 38, 40, 44, 46, 46, 48, 58, 60, 65535, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 100, 100, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 99, 101, 65535, -1, -1, 103, 103, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 102, 104, 65535, -1, -1, 121, 121, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 120, 122, 65535, -1, -1, 121, 121, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 120, 122, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 100, 100, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 99, 101, 65535, -1, -1, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 112, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 114, 114, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 113, 115, 65535, -1, -1, 35, 35, 41, 41, 59, 59, 61, 61, 124, 124, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 35, 35, 47, 47, 59, 59, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 35, 35, 41, 41, 59, 59, 124, 124, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 111, 111, 112, 112, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 113, 65535, -1, -1, 112, 112, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 111, 113, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 114, 114, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 113, 115, 65535, -1, -1, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 65535, -1, -1, 116, 116, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 115, 117, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 105, 105, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 104, 106, 65535, -1, -1, 99, 99, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 98, 100, 65535, -1, -1, 111, 111, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 110, 112, 65535, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 100, 100, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 99, 101, 65535, -1, -1, 110, 110, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 109, 111, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 101, 101, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 100, 102, 65535, -1, -1, 99, 99, 1, 8, 11, 12, 14, 31, 35, 38, 40, 46, 48, 58, 60, 98, 100, 65535, -1, -1, 34, 34, 35, 35, 39, 39, 59, 59, 91, 91, 111, 111, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, -1, -1, 102, 102, 110, 110, -1, -1, 102, 102, -1, -1, 9, 9, 10, 10, 13, 13, 32, 32, 33, 33, 34, 34, 39, 39, 47, 47, 64, 64, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, 47, 47, -1, -1, 33, 33, 34, 34, 39, 39, 64, 64, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 34, 34, 35, 35, 39, 39, 41, 41, 59, 59, 91, 91, 111, 111, 124, 124, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, 42, -1, -1, 102, 102, 110, 110, -1, -1, 102, 102, -1, -1
};

/* DFA transitions */
UNICC_STATIC int _dfa_trans[ 7019 ] =
{
	1, 2, 3, 4, 5, 12, 6, 13, 7, 7, 7, -1, -1, -1, -1, -1, 8, -1, -1, -1, -1, -1, -1, -1, 9, 10, -1, 11, -1, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 25, 25, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 27, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 26, 26, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1, 2, 3, 4, 5, 6, 7, 49, 51, 8, 49, 49, 49, 49, 53, 49, 48, 55, 9, 49, 57, 49, 49, 59, 61, 137, 63, 65, 67, 69, 71, 73, 75, 77, 79, 81, 83, 85, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, -1, -1, -1, -1, -1, -1, -1, 10, 49, 49, 49, 49, 49, 49, 49, -1, -1, -1, -1, 49, 49, 49, 49, 49, 49, 49, -1, -1, -1, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 139, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 243, 49, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, 49, 49, 49, 49, 49, 49, 49, -1, -1, 49, 49, 49, 49, 49, 49, 49, -1, -1, -1, -1, 49, 49, 49, 49, 49, 49, 49, -1, -1, -1, 12, 13, -1, 49, 49, 49, 49, 49, 49, 49, -1, 52, -1, 87, 49, 49, 49, 49, 49, 49, 49, 49, -1, 54, -1, 11, 49, 49, 49, 49, 49, 49, 49, 49, -1, 56, -1, 14, 49, 49, 49, 49, 49, 49, 49, 49, -1, 201, -1, 15, 49, 49, 49, 49, 49, 49, 49, 49, -1, 64, 66, 68, -1, 16, 49, 49, 49, 49, 49, 49, 49, 49, -1, 70, -1, 89, 144, 49, 49, 49, 49, 49, 49, 49, 49, 49, -1, 140, -1, 142, 49, 49, 49, 49, 49, 49, 49, 49, -1, 72, -1, 93, 49, 49, 49, 49, 49, 49, 49, 49, -1, 176, -1, 159, 49, 49, 49, 49, 49, 49, 49, 49, -1, 74, -1, 206, 49, 49, 49, 49, 49, 49, 49, 49, -1, 143, -1, 165, 95, 49, 49, 49, 49, 49, 49, 49, 49, 49, -1, 158, -1, 97, 49, 49, 49, 49, 49, 49, 49, 49, -1, 78, -1, 180, 49, 49, 49, 49, 49, 49, 49, 49, -1, 82, -1, 98, 17, 99, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, -1, 162, -1, 100, 101, 49, 49, 49, 49, 49, 49, 49, 49, 49, -1, 164, -1, 238, 102, 49, 49, 49, 49, 49, 49, 49, 49, 49, -1, 200, -1, 103, 190, 49, 49, 49, 49, 49, 49, 49, 49, 49, -1, 138, -1, 163, 49, 49, 49, 49, 49, 49, 49, 49, -1, 90, -1, 104, 105, 49, 49, 49, 49, 49, 49, 49, 49, 49, -1, 177, -1, 174, 49, 49, 49, 49, 49, 49, 49, 49, -1, 92, -1, 107, 49, 49, 49, 49, 49, 49, 49, 49, -1, 94, -1, 109, 49, 49, 49, 49, 49, 49, 49, 49, -1, 188, -1, 110, 214, 49, 49, 49, 49, 49, 49, 49, 49, 49, -1, 198, -1, 217, 49, 49, 49, 49, 49, 49, 49, 49, -1, 18, 49, 49, 49, 49, 49, 49, 49, 49, -1, 178, 49, 49, 49, 49, 49, 49, 49, 49, -1, 19, 49, 49, 49, 49, 49, 49, 49, 49, -1, 112, 256, 49, 49, 49, 49, 49, 49, 49, 49, 49, -1, 113, 49, 49, 49, 49, 49, 49, 49, 49, -1, 196, 49, 49, 49, 49, 49, 49, 49, 49, -1, 20, 49, 49, 49, 49, 49, 49, 49, 49, -1, 145, 49, 49, 49, 49, 49, 49, 49, 49, -1, 219, 49, 49, 49, 49, 49, 49, 49, 49, -1, 116, 49, 49, 49, 49, 49, 49, 49, 49, -1, 166, 49, 49, 49, 49, 49, 49, 49, 49, -1, 242, 49, 49, 49, 49, 49, 49, 49, 49, -1, 21, 49, 49, 49, 49, 49, 49, 49, 49, -1, 170, 120, 49, 49, 49, 49, 49, 49, 49, 49, 49, -1, 220, 202, 49, 49, 49, 49, 49, 49, 49, 49, 49, -1, 122, 49, 49, 49, 49, 49, 49, 49, 49, -1, 189, 49, 49, 49, 49, 49, 49, 49, 49, -1, 50, 49, 49, 49, 49, 49, 49, 49, -1, 124, 49, 49, 49, 49, 49, 49, 49, 49, -1, 125, 49, 49, 49, 49, 49, 49, 49, 49, -1, 152, 49, 49, 49, 49, 49, 49, 49, 49, -1, 223, 49, 49, 49, 49, 49, 49, 49, 49, -1, 126, 49, 49, 49, 49, 49, 49, 49, 49, -1, 127, 49, 49, 49, 49, 49, 49, 49, 49, -1, 22, 49, 49, 49, 49, 49, 49, 49, 49, -1, 23, 49, 49, 49, 49, 49, 49, 49, 49, -1, 157, 49, 49, 49, 49, 49, 49, 49, 49, -1, 25, 49, 49, 49, 49, 49, 49, 49, 49, -1, 191, 49, 49, 49, 49, 49, 49, 49, 49, -1, 227, 49, 49, 49, 49, 49, 49, 49, 49, -1, 129, 49, 49, 49, 49, 49, 49, 49, 49, -1, 133, 49, 49, 49, 49, 49, 49, 49, 49, -1, 58, 49, 49, 49, 49, 49, 49, 49, -1, 32, 49, 49, 49, 49, 49, 49, 49, 49, -1, 62, 49, 49, 49, 49, 49, 49, 49, -1, 275, 272, 49, 49, 49, 49, 49, 49, 49, 49, 49, -1, 245, 49, 49, 49, 49, 49, 49, 49, 49, -1, 35, 49, 49, 49, 49, 49, 49, 49, 49, -1, 204, -1, 91, 49, 49, 49, 49, 49, 49, 49, 49, -1, 40, -1, 60, -1, 76, -1, 171, 49, 49, 49, 49, 49, 49, 49, 49, -1, 108, 49, 49, 49, 49, 49, 49, 49, 49, -1, 80, -1, 106, 49, 49, 49, 49, 49, 49, 49, 49, -1, 123, 49, 49, 49, 49, 49, 49, 49, 49, -1, 205, -1, 212, -1, 179, -1, 147, -1, 128, 49, 49, 49, 49, 49, 49, 49, 49, -1, 118, 49, 49, 49, 49, 49, 49, 49, 49, -1, 192, 49, 49, 49, 49, 49, 49, 49, 49, -1, 228, 49, 49, 49, 49, 49, 49, 49, 49, -1, 135, 49, 49, 49, 49, 49, 49, 49, 49, -1, 141, 49, 49, 49, 49, 49, 49, 49, 49, -1, 29, 49, 49, 49, 49, 49, 49, 49, 49, -1, 130, 49, 49, 49, 49, 49, 49, 49, 49, -1, 84, -1, 185, 49, 49, 49, 49, 49, 49, 49, 49, -1, 203, -1, 136, -1, 86, -1, 234, 49, 49, 49, 49, 49, 49, 49, 49, -1, 232, -1, 151, 49, 49, 49, 49, 49, 49, 49, 49, -1, 182, 49, 49, 49, 49, 49, 49, 49, 49, -1, 187, -1, 194, -1, 28, 49, 49, 49, 49, 49, 49, 49, 49, -1, 231, 49, 49, 49, 49, 49, 49, 49, 49, -1, 251, 49, 49, 49, 49, 49, 49, 49, 49, -1, 183, 49, 49, 49, 49, 49, 49, 49, 49, -1, 146, -1, 115, 49, 49, 49, 49, 49, 49, 49, 49, -1, 148, -1, 173, -1, 168, -1, 181, 49, 49, 49, 49, 49, 49, 49, 49, -1, 250, -1, 111, 49, 49, 49, 49, 49, 49, 49, 49, -1, 211, 49, 49, 49, 49, 49, 49, 49, 49, -1, 153, 49, 49, 49, 49, 49, 49, 49, 49, -1, 38, 49, 49, 49, 49, 49, 49, 49, 49, -1, 88, -1, 117, 49, 49, 49, 49, 49, 49, 49, 49, -1, 42, -1, 43, -1, 44, -1, 207, 49, 49, 49, 49, 49, 49, 49, 49, -1, 114, 49, 49, 49, 49, 49, 49, 49, 49, -1, 131, 49, 49, 49, 49, 49, 49, 49, 49, -1, 229, 49, 49, 49, 49, 49, 49, 49, 49, -1, 96, -1, 149, -1, 235, 49, 49, 49, 49, 49, 49, 49, 49, -1, 199, 49, 49, 49, 49, 49, 49, 49, 49, -1, 46, -1, 47, -1, 224, 49, 49, 49, 49, 49, 49, 49, 49, -1, 160, -1, 161, -1, 169, 49, 49, 49, 49, 49, 49, 49, 49, -1, 167, -1, 184, -1, 175, -1, 209, 49, 49, 49, 49, 49, 49, 49, 49, -1, 195, 49, 49, 49, 49, 49, 49, 49, 49, -1, 213, -1, 267, 49, 49, 49, 49, 49, 49, 49, 49, -1, 39, 49, 49, 49, 49, 49, 49, 49, 49, -1, 27, 49, 49, 49, 49, 49, 49, 49, 49, -1, 193, -1, 186, -1, 119, 49, 49, 49, 49, 49, 49, 49, 49, -1, 134, 49, 49, 49, 49, 49, 49, 49, 49, -1, 197, -1, 49, 49, 49, 49, 49, 49, 49, 49, 49, -1, 121, 49, 49, 49, 49, 49, 49, 49, 49, -1, 150, 49, 49, 49, 49, 49, 49, 49, 49, -1, 233, 49, 49, 49, 49, 49, 49, 49, 49, -1, 155, 49, 49, 49, 49, 49, 49, 49, 49, -1, 24, 49, 49, 49, 49, 49, 49, 49, 49, -1, 26, 49, 49, 49, 49, 49, 49, 49, 49, -1, 156, 49, 49, 49, 49, 49, 49, 49, 49, -1, 230, 49, 49, 49, 49, 49, 49, 49, 49, -1, 215, 49, 49, 49, 49, 49, 49, 49, 49, -1, 132, 49, 49, 49, 49, 49, 49, 49, 49, -1, 30, 49, 49, 49, 49, 49, 49, 49, 49, -1, 31, 49, 49, 49, 49, 49, 49, 49, 49, -1, 154, 49, 49, 49, 49, 49, 49, 49, 49, -1, 225, 49, 49, 49, 49, 49, 49, 49, 49, -1, 208, -1, 226, 49, 49, 49, 49, 49, 49, 49, 49, -1, 221, 49, 49, 49, 49, 49, 49, 49, 49, -1, 244, 49, 49, 49, 49, 49, 49, 49, 49, -1, 240, 49, 49, 49, 49, 49, 49, 49, 49, -1, 236, 49, 49, 49, 49, 49, 49, 49, 49, -1, 218, 49, 49, 49, 49, 49, 49, 49, 49, -1, 216, -1, 33, 49, 49, 49, 49, 49, 49, 49, 49, -1, 239, -1, 222, 49, 49, 49, 49, 49, 49, 49, 49, -1, 172, 49, 49, 49, 49, 49, 49, 49, 49, -1, 34, 49, 49, 49, 49, 49, 49, 49, 49, -1, 36, 49, 49, 49, 49, 49, 49, 49, 49, -1, 210, 49, 49, 49, 49, 49, 49, 49, 49, -1, 37, 49, 49, 49, 49, 49, 49, 49, 49, -1, 41, 49, 49, 49, 49, 49, 49, 49, 49, -1, 45, 49, 49, 49, 49, 49, 49, 49, 49, -1, 241, -1, 246, 49, 49, 49, 49, 49, 49, 49, 49, -1, 237, 49, 49, 49, 49, 49, 49, 49, 49, -1, 247, 49, 49, 49, 49, 49, 49, 49, 49, -1, 248, 49, 49, 49, 49, 49, 49, 49, 49, -1, 249, 49, 49, 49, 49, 49, 49, 49, 49, -1, 252, 49, 49, 49, 49, 49, 49, 49, 49, -1, 253, 49, 49, 49, 49, 49, 49, 49, 49, -1, 257, 49, 49, 49, 49, 49, 49, 49, 49, -1, 254, 49, 49, 49, 49, 49, 49, 49, 49, -1, 259, 49, 49, 49, 49, 49, 49, 49, 49, -1, 255, 49, 49, 49, 49, 49, 49, 49, 49, -1, 261, 49, 49, 49, 49, 49, 49, 49, 49, -1, 258, 49, 49, 49, 49, 49, 49, 49, 49, -1, 260, 49, 49, 49, 49, 49, 49, 49, 49, -1, 262, 49, 49, 49, 49, 49, 49, 49, 49, -1, 263, 49, 49, 49, 49, 49, 49, 49, 49, -1, 266, 49, 49, 49, 49, 49, 49, 49, 49, -1, 264, 49, 49, 49, 49, 49, 49, 49, 49, -1, 268, 49, 49, 49, 49, 49, 49, 49, 49, -1, 265, 49, 49, 49, 49, 49, 49, 49, 49, -1, 270, 49, 49, 49, 49, 49, 49, 49, 49, -1, 269, 49, 49, 49, 49, 49, 49, 49, 49, -1, 271, 49, 49, 49, 49, 49, 49, 49, 49, -1, 273, 49, 49, 49, 49, 49, 49, 49, 49, -1, 274, 49, 49, 49, 49, 49, 49, 49, 49, -1, 1, 2, 6, 3, 3, 3, -1, 4, -1, -1, -1, -1, -1, 5, -1, 2, -1, -1, 1, -1, 1, -1, -1, 1, 2, 5, 3, 3, 3, -1, -1, -1, -1, -1, 4, -1, 1, 2, 3, 4, 9, 10, 11, -1, -1, -1, -1, -1, -1, -1, -1, -1, 5, 6, -1, 12, -1, 13, -1, 14, -1, 15, -1, 16, -1, 7, -1, 18, -1, 8, -1, 19, -1, 17, -1, 3, 4, -1, -1, -1, 5, -1, 6, -1, 7, -1, 8, -1, 9, -1, 1, -1, 11, -1, 2, -1, 12, -1, 10, -1, 1, 2, 3, 4, 5, 6, 7, 8, 31, 9, 10, 11, 12, 13, 32, 14, 33, 15, 16, 17, 18, 19, 20, 34, 21, 22, 22, 22, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 26, -1, -1, -1, 27, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 35, -1, 23, -1, 24, 25, -1, 28, -1, 36, 37, -1, 29, -1, 38, -1, 39, -1, 30, -1, 1, 2, 3, 4, 5, 6, 15, 7, 8, 9, 16, 10, 11, 11, 11, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 12, 13, -1, 14, -1, 1, -1, -1, 1, 2, 3, 4, 28, 5, 29, 31, 33, 35, 96, 37, 98, 39, 41, 43, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, -1, -1, -1, -1, -1, 47, 45, 45, 45, 45, 45, 45, 45, 45, -1, -1, -1, 45, 45, 45, 45, 45, 45, 45, -1, 45, 45, 45, 45, 45, 45, 45, -1, 45, 45, 45, 45, 45, 45, 45, -1, 45, 45, 45, 45, 45, 45, 45, -1, 45, 45, 45, 45, 45, 45, 45, -1, 101, 45, 45, 45, 45, 45, 45, 45, -1, 45, 45, 45, 45, 45, 45, 45, -1, 45, 45, 45, 45, 45, 45, 45, -1, 45, 45, 45, 45, 45, 45, 45, -1, 45, 45, 45, 45, 45, 45, 45, -1, 45, 45, 45, 45, 45, 45, 45, -1, 45, 45, 45, 45, 45, 45, 45, -1, 45, 45, 45, 45, 45, 45, 45, -1, 45, 45, 45, 45, 45, 45, 45, -1, -1, -1, -1, -1, -1, -1, 6, 7, -1, 49, 45, 45, 45, 45, 45, 45, 45, 45, -1, 32, -1, 100, 45, 45, 45, 45, 45, 45, 45, 45, -1, 34, -1, 51, 45, 45, 45, 45, 45, 45, 45, 45, -1, 36, -1, 115, 45, 45, 45, 45, 45, 45, 45, 45, -1, 149, -1, 55, 45, 45, 45, 45, 45, 45, 45, 45, -1, 44, 46, 48, -1, 59, 61, 45, 45, 45, 45, 45, 45, 45, 45, 45, -1, 50, -1, 151, 63, 45, 45, 45, 45, 45, 45, 45, 45, 45, -1, 103, -1, 119, 45, 45, 45, 45, 45, 45, 45, 45, -1, 52, -1, 45, 45, 45, 45, 45, 45, 45, -1, 135, -1, 131, 45, 45, 45, 45, 45, 45, 45, 45, -1, 54, -1, 95, 45, 45, 45, 45, 45, 45, 45, 45, -1, 104, -1, 114, 45, 45, 45, 45, 45, 45, 45, 45, -1, 116, -1, 67, 155, 45, 45, 45, 45, 45, 45, 45, 45, 45, -1, 58, -1, 69, 45, 45, 45, 45, 45, 45, 45, 45, -1, 62, -1, 134, 45, 45, 45, 45, 45, 45, 45, 45, -1, 122, -1, 8, 45, 45, 45, 45, 45, 45, 45, 45, -1, 123, -1, 71, 183, 45, 45, 45, 45, 45, 45, 45, 45, 45, -1, 148, -1, 73, 45, 45, 45, 45, 45, 45, 45, 45, -1, 99, -1, 102, 45, 45, 45, 45, 45, 45, 45, 45, -1, 70, -1, 9, 45, 45, 45, 45, 45, 45, 45, 45, -1, 136, -1, 108, 81, 45, 45, 45, 45, 45, 45, 45, 45, 45, -1, 72, -1, 161, 141, 45, 45, 45, 45, 45, 45, 45, 45, 45, -1, 74, -1, 83, 45, 45, 45, 45, 45, 45, 45, 45, -1, 143, -1, 162, 45, 45, 45, 45, 45, 45, 45, 45, -1, 147, -1, 30, 45, 45, 45, 45, 45, 45, 45, -1, 84, 45, 45, 45, 45, 45, 45, 45, 45, -1, 85, 45, 45, 45, 45, 45, 45, 45, 45, -1, 164, 45, 45, 45, 45, 45, 45, 45, 45, -1, 86, 45, 45, 45, 45, 45, 45, 45, 45, -1, 88, 45, 45, 45, 45, 45, 45, 45, 45, -1, 10, 45, 45, 45, 45, 45, 45, 45, 45, -1, 89, 45, 45, 45, 45, 45, 45, 45, 45, -1, 12, 45, 45, 45, 45, 45, 45, 45, 45, -1, 121, 45, 45, 45, 45, 45, 45, 45, 45, -1, 15, 45, 45, 45, 45, 45, 45, 45, 45, -1, 167, 45, 45, 45, 45, 45, 45, 45, 45, -1, 90, 45, 45, 45, 45, 45, 45, 45, 45, -1, 38, 45, 45, 45, 45, 45, 45, 45, -1, 17, 45, 45, 45, 45, 45, 45, 45, 45, -1, 42, 45, 45, 45, 45, 45, 45, 45, -1, 178, 45, 45, 45, 45, 45, 45, 45, 45, -1, 19, 45, 45, 45, 45, 45, 45, 45, 45, -1, 78, 45, 45, 45, 45, 45, 45, 45, 45, -1, 53, 45, 45, 45, 45, 45, 45, 45, 45, -1, 153, -1, 57, 45, 45, 45, 45, 45, 45, 45, 45, -1, 22, -1, 65, 45, 45, 45, 45, 45, 45, 45, 45, -1, 40, -1, 126, 45, 45, 45, 45, 45, 45, 45, 45, -1, 56, -1, 60, -1, 154, -1, 14, 45, 45, 45, 45, 45, 45, 45, 45, -1, 157, -1, 170, 45, 45, 45, 45, 45, 45, 45, 45, -1, 137, -1, 107, -1, 168, 45, 45, 45, 45, 45, 45, 45, 45, -1, 166, 45, 45, 45, 45, 45, 45, 45, 45, -1, 117, 45, 45, 45, 45, 45, 45, 45, 45, -1, 172, 45, 45, 45, 45, 45, 45, 45, 45, -1, 138, 45, 45, 45, 45, 45, 45, 45, 45, -1, 64, -1, 130, 45, 45, 45, 45, 45, 45, 45, 45, -1, 152, -1, 75, 45, 45, 45, 45, 45, 45, 45, 45, -1, 97, -1, 91, 45, 45, 45, 45, 45, 45, 45, 45, -1, 66, -1, 171, -1, 142, -1, 93, 45, 45, 45, 45, 45, 45, 45, 45, -1, 111, 45, 45, 45, 45, 45, 45, 45, 45, -1, 145, -1, 94, 45, 45, 45, 45, 45, 45, 45, 45, -1, 21, 45, 45, 45, 45, 45, 45, 45, 45, -1, 181, 45, 45, 45, 45, 45, 45, 45, 45, -1, 77, 45, 45, 45, 45, 45, 45, 45, 45, -1, 105, -1, 109, -1, 150, 45, 45, 45, 45, 45, 45, 45, 45, -1, 132, -1, 127, -1, 180, -1, 79, 45, 45, 45, 45, 45, 45, 45, 45, -1, 68, -1, 23, -1, 87, 45, 45, 45, 45, 45, 45, 45, 45, -1, 24, -1, 25, -1, 76, -1, 110, -1, 26, -1, 27, -1, 118, -1, 120, -1, 106, 45, 45, 45, 45, 45, 45, 45, 45, -1, 159, 45, 45, 45, 45, 45, 45, 45, 45, -1, 124, -1, 139, -1, 133, -1, 80, 45, 45, 45, 45, 45, 45, 45, 45, -1, 158, -1, 144, -1, 140, -1, 82, 45, 45, 45, 45, 45, 45, 45, 45, -1, 146, -1, 112, 45, 45, 45, 45, 45, 45, 45, 45, -1, 113, 45, 45, 45, 45, 45, 45, 45, 45, -1, 11, 45, 45, 45, 45, 45, 45, 45, 45, -1, 13, 45, 45, 45, 45, 45, 45, 45, 45, -1, 169, 45, 45, 45, 45, 45, 45, 45, 45, -1, 125, 45, 45, 45, 45, 45, 45, 45, 45, -1, 92, 45, 45, 45, 45, 45, 45, 45, 45, -1, 16, 45, 45, 45, 45, 45, 45, 45, 45, -1, 128, 45, 45, 45, 45, 45, 45, 45, 45, -1, 165, 45, 45, 45, 45, 45, 45, 45, 45, -1, 156, -1, 163, 45, 45, 45, 45, 45, 45, 45, 45, -1, 176, 45, 45, 45, 45, 45, 45, 45, 45, -1, 173, 45, 45, 45, 45, 45, 45, 45, 45, -1, 160, -1, 18, 45, 45, 45, 45, 45, 45, 45, 45, -1, 175, -1, 20, 45, 45, 45, 45, 45, 45, 45, 45, -1, 129, 45, 45, 45, 45, 45, 45, 45, 45, -1, 177, -1, 179, 45, 45, 45, 45, 45, 45, 45, 45, -1, 174, 45, 45, 45, 45, 45, 45, 45, 45, -1, 182, 45, 45, 45, 45, 45, 45, 45, 45, -1, 1, 2, 3, 4, 5, 14, 15, 6, 7, 16, 8, 8, 8, -1, -1, -1, -1, -1, -1, 12, -1, -1, -1, -1, -1, -1, -1, -1, 9, -1, 10, 11, -1, 13, -1, 1, 2, 3, 4, 8, 5, 5, 5, -1, -1, -1, -1, -1, -1, -1, -1, 6, 7, -1, 1, 2, 3, 4, 5, 6, 7, 8, 32, 9, 10, 11, 12, 13, 33, 14, 34, 15, 16, 17, 18, 19, 20, 21, 35, 22, 23, 23, 23, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 27, -1, -1, -1, 28, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 36, -1, 24, -1, 25, 26, -1, 29, -1, 37, 38, -1, 30, -1, 39, -1, 40, -1, 31, -1, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 25, 25, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 27, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1, 20, 22, 24, 83, 26, 85, 28, 30, 32, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, -1, 36, 34, 34, 34, 34, 34, 34, 34, 34, -1, 34, 34, 34, 34, 34, 34, 34, -1, 34, 34, 34, 34, 34, 34, 34, -1, 34, 34, 34, 34, 34, 34, 34, -1, 34, 34, 34, 34, 34, 34, 34, -1, 86, 34, 34, 34, 34, 34, 34, 34, -1, 34, 34, 34, 34, 34, 34, 34, -1, 34, 34, 34, 34, 34, 34, 34, -1, 34, 34, 34, 34, 34, 34, 34, -1, 34, 34, 34, 34, 34, 34, 34, -1, 34, 34, 34, 34, 34, 34, 34, -1, 34, 34, 34, 34, 34, 34, 34, -1, -1, -1, -1, -1, -1, -1, 21, -1, 38, 34, 34, 34, 34, 34, 34, 34, 34, -1, 23, -1, 87, 34, 34, 34, 34, 34, 34, 34, 34, -1, 25, -1, 40, 34, 34, 34, 34, 34, 34, 34, 34, -1, 139, -1, 44, 34, 34, 34, 34, 34, 34, 34, 34, -1, 33, 35, 37, -1, 48, 50, 34, 34, 34, 34, 34, 34, 34, 34, 34, -1, 39, -1, 140, 52, 34, 34, 34, 34, 34, 34, 34, 34, 34, -1, 89, -1, 104, 34, 34, 34, 34, 34, 34, 34, 34, -1, 41, -1, 34, 34, 34, 34, 34, 34, 34, -1, 115, -1, 100, 34, 34, 34, 34, 34, 34, 34, 34, -1, 43, -1, 81, 34, 34, 34, 34, 34, 34, 34, 34, -1, 90, -1, 98, 34, 34, 34, 34, 34, 34, 34, 34, -1, 99, -1, 56, 113, 34, 34, 34, 34, 34, 34, 34, 34, 34, -1, 47, -1, 111, 34, 34, 34, 34, 34, 34, 34, 34, -1, 51, -1, 116, 34, 34, 34, 34, 34, 34, 34, 34, -1, 106, -1, 2, 34, 34, 34, 34, 34, 34, 34, 34, -1, 107, -1, 58, 156, 34, 34, 34, 34, 34, 34, 34, 34, 34, -1, 138, -1, 60, 34, 34, 34, 34, 34, 34, 34, 34, -1, 84, -1, 88, 34, 34, 34, 34, 34, 34, 34, 34, -1, 59, -1, 3, 34, 34, 34, 34, 34, 34, 34, 34, -1, 118, -1, 125, 34, 34, 34, 34, 34, 34, 34, 34, -1, 61, -1, 70, 34, 34, 34, 34, 34, 34, 34, 34, -1, 63, -1, 127, 34, 34, 34, 34, 34, 34, 34, 34, -1, 126, -1, 19, 34, 34, 34, 34, 34, 34, 34, -1, 132, -1, 71, 34, 34, 34, 34, 34, 34, 34, 34, -1, 133, 34, 34, 34, 34, 34, 34, 34, 34, -1, 72, 34, 34, 34, 34, 34, 34, 34, 34, -1, 75, 34, 34, 34, 34, 34, 34, 34, 34, -1, 4, 34, 34, 34, 34, 34, 34, 34, 34, -1, 76, 34, 34, 34, 34, 34, 34, 34, 34, -1, 117, 34, 34, 34, 34, 34, 34, 34, 34, -1, 7, 34, 34, 34, 34, 34, 34, 34, 34, -1, 8, 34, 34, 34, 34, 34, 34, 34, 34, -1, 134, 34, 34, 34, 34, 34, 34, 34, 34, -1, 77, 34, 34, 34, 34, 34, 34, 34, 34, -1, 27, 34, 34, 34, 34, 34, 34, 34, -1, 10, 34, 34, 34, 34, 34, 34, 34, 34, -1, 31, 34, 34, 34, 34, 34, 34, 34, -1, 137, 34, 34, 34, 34, 34, 34, 34, 34, -1, 66, 34, 34, 34, 34, 34, 34, 34, 34, -1, 142, -1, 42, 34, 34, 34, 34, 34, 34, 34, 34, -1, 13, -1, 46, 34, 34, 34, 34, 34, 34, 34, 34, -1, 29, -1, 54, 34, 34, 34, 34, 34, 34, 34, 34, -1, 93, 34, 34, 34, 34, 34, 34, 34, 34, -1, 45, -1, 49, -1, 143, -1, 147, -1, 96, 34, 34, 34, 34, 34, 34, 34, 34, -1, 119, -1, 92, -1, 135, 34, 34, 34, 34, 34, 34, 34, 34, -1, 102, 34, 34, 34, 34, 34, 34, 34, 34, -1, 144, 34, 34, 34, 34, 34, 34, 34, 34, -1, 53, -1, 64, 34, 34, 34, 34, 34, 34, 34, 34, -1, 141, -1, 120, 34, 34, 34, 34, 34, 34, 34, 34, -1, 82, -1, 62, 34, 34, 34, 34, 34, 34, 34, 34, -1, 73, 34, 34, 34, 34, 34, 34, 34, 34, -1, 55, -1, 150, -1, 124, -1, 129, -1, 12, 34, 34, 34, 34, 34, 34, 34, 34, -1, 68, 34, 34, 34, 34, 34, 34, 34, 34, -1, 91, -1, 67, 34, 34, 34, 34, 34, 34, 34, 34, -1, 94, -1, 112, -1, 105, 34, 34, 34, 34, 34, 34, 34, 34, -1, 78, 34, 34, 34, 34, 34, 34, 34, 34, -1, 109, -1, 154, -1, 80, 34, 34, 34, 34, 34, 34, 34, 34, -1, 57, -1, 69, 34, 34, 34, 34, 34, 34, 34, 34, -1, 14, -1, 15, -1, 74, 34, 34, 34, 34, 34, 34, 34, 34, -1, 16, -1, 97, 34, 34, 34, 34, 34, 34, 34, 34, -1, 65, -1, 95, -1, 5, 34, 34, 34, 34, 34, 34, 34, 34, -1, 17, -1, 18, -1, 6, 34, 34, 34, 34, 34, 34, 34, 34, -1, 79, 34, 34, 34, 34, 34, 34, 34, 34, -1, 9, 34, 34, 34, 34, 34, 34, 34, 34, -1, 11, 34, 34, 34, 34, 34, 34, 34, 34, -1, 110, 34, 34, 34, 34, 34, 34, 34, 34, -1, 101, -1, 103, -1, 122, 34, 34, 34, 34, 34, 34, 34, 34, -1, 108, -1, 121, -1, 114, -1, 130, 34, 34, 34, 34, 34, 34, 34, 34, -1, 136, 34, 34, 34, 34, 34, 34, 34, 34, -1, 148, -1, 128, -1, 123, -1, 131, -1, 146, -1, 145, 34, 34, 34, 34, 34, 34, 34, 34, -1, 149, -1, 152, -1, 153, -1, 151, 34, 34, 34, 34, 34, 34, 34, 34, -1, 155, 34, 34, 34, 34, 34, 34, 34, 34, -1, 1, 1, 1, -1, -1, 1, 2, 3, 4, 13, 14, 15, 16, -1, -1, -1, -1, -1, -1, -1, 36, -1, -1, -1, -1, -1, -1, 5, 6, -1, 29, -1, 17, -1, 18, 43, -1, 20, -1, 33, -1, 21, -1, 55, -1, 23, -1, 31, -1, 35, -1, 7, -1, 27, -1, 28, -1, 39, -1, 65, 62, -1, 19, -1, 22, -1, 25, -1, 24, -1, 37, -1, 38, -1, 26, -1, 34, -1, 32, -1, 10, -1, 8, -1, 9, -1, 11, -1, 12, -1, 30, -1, 40, -1, 41, -1, 42, -1, 44, -1, 47, -1, 45, -1, 49, -1, 46, -1, 51, -1, 48, -1, 53, -1, 54, -1, 50, -1, 56, -1, 57, -1, 52, -1, 59, -1, 60, -1, 58, -1, 61, -1, 63, -1, 64, -1, 1, 2, 3, 4, 5, 6, 10, 7, 7, 7, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 8, 9, -1, 7, 8, 9, -1, 29, -1, -1, -1, -1, -1, -1, 22, -1, 10, -1, 11, 36, -1, 13, -1, 26, -1, 14, -1, 48, -1, 16, -1, 24, -1, 28, -1, 1, -1, 20, -1, 21, -1, 32, -1, 58, 55, -1, 12, -1, 15, -1, 18, -1, 17, -1, 30, -1, 31, -1, 19, -1, 27, -1, 25, -1, 4, -1, 2, -1, 3, -1, 5, -1, 6, -1, 23, -1, 33, -1, 34, -1, 35, -1, 37, -1, 40, -1, 38, -1, 42, -1, 39, -1, 44, -1, 41, -1, 46, -1, 47, -1, 43, -1, 49, -1, 50, -1, 45, -1, 52, -1, 53, -1, 51, -1, 54, -1, 56, -1, 57, -1, 1, 2, 3, 3, 3, -1, -1, -1, -1, 1, 2, 3, 4, 13, 14, 5, 6, 15, 7, 7, 7, -1, -1, -1, -1, -1, 11, -1, -1, -1, -1, -1, -1, -1, -1, 8, -1, 9, 10, -1, 12, -1, 2, -1, -1, 1, -1, 1, 2, 3, 4, 5, 6, 7, 8, 14, 9, 10, 11, 11, 11, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 12, 13, -1, 1, 2, 3, 4, 5, 6, 9, -1, -1, -1, -1, -1, -1, -1, -1, -1, 7, 8, -1, 1, 2, 3, 4, 9, 5, 10, -1, -1, -1, -1, -1, -1, -1, -1, -1, 6, 7, -1, 8, -1, 1, 2, 3, 4, 9, 5, 6, -1, -1, -1, -1, -1, -1, -1, -1, -1, 7, 8, -1, 1, 2, 3, 4, 10, 5, 11, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 6, 7, -1, 12, 8, -1, 9, -1, 1, 2, 3, 4, 8, 9, -1, -1, -1, -1, -1, -1, -1, -1, 5, 6, -1, 7, -1, 1, 2, 3, 4, 8, 5, 5, 5, 5, 5, 5, 5, -1, -1, -1, -1, -1, 5, 5, 5, 5, 5, 5, 5, -1, -1, -1, 6, 7, -1, 1, 1, 1, 1, 1, 1, 1, -1, 1, 1, 1, 1, 1, 1, 1, -1, 1, 2, -1, -1, -1, 1, 3, -1, -1, -1, 2, -1, 1, 4, -1, -1, -1, -1, 5, 2, -1, 3, -1, 2, -1, -1, 1, -1, 1, 2, 3, 4, 5, 6, 7, 8, 9, 14, 10, 11, 11, 11, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 12, 13, -1, 1, 2, 3, 4, 8, 5, -1, -1, -1, -1, -1, -1, -1, -1, 6, 7, -1, 1, 2, 3, 4, 5, 6, 7, 22, 8, 9, 10, 23, 11, 12, 13, 14, 24, 15, 16, 16, 16, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 25, -1, 17, 18, -1, 19, -1, 26, 27, -1, 20, -1, 28, -1, 29, -1, 21, -1, 1, 2, 3, 4, 5, 6, 7, 26, 8, 9, 10, 11, 12, 13, 27, 14, 15, 16, 17, 18, 28, 19, 20, 20, 20, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 29, -1, 21, 22, -1, 23, -1, 30, 31, -1, 24, -1, 32, -1, 33, -1, 25, -1, 1, 2, 3, 4, 5, 6, -1, -1, -1, -1, -1, -1, -1, 1, 2, 3, 4, 12, 13, 5, 6, 14, -1, -1, -1, -1, -1, 10, -1, -1, -1, -1, -1, -1, -1, 7, -1, 8, 9, -1, 11, -1, 1, 2, 3, 4, 5, 6, 7, 26, 8, 9, 10, 11, 12, 27, 13, 14, 15, 16, 17, 18, 28, 19, 20, 20, 20, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 29, -1, 21, 22, -1, 23, -1, 30, 31, -1, 24, -1, 32, -1, 33, -1, 25, -1, 1, 2, 3, 4, 5, 6, 7, 8, 17, 9, 18, 10, 11, 19, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 15, -1, -1, -1, -1, -1, -1, -1, 12, -1, 13, 14, -1, 16, -1, 1, 2, 3, 4, 5, 6, 7, 8, 15, 9, 10, 11, 12, 12, 12, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 13, 14, -1, 1, -1, -1, 1, -1, -1, 1, 2, 3, 4, 5, 6, 11, 7, 8, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 9, 10, -1, 1, 2, 3, 4, 5, -1, -1, -1, -1, -1, -1, 5, 1, 6, -1, 3, -1, -1, -1, -1, 2, -1, 4, -1, 1, 2, 3, 4, 5, 6, 7, 8, 16, 9, 17, 18, 10, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 11, 12, -1, 13, -1, 19, 14, -1, 15, -1, 1, 2, 3, 7, 8, -1, -1, -1, -1, -1, -1, -1, 4, -1, 9, 5, -1, 6, -1, 1, 2, 3, 4, 5, 6, 7, 22, 8, 9, 10, 11, 23, 12, 13, 14, 24, 15, 16, 16, 16, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 25, -1, 17, 18, -1, 19, -1, 26, 27, -1, 20, -1, 28, -1, 29, -1, 21, -1, 1, 2, 3, 4, 5, 6, 7, 21, 8, 9, 10, 22, 11, 12, 13, 23, 14, 15, 15, 15, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 24, -1, 16, 17, -1, 18, -1, 25, 26, -1, 19, -1, 27, -1, 28, -1, 20, -1, 1, 2, 3, 5, -1, -1, -1, -1, -1, 4, -1, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 21, 14, 15, 16, 22, 17, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 18, 19, -1, 20, -1, 1, 2, 3, 4, 7, 5, -1, -1, -1, -1, -1, -1, -1, 6, -1, 1, 2, 3, 4, 5, 6, 7, 8, 9, 12, 10, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 11, -1, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 15, 13, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 14, -1, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 25, 25, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1, 2, 3, 4, 5, 6, 7, 21, 8, 9, 22, 10, 11, 12, 13, 23, 14, 15, 15, 15, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 24, -1, 16, 17, -1, 18, -1, 25, 26, -1, 19, -1, 27, -1, 28, -1, 20, -1, 1, 2, 3, -1, -1, -1, -1, 1, 2, 3, 4, 5, 6, 7, 23, 8, 9, 10, 11, 24, 12, 13, 14, 15, 25, 16, 17, 17, 17, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 26, -1, 18, 19, -1, 20, -1, 27, 28, -1, 21, -1, 29, -1, 30, -1, 22, -1, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 18, 12, 13, 19, 14, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 15, 16, -1, 17, -1, 1, -1, -1, 1, 2, -1, -1, -1, 1, 2, -1, -1, -1, 1, 2, -1, -1, -1, 1, 2, 3, 4, 5, 6, 7, 27, 8, 9, 10, 11, 12, 13, 28, 14, 15, 16, 17, 18, 19, 29, 20, 21, 21, 21, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 30, -1, 22, 23, -1, 24, -1, 31, 32, -1, 25, -1, 33, -1, 34, -1, 26, -1, 1, 2, 3, 4, 5, 6, 7, 23, 8, 9, 10, 24, 11, 12, 13, 14, 15, 25, 16, 17, 17, 17, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 26, -1, 18, 19, -1, 20, -1, 27, 28, -1, 21, -1, 29, -1, 30, -1, 22, -1, 1, 5, 6, 7, 7, 7, 7, 7, 7, 7, 7, 7, -1, 8, 7, 7, 7, 7, 7, 7, 7, 7, -1, 7, 7, 7, 7, 7, 7, 7, -1, 7, 7, 7, 7, 7, 7, 7, -1, 7, 7, 7, 7, 7, 7, 7, -1, 9, 7, 7, 7, 7, 7, 7, 7, 7, -1, 10, 7, 7, 7, 7, 7, 7, 7, 7, -1, 7, 7, 7, 7, 7, 7, 7, -1, 17, 7, 7, 7, 7, 7, 7, 7, 7, -1, 11, 7, 7, 7, 7, 7, 7, 7, 7, -1, 12, 7, 7, 7, 7, 7, 7, 7, 7, -1, 14, 7, 7, 7, 7, 7, 7, 7, 7, -1, 20, 7, 7, 7, 7, 7, 7, 7, 7, -1, 15, 7, 7, 7, 7, 7, 7, 7, 7, -1, 23, 7, 7, 7, 7, 7, 7, 7, 7, -1, 2, 7, 7, 7, 7, 7, 7, 7, 7, -1, 4, 7, 7, 7, 7, 7, 7, 7, 7, -1, 13, 7, 7, 7, 7, 7, 7, 7, 7, -1, 3, 7, 7, 7, 7, 7, 7, 7, 7, -1, 16, 7, 7, 7, 7, 7, 7, 7, 7, -1, 18, 7, 7, 7, 7, 7, 7, 7, 7, -1, 22, 7, 7, 7, 7, 7, 7, 7, 7, -1, 19, 7, 7, 7, 7, 7, 7, 7, 7, -1, 21, 7, 7, 7, 7, 7, 7, 7, 7, -1, 1, 2, 3, 4, 5, -1, -1, -1, -1, -1, -1, 1, 2, 3, 4, 5, 9, 6, -1, -1, -1, -1, -1, -1, -1, -1, -1, 7, 8, -1, 1, 2, 3, 4, -1, -1, -1, -1, -1, 1, 4, 5, 5, 5, 5, 5, 5, 5, 5, -1, 6, 5, 5, 5, 5, 5, 5, 5, 5, -1, 5, 5, 5, 5, 5, 5, 5, -1, 5, 5, 5, 5, 5, 5, 5, -1, 7, 5, 5, 5, 5, 5, 5, 5, 5, -1, 5, 5, 5, 5, 5, 5, 5, -1, 8, 5, 5, 5, 5, 5, 5, 5, 5, -1, 9, 5, 5, 5, 5, 5, 5, 5, 5, -1, 10, 5, 5, 5, 5, 5, 5, 5, 5, -1, 14, 5, 5, 5, 5, 5, 5, 5, 5, -1, 11, 5, 5, 5, 5, 5, 5, 5, 5, -1, 2, 5, 5, 5, 5, 5, 5, 5, 5, -1, 15, 5, 5, 5, 5, 5, 5, 5, 5, -1, 17, 5, 5, 5, 5, 5, 5, 5, 5, -1, 12, 5, 5, 5, 5, 5, 5, 5, 5, -1, 13, 5, 5, 5, 5, 5, 5, 5, 5, -1, 3, 5, 5, 5, 5, 5, 5, 5, 5, -1, 16, 5, 5, 5, 5, 5, 5, 5, 5, -1, 1, 2, 3, 4, 8, 9, -1, -1, -1, -1, -1, -1, -1, -1, 5, -1, 10, 6, -1, 7, -1, 1, 2, 3, 4, 5, 6, 7, 11, 8, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 9, 10, -1, 1, 2, 3, 4, -1, -1, -1, -1, -1, 1, 2, 3, 4, 5, 10, 11, 6, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 7, -1, 12, 8, -1, 9, -1
};

/* DFA acception states */
UNICC_STATIC int _dfa_accept[ 81 ][ 276 ] =
{
	{ 0, 48, 47, 46, 49, 69, 67, 51, 43, 4, 2, 5, 0, 0 },
	{ 0, 48, 47, 46, 49, 57, 54, 69, 66, 56, 63, 62, 61, 60, 58, 50, 68, 70, 53, 64, 52, 59, 67, 55, 65, 51, 45, 3 },
	{ 0, 44, 48, 47, 46, 49, 57, 54, 69, 66, 56, 63, 62, 61, 60, 58, 50, 68, 70, 53, 64, 52, 59, 67, 55, 65, 51, 45 },
	{ 0, 48, 47, 46, 49, 57, 54, 41, 56, 70, 43, 14, 4, 2, 12, 13, 5, 16, 15, 18, 7, 30, 29, 8, 31, 11, 32, 17, 27, 34, 19, 40, 28, 20, 38, 10, 9, 35, 37, 33, 26, 39, 23, 21, 24, 36, 25, 22, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 0, 41, 0, 0, 0, 41, 41, 0, 41, 41, 0, 0, 0, 0, 41, 41, 41, 41, 41, 41, 41, 41, 0, 41, 0, 0, 0, 41, 0, 41, 41, 0, 0, 41, 41, 41, 41, 0, 41, 0, 0, 0, 41, 0, 41, 41, 41, 41, 0, 41, 0, 0, 0, 41, 41, 41, 41, 0, 0, 41, 41, 0, 0, 41, 0, 0, 41, 0, 0, 0, 41, 41, 0, 41, 41, 41, 0, 0, 41, 41, 0, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 0, 41, 41, 41, 41, 41, 41, 0, 41, 0, 41, 41, 41, 41, 41, 41, 41, 41, 0, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41 },
	{ 0, 69, 67, 51, 43, 5, 0 },
	{ 0, 3, 0 },
	{ 0, 47 },
	{ 0, 69, 67, 51, 5, 0 },
	{ 0, 48, 47, 46, 49, 4, 2, 42, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 0, 42, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 0, 48, 47, 46, 49, 57, 54, 69, 66, 56, 63, 62, 61, 60, 58, 68, 70, 53, 64, 59, 67, 65, 51, 14, 4, 2, 12, 13, 5, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 0, 48, 47, 46, 49, 69, 62, 70, 64, 67, 65, 51, 4, 2, 5, 0, 0 },
	{ 0, 70 },
	{ 0, 48, 47, 46, 49, 41, 4, 2, 18, 30, 29, 31, 11, 32, 17, 27, 19, 28, 20, 10, 9, 33, 26, 23, 21, 24, 25, 22, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 0, 41, 0, 41, 0, 41, 0, 0, 0, 41, 0, 41, 0, 0, 41, 41, 41, 41, 41, 0, 41, 0, 41, 0, 41, 0, 0, 0, 41, 41, 0, 41, 41, 41, 41, 0, 0, 41, 0, 0, 0, 41, 0, 0, 41, 0, 0, 0, 0, 0, 0, 0, 0, 41, 41, 0, 0, 0, 41, 0, 0, 0, 41, 0, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 0, 41, 41, 41, 0, 41, 0, 41, 41, 0, 41, 41, 41 },
	{ 0, 48, 47, 46, 49, 66, 68, 53, 51, 14, 4, 2, 12, 13, 0, 0, 0 },
	{ 0, 48, 47, 46, 49, 51, 4, 2, 0 },
	{ 0, 48, 47, 46, 49, 57, 54, 69, 66, 56, 63, 62, 61, 60, 58, 50, 68, 70, 53, 64, 59, 67, 65, 51, 14, 4, 2, 12, 13, 5, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 0, 48, 47, 46, 49, 57, 54, 69, 66, 56, 63, 62, 61, 60, 58, 50, 68, 70, 53, 64, 52, 59, 67, 55, 65, 51, 45, 6 },
	{ 0, 41, 18, 30, 29, 31, 32, 17, 27, 19, 28, 20, 33, 26, 23, 21, 24, 25, 22, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 0, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 0, 41, 0, 41, 0, 41, 41, 0, 0, 0, 0, 41, 0, 0, 41, 41, 41, 0, 41, 0, 41, 0, 41, 41, 0, 0, 0, 0, 41, 41, 0, 41, 0, 0, 41, 41, 0, 0, 41, 0, 41, 0, 0, 41, 0, 41, 0, 0, 41, 0, 0, 41, 41, 41, 41, 41, 0, 0, 41, 0, 0, 0, 41, 41, 0, 0, 0, 0, 0, 41, 0, 0, 0, 41, 41 },
	{ 0, 51 },
	{ 0, 48, 47, 46, 49, 4, 2, 34, 38, 35, 37, 39, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 0, 48, 47, 46, 49, 54, 56, 51, 4, 2, 0 },
	{ 0, 34, 38, 35, 37, 39, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 0, 54, 56, 51 },
	{ 0, 48, 47, 46, 49, 68, 53, 51, 14, 4, 2, 12, 13, 0, 0, 0 },
	{ 0, 6, 0 },
	{ 0, 48, 47, 46, 49, 57, 54, 56, 63, 53, 67, 51, 4, 2, 0 },
	{ 0, 48, 47, 46, 49, 54, 56, 4, 2, 0 },
	{ 0, 48, 47, 46, 49, 70, 4, 2, 5, 0, 0 },
	{ 0, 48, 47, 46, 49, 70, 53, 4, 2, 0 },
	{ 0, 48, 47, 46, 49, 70, 4, 2, 16, 15, 0, 0, 0 },
	{ 0, 48, 47, 46, 49, 4, 2, 5, 0, 0 },
	{ 0, 48, 47, 46, 49, 41, 4, 2, 0 },
	{ 0, 41 },
	{ 0, 54, 56 },
	{ 0, 70, 5, 0 },
	{ 0, 70, 16, 15, 0, 0 },
	{ 0, 5, 0 },
	{ 0, 48, 47, 46, 49, 57, 54, 56, 63, 58, 53, 51, 4, 2, 0 },
	{ 0, 48, 47, 46, 49, 70, 4, 2, 0 },
	{ 0, 48, 47, 46, 49, 57, 54, 69, 56, 63, 62, 70, 53, 64, 67, 65, 51, 4, 2, 5, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 0, 48, 47, 46, 49, 57, 54, 69, 56, 63, 62, 61, 60, 58, 70, 53, 64, 59, 67, 65, 51, 4, 2, 5, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 0, 54, 69, 56, 62, 70, 65 },
	{ 0, 48, 47, 46, 49, 68, 53, 14, 4, 2, 12, 13, 0, 0, 0 },
	{ 0, 48, 47, 46, 49, 57, 54, 69, 56, 63, 62, 61, 60, 68, 70, 53, 64, 59, 67, 65, 51, 4, 2, 5, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 0, 48, 47, 46, 49, 57, 54, 56, 63, 58, 68, 70, 14, 4, 2, 12, 13, 0, 0, 0 },
	{ 0, 48, 47, 46, 49, 57, 54, 56, 63, 70, 53, 67, 51, 4, 2, 0 },
	{ 0, 56 },
	{ 0, 63 },
	{ 0, 48, 47, 46, 49, 69, 62, 70, 65, 4, 2, 0 },
	{ 0, 57, 54, 56, 63, 58 },
	{ 0, 68, 14, 12, 13, 0, 0 },
	{ 0, 48, 47, 46, 49, 54, 69, 56, 62, 70, 65, 4, 2, 5, 16, 15, 0, 0, 0, 0 },
	{ 0, 54, 56, 70, 5, 16, 15, 0, 0, 0 },
	{ 0, 48, 47, 46, 49, 57, 54, 69, 56, 63, 62, 58, 53, 64, 67, 65, 51, 4, 2, 5, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 0, 48, 47, 46, 49, 57, 54, 69, 56, 63, 62, 53, 64, 67, 65, 51, 4, 2, 5, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 0, 69, 70, 64, 5, 0 },
	{ 0, 48, 47, 46, 49, 57, 54, 69, 56, 63, 62, 61, 60, 58, 70, 64, 59, 65, 4, 2, 5, 0, 0 },
	{ 0, 69, 62, 70, 64, 65, 5, 0 },
	{ 0, 57, 54, 69, 56, 63, 62, 58, 70, 64, 65, 5, 0 },
	{ 0, 57, 54, 69, 56, 63, 62, 61, 60, 58, 70, 64, 59, 65, 5, 0 },
	{ 0, 48, 47, 46, 49, 57, 54, 69, 66, 56, 63, 62, 61, 60, 58, 50, 68, 70, 53, 64, 52, 59, 67, 55, 65, 51, 45 },
	{ 0, 48, 47, 46, 49, 57, 54, 69, 56, 63, 70, 53, 64, 67, 65, 51, 4, 2, 5, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 0, 69, 70, 64 },
	{ 0, 48, 47, 46, 49, 57, 54, 69, 56, 63, 62, 58, 70, 53, 64, 67, 65, 51, 4, 2, 5, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 0, 48, 47, 46, 49, 57, 54, 69, 56, 63, 62, 58, 70, 64, 65, 4, 2, 5, 0, 0 },
	{ 0, 62 },
	{ 0, 70, 65 },
	{ 0, 62, 65 },
	{ 0, 69, 70 },
	{ 0, 48, 47, 46, 49, 57, 54, 69, 56, 63, 62, 61, 60, 58, 68, 70, 53, 64, 59, 67, 65, 51, 4, 2, 5, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 0, 48, 47, 46, 49, 57, 54, 69, 56, 63, 62, 68, 70, 53, 64, 67, 65, 51, 4, 2, 5, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 0, 41, 11, 17, 10, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41 },
	{ 0, 69, 62, 70, 64, 65 },
	{ 0, 48, 47, 46, 49, 69, 70, 4, 2, 0 },
	{ 0, 69, 62, 70, 65 },
	{ 0, 41, 17, 9, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41 },
	{ 0, 54, 69, 56, 70, 5, 16, 15, 0, 0, 0 },
	{ 0, 48, 47, 46, 49, 57, 54, 56, 67, 4, 2, 0 },
	{ 0, 57, 54, 56, 67 },
	{ 0, 54, 69, 56, 62, 70, 65, 5, 16, 15, 0, 0, 0 }
};

#endif

/* Symbol information table */
UNICC_STATIC _syminfo _symbols[] =
{
	{ /* 0 */ "&eof", "", 3, 0, 0, 1 },
	{ /* 1 */ "//", "//", 2, 0, 0, 1 },
	{ /* 2 */ "*/", "*/", 2, 0, 0, 1 },
	{ /* 3 */ "/*", "/*", 2, 0, 0, 1 },
	{ /* 4 */ "[*", "[*", 2, 0, 0, 1 },
	{ /* 5 */ "*]", "*]", 2, 0, 0, 1 },
	{ /* 6 */ "&eof", "&eof", 2, 0, 0, 1 },
	{ /* 7 */ "&error", "&error", 2, 0, 0, 1 },
	{ /* 8 */ "precedence", "precedence", 2, 0, 0, 1 },
	{ /* 9 */ "non-greedy", "non-greedy", 2, 0, 0, 1 },
	{ /* 10 */ "greedy", "greedy", 2, 0, 0, 1 },
	{ /* 11 */ ":=", ":=", 2, 0, 0, 1 },
	{ /* 12 */ "=>", "=>", 2, 0, 0, 1 },
	{ /* 13 */ "->", "->", 2, 0, 0, 1 },
	{ /* 14 */ "off", "off", 2, 0, 0, 1 },
	{ /* 15 */ "on", "on", 2, 0, 0, 1 },
	{ /* 16 */ "option", "option", 2, 0, 0, 1 },
	{ /* 17 */ "pcb", "pcb", 2, 0, 0, 1 },
	{ /* 18 */ "epilogue", "epilogue", 2, 0, 0, 1 },
	{ /* 19 */ "prologue", "prologue", 2, 0, 0, 1 },
	{ /* 20 */ "reserve terminals", "reserve terminals", 2, 0, 0, 1 },
	{ /* 21 */ "case insensitive strings", "case insensitive strings", 2, 0, 0, 1 },
	{ /* 22 */ "lexeme separation", "lexeme separation", 2, 0, 0, 1 },
	{ /* 23 */ "default value type", "default value type", 2, 0, 0, 1 },
	{ /* 24 */ "default epsilon action", "default epsilon action", 2, 0, 0, 1 },
	{ /* 25 */ "default action", "default action", 2, 0, 0, 1 },
	{ /* 26 */ "prefix", "prefix", 2, 0, 0, 1 },
	{ /* 27 */ "nonassoc", "nonassoc", 2, 0, 0, 1 },
	{ /* 28 */ "right", "right", 2, 0, 0, 1 },
	{ /* 29 */ "left", "left", 2, 0, 0, 1 },
	{ /* 30 */ "fixate", "fixate", 2, 0, 0, 1 },
	{ /* 31 */ "lexeme", "lexeme", 2, 0, 0, 1 },
	{ /* 32 */ "whitespaces", "whitespaces", 2, 0, 0, 1 },
	{ /* 33 */ "scanner", "scanner", 2, 0, 0, 1 },
	{ /* 34 */ "insensitive", "insensitive", 2, 0, 0, 1 },
	{ /* 35 */ "context-insensitive", "context-insensitive", 2, 0, 0, 1 },
	{ /* 36 */ "scannerless", "scannerless", 2, 0, 0, 1 },
	{ /* 37 */ "sensitive", "sensitive", 2, 0, 0, 1 },
	{ /* 38 */ "context-sensitive", "context-sensitive", 2, 0, 0, 1 },
	{ /* 39 */ "language", "language", 2, 0, 0, 1 },
	{ /* 40 */ "USERDEF", "", 2, 0, 0, 1 },
	{ /* 41 */ "mode", "mode", 2, 0, 0, 1 },
	{ /* 42 */ "#!", "#!", 2, 0, 0, 1 },
	{ /* 43 */ "\\x0", "", 1, 0, 0, 1 },
	{ /* 44 */ "\\x1-\\b\\v-\\f\\xE-\\x1F%-&,--/[]-^`{}-\\uFFFF", "", 1, 0, 0, 1 },
	{ /* 45 */ "\\r", "", 1, 0, 0, 1 },
	{ /* 46 */ "\\n", "", 1, 0, 0, 1 },
	{ /* 47 */ "\\t", "", 1, 0, 0, 1 },
	{ /* 48 */ " ", "", 1, 0, 0, 1 },
	{ /* 49 */ "0-9", "", 1, 0, 0, 1 },
	{ /* 50 */ "A-Z_a-z", "", 1, 0, 0, 1 },
	{ /* 51 */ ">", "", 1, 0, 0, 1 },
	{ /* 52 */ "<", "", 1, 0, 0, 1 },
	{ /* 53 */ "\"", "", 1, 0, 0, 1 },
	{ /* 54 */ "\\\\", "", 1, 0, 0, 1 },
	{ /* 55 */ "'", "", 1, 0, 0, 1 },
	{ /* 56 */ "!", "", 1, 0, 0, 1 },
	{ /* 57 */ ".", "", 1, 0, 0, 1 },
	{ /* 58 */ "?", "", 1, 0, 0, 1 },
	{ /* 59 */ "+", "", 1, 0, 0, 1 },
	{ /* 60 */ "*", "", 1, 0, 0, 1 },
	{ /* 61 */ ")", "", 1, 0, 0, 1 },
	{ /* 62 */ "(", "", 1, 0, 0, 1 },
	{ /* 63 */ "=", "", 1, 0, 0, 1 },
	{ /* 64 */ "|", "", 1, 0, 0, 1 },
	{ /* 65 */ "$", "", 1, 0, 0, 1 },
	{ /* 66 */ "@", "", 1, 0, 0, 1 },
	{ /* 67 */ ":", "", 1, 0, 0, 1 },
	{ /* 68 */ "#", "", 1, 0, 0, 1 },
	{ /* 69 */ ";", "", 1, 0, 0, 1 },
	{ /* 70 */ "\\x0##", "", 0, 0, 0, 1 },
	{ /* 71 */ ":-;#", "", 0, 0, 0, 1 },
	{ /* 72 */ "\\x0#@#", "", 0, 0, 0, 1 },
	{ /* 73 */ "$:-;#", "", 0, 0, 0, 1 },
	{ /* 74 */ "\\x0#@|#", "", 0, 0, 0, 1 },
	{ /* 75 */ "$:-;=#", "", 0, 0, 0, 1 },
	{ /* 76 */ "\\x0#(@|#", "", 0, 0, 0, 1 },
	{ /* 77 */ "$):-;=#", "", 0, 0, 0, 1 },
	{ /* 78 */ "\\x0#(*@|#", "", 0, 0, 0, 1 },
	{ /* 79 */ "$)+:-;=#", "", 0, 0, 0, 1 },
	{ /* 80 */ "\\x0#(*?-@|#", "", 0, 0, 0, 1 },
	{ /* 81 */ "$)+.:-;=#", "", 0, 0, 0, 1 },
	{ /* 82 */ "$)+.:-=#", "", 0, 0, 0, 1 },
	{ /* 83 */ "$)+.:-=A-Z_a-z#", "", 0, 0, 0, 1 },
	{ /* 84 */ "0-9>#", "", 0, 0, 0, 1 },
	{ /* 85 */ " $)+.:-=A-Z_a-z#", "", 0, 0, 0, 1 },
	{ /* 86 */ "\\x0!#(*?-@|#", "", 0, 0, 0, 1 },
	{ /* 87 */ "\\r $)+.:-=A-Z_a-z#", "", 0, 0, 0, 1 },
	{ /* 88 */ "\"'#", "", 0, 0, 0, 1 },
	{ /* 89 */ "\\t0-9>#", "", 0, 0, 0, 1 },
	{ /* 90 */ "\\x0-\\b\\v-\\f\\xE-\\x1F%-&,--/[]-^`{}-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 91 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#%-&(*,--/?-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 92 */ "\\x0-\\t\\v-\\f\\xE-\\x1F%-&,--/-9>[]-^`{}-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 93 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"%-',--/[]-^`{}-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 94 */ "\\x0-\\b\\v- $-&)+-/:-=A-[]-{}-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 95 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"%-',--/;[]-^`{}-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 96 */ "\\x0-\\t\\v-\\f\\xE-\\x1F%-&,--/-9;>[]-^`{}-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 97 */ "\\x1-\\b\\v-\\f\\xE-\\x1F%-&,--/;[]-^`{}-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 98 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#%-&(*,--/;?-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 99 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#%-&,--/;[]-^`{}-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 100 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#%-&,--/-9;>[]-^`{}-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 101 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-#%-',--/;[]-^`{}-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 102 */ "\\x0-\\b\\v- #-&)+-/:-=A-[]-{}-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 103 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-#%-',--/:-;[]-^`{}-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 104 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#%-&,--/-;>[]-^`{}-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 105 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#%-&,--/:-;[]-^`{}-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 106 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#%-&(*,--/:-;?-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 107 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#%-&,--/:-;@[]-^`{}-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 108 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#%-&,--/-;>@[]-^`{}-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 109 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-#%-',--/:-;@[]-^`{}-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 110 */ "\\x0-\\b\\v- #-&)+-/:-=@-[]-{}-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 111 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-',--/:-;@[]-^`{}-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 112 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&,--/-;>@[]-^`{}-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 113 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&,--/:-;@[]-^`{}-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 114 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-&(*,--/:-;?-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 115 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&,--/:-;@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 116 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&,--/-;>@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 117 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-',--/:-;@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 118 */ "\\x0-\\b\\v- #-&)+-/:-=@-[]-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 119 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-',--/:-;=@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 120 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&,--/-;=->@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 121 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&,--/:-;=@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 122 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-&(*,--/:-;=?-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 123 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&(,--/:-;=@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 124 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&(,--/-;=->@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 125 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-(,--/:-;=@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 126 */ "\\x0-\\b\\v- #-&(-)+-/:-=@-[]-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 127 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-),--/:-;=@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 128 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&(-),--/-;=->@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 129 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&(-),--/:-;=@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 130 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-&(-*,--/:-;=?-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 131 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&(-*,--/:-;=@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 132 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&(-*,--/-;=->@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 133 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-*,--/:-;=@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 134 */ "\\x0-\\b\\v- #-&(-/:-=@-[]-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 135 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"--/:-;=@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 136 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&(--/-;=->@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 137 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&(--/:-;=@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 138 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-&(--/:-;=?-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 139 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&(--/:-;=?-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 140 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&(--/-;=-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 141 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"--/:-;=?-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 142 */ "\\x0-\\b\\v- #-&(-/:-=?-[]-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 143 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-/:-;=?-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 144 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&(-;=-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 145 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&(-/:-;=?-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 146 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-&(-/:-;=?-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 147 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!#-&(-/:-;=?-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 148 */ "\\x0-\\t\\v-\\f\\xE-\\x1F!#-&(-;=-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 149 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!-/:-;=?-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 150 */ "\\x0-\\t\\v-\\f\\xE-\\x1F!#-;=-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 151 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!#-/:-;=?-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 152 */ "\\x0-\\b\\v-!#-&(-/:-=?-[]-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 153 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!#-/:-;=?-@[-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 154 */ "\\x0-\\t\\v-\\f\\xE-\\x1F!#-;=-@[-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 155 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!-/:-;=?-@[-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 156 */ "\\x0-\\t\\v-\\f\\xE-\\x1F!-;=-@[-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 157 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-/:-;=?-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 158 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!-/:-;=?-@[-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 159 */ "\\x0-\\b\\v-&(-/:-=?-[]-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 160 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!-/:-=?-@[-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 161 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-/:-=?-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 162 */ "\\x0-\\t\\v-\\f\\xE-\\x1F!-@[-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 163 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!-/:-=?-@[-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 164 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-/:-@[]-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 165 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!-/:-@[-^`{-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 166 */ "\\x0-\\b\\v-&(-/:-[]-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 167 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!-/:-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 168 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-/:-[]-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 169 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!-/:-=?-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 170 */ "\\x0-\\t\\v-\\f\\xE-\\x1F!-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 171 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!-=?-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 172 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-[]-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 173 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 174 */ "\\x0-\\b\\v-&(-[]-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 175 */ "\\x1-\\b\\v-\\f\\xE-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 176 */ "\\x0-\\b\\v-\\f\\xE-!#-[]-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 177 */ "\\x0-\\b\\v-\\f\\xE-=?-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 178 */ "\\x0-\\t\\v-\\f\\xE-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 179 */ "\\x0-\\t\\v-\\f\\xE-=?-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 180 */ "\\x0-\\t\\v-\\f\\xE-!#-[]-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 181 */ "\\x1-\\t\\v-\\f\\xE-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 182 */ "\\x0-\\t\\v-&(-[]-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 183 */ "\\x1-\\t\\v-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 184 */ "\\x0-\\t\\v-!#-[]-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 185 */ "\\x0-\\t\\v-=?-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 186 */ "grammar_spec''", "", 0, 0, 0, 1 },
	{ /* 187 */ "scanner'", "", 0, 0, 0, 1 },
	{ /* 188 */ "insensitive'", "", 0, 0, 0, 1 },
	{ /* 189 */ "context-insensitive'", "", 0, 0, 0, 1 },
	{ /* 190 */ "scannerless'", "", 0, 0, 0, 1 },
	{ /* 191 */ "sensitive'", "", 0, 0, 0, 1 },
	{ /* 192 */ "context-sensitive'", "", 0, 0, 0, 1 },
	{ /* 193 */ "language'", "", 0, 0, 0, 1 },
	{ /* 194 */ "mode'", "", 0, 0, 0, 1 },
	{ /* 195 */ "#!'", "", 0, 0, 0, 1 },
	{ /* 196 */ "$'", "", 0, 0, 0, 1 },
	{ /* 197 */ ":='", "", 0, 0, 0, 1 },
	{ /* 198 */ "=>'", "", 0, 0, 0, 1 },
	{ /* 199 */ "->'", "", 0, 0, 0, 1 },
	{ /* 200 */ ".'", "", 0, 0, 0, 1 },
	{ /* 201 */ "ccl'", "", 0, 0, 0, 1 },
	{ /* 202 */ "?'", "", 0, 0, 0, 1 },
	{ /* 203 */ "+'", "", 0, 0, 0, 1 },
	{ /* 204 */ "*'", "", 0, 0, 0, 1 },
	{ /* 205 */ "non-greedy'", "", 0, 0, 0, 1 },
	{ /* 206 */ "greedy'", "", 0, 0, 0, 1 },
	{ /* 207 */ "@'", "", 0, 0, 0, 1 },
	{ /* 208 */ "&eof'", "", 0, 0, 0, 1 },
	{ /* 209 */ "&error'", "", 0, 0, 0, 1 },
	{ /* 210 */ "modifier'", "", 0, 0, 0, 1 },
	{ /* 211 */ ":'", "", 0, 0, 0, 1 },
	{ /* 212 */ "='", "", 0, 0, 0, 1 },
	{ /* 213 */ "precedence'", "", 0, 0, 0, 1 },
	{ /* 214 */ "|'", "", 0, 0, 0, 1 },
	{ /* 215 */ ")'", "", 0, 0, 0, 1 },
	{ /* 216 */ "('", "", 0, 0, 0, 1 },
	{ /* 217 */ "identifier'", "", 0, 0, 0, 1 },
	{ /* 218 */ "terminal'", "", 0, 0, 0, 1 },
	{ /* 219 */ "kw'", "", 0, 0, 0, 1 },
	{ /* 220 */ "ccl_string'", "", 0, 0, 0, 1 },
	{ /* 221 */ "option'", "", 0, 0, 0, 1 },
	{ /* 222 */ "off'", "", 0, 0, 0, 1 },
	{ /* 223 */ "on'", "", 0, 0, 0, 1 },
	{ /* 224 */ "USERDEF'", "", 0, 0, 0, 1 },
	{ /* 225 */ "pcb'", "", 0, 0, 0, 1 },
	{ /* 226 */ "epilogue'", "", 0, 0, 0, 1 },
	{ /* 227 */ "prologue'", "", 0, 0, 0, 1 },
	{ /* 228 */ "reserve terminals'", "", 0, 0, 0, 1 },
	{ /* 229 */ "case insensitive strings'", "", 0, 0, 0, 1 },
	{ /* 230 */ "lexeme separation'", "", 0, 0, 0, 1 },
	{ /* 231 */ "type'", "", 0, 0, 0, 1 },
	{ /* 232 */ "default value type'", "", 0, 0, 0, 1 },
	{ /* 233 */ "default epsilon action'", "", 0, 0, 0, 1 },
	{ /* 234 */ "default action'", "", 0, 0, 0, 1 },
	{ /* 235 */ "prefix'", "", 0, 0, 0, 1 },
	{ /* 236 */ "nonassoc'", "", 0, 0, 0, 1 },
	{ /* 237 */ "right'", "", 0, 0, 0, 1 },
	{ /* 238 */ "left'", "", 0, 0, 0, 1 },
	{ /* 239 */ "fixate'", "", 0, 0, 0, 1 },
	{ /* 240 */ "lexeme'", "", 0, 0, 0, 1 },
	{ /* 241 */ "whitespaces'", "", 0, 0, 0, 1 },
	{ /* 242 */ "#'", "", 0, 0, 0, 1 },
	{ /* 243 */ ";'", "", 0, 0, 0, 1 },
	{ /* 244 */ "code'", "", 0, 0, 0, 1 },
	{ /* 245 */ "&whitespace*", "", 0, 1, 1, 1 },
	{ /* 246 */ "&whitespace+", "", 0, 1, 1, 1 },
	{ /* 247 */ "&whitespace", "", 0, 1, 1, 1 },
	{ /* 248 */ "grammar_spec'", "", 0, 0, 0, 1 },
	{ /* 249 */ "\\x0-\\t\\v-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 250 */ "scomment?", "", 0, 1, 0, 1 },
	{ /* 251 */ "scomment", "", 0, 1, 0, 1 },
	{ /* 252 */ "comment?", "", 0, 1, 0, 1 },
	{ /* 253 */ "comment", "", 0, 1, 0, 1 },
	{ /* 254 */ "anychar", "", 0, 1, 0, 1 },
	{ /* 255 */ "inner_code", "", 0, 1, 0, 1 },
	{ /* 256 */ "inner_code_opt", "", 0, 1, 0, 1 },
	{ /* 257 */ "code_begin", "", 0, 1, 0, 1 },
	{ /* 258 */ "integer", "", 0, 0, 0, 1 },
	{ /* 259 */ "0-9A-Z_a-z#", "", 0, 0, 0, 1 },
	{ /* 260 */ "identifier_follow", "", 0, 1, 0, 1 },
	{ /* 261 */ "identifier_start", "", 0, 1, 0, 1 },
	{ /* 262 */ "\\x0-=?-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 263 */ "type_str", "", 0, 1, 0, 1 },
	{ /* 264 */ "\\x0-!#-[]-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 265 */ "kw_char", "", 0, 1, 0, 1 },
	{ /* 266 */ "kw_str", "", 0, 1, 0, 1 },
	{ /* 267 */ "\\x1-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 268 */ "\\x0-&(-[]-\\uFFFF#", "", 0, 0, 0, 1 },
	{ /* 269 */ "ccl_char", "", 0, 1, 0, 1 },
	{ /* 270 */ "ccl_str", "", 0, 1, 0, 1 },
	{ /* 271 */ "string_single+", "", 0, 0, 0, 1 },
	{ /* 272 */ "re_factor", "", 0, 0, 0, 1 },
	{ /* 273 */ "re_modifier", "", 0, 0, 0, 1 },
	{ /* 274 */ "re_expr", "", 0, 0, 0, 1 },
	{ /* 275 */ "re_alt", "", 0, 0, 0, 1 },
	{ /* 276 */ "string_single", "", 0, 0, 0, 1 },
	{ /* 277 */ "ccl", "", 0, 1, 0, 1 },
	{ /* 278 */ "stack_cur_prod", "", 0, 0, 0, 1 },
	{ /* 279 */ "access_name", "", 0, 0, 0, 1 },
	{ /* 280 */ "symbol", "", 0, 0, 0, 1 },
	{ /* 281 */ "rhs", "", 0, 0, 0, 1 },
	{ /* 282 */ "prod_directives*", "", 0, 0, 0, 1 },
	{ /* 283 */ "prod_directives+", "", 0, 0, 0, 1 },
	{ /* 284 */ "prod_directives", "", 0, 0, 0, 1 },
	{ /* 285 */ "code_opt_dup", "", 0, 0, 0, 1 },
	{ /* 286 */ "rhs_opt", "", 0, 0, 0, 1 },
	{ /* 287 */ "production", "", 0, 0, 0, 1 },
	{ /* 288 */ "sym_option*", "", 0, 0, 0, 1 },
	{ /* 289 */ "sym_option+", "", 0, 0, 0, 1 },
	{ /* 290 */ "sym_option", "", 0, 0, 0, 1 },
	{ /* 291 */ "ast_node", "", 0, 0, 0, 1 },
	{ /* 292 */ "regex", "", 0, 0, 0, 1 },
	{ /* 293 */ "productions", "", 0, 0, 0, 1 },
	{ /* 294 */ "alt_lhs_list?", "", 0, 0, 0, 1 },
	{ /* 295 */ "goal_mark", "", 0, 0, 0, 1 },
	{ /* 296 */ "defines", "", 0, 0, 0, 1 },
	{ /* 297 */ "regex_sym", "", 0, 0, 0, 1 },
	{ /* 298 */ "alt_regex_sym", "", 0, 0, 0, 1 },
	{ /* 299 */ "alt_lhs_list", "", 0, 0, 0, 1 },
	{ /* 300 */ "lhs", "", 0, 0, 0, 1 },
	{ /* 301 */ "sym", "", 0, 0, 0, 1 },
	{ /* 302 */ "line_number", "", 0, 0, 0, 1 },
	{ /* 303 */ "option?", "", 0, 0, 0, 1 },
	{ /* 304 */ "boolean_opt", "", 0, 0, 0, 1 },
	{ /* 305 */ "code_opt", "", 0, 0, 0, 1 },
	{ /* 306 */ "symbol_list", "", 0, 0, 0, 1 },
	{ /* 307 */ "boolean", "", 0, 0, 0, 1 },
	{ /* 308 */ "string", "", 0, 0, 0, 1 },
	{ /* 309 */ "userparam", "", 0, 0, 0, 1 },
	{ /* 310 */ "directive_parms", "", 0, 0, 0, 1 },
	{ /* 311 */ "unfixed_directive", "", 0, 0, 0, 1 },
	{ /* 312 */ "definition", "", 0, 0, 0, 1 },
	{ /* 313 */ "string_or_ident", "", 0, 0, 0, 1 },
	{ /* 314 */ "mode_type", "", 0, 0, 0, 1 },
	{ /* 315 */ "fixed_directive", "", 0, 0, 0, 1 },
	{ /* 316 */ "segment*", "", 0, 0, 0, 1 },
	{ /* 317 */ "segment+", "", 0, 0, 0, 1 },
	{ /* 318 */ "segment", "", 0, 0, 0, 1 },
	{ /* 319 */ "fixed_directive_def*", "", 0, 0, 0, 1 },
	{ /* 320 */ "fixed_directive_def+", "", 0, 0, 0, 1 },
	{ /* 321 */ "fixed_directive_def", "", 0, 0, 0, 1 },
	{ /* 322 */ "grammar_spec", "", 0, 0, 0, 1 },
	{ /* 323 */ "type", "", 0, 1, 0, 1 },
	{ /* 324 */ "kw", "", 0, 1, 0, 1 },
	{ /* 325 */ "ccl_string", "", 0, 1, 0, 1 },
	{ /* 326 */ "code", "", 0, 1, 0, 1 },
	{ /* 327 */ "modifier", "", 0, 1, 0, 1 },
	{ /* 328 */ "identifier", "", 0, 1, 0, 1 },
	{ /* 329 */ "terminal", "", 0, 1, 0, 1 },
	{ /* 330 */ "whitespace", "", 0, 1, 1, 1 }
};

/* Production information table */
UNICC_STATIC _prodinfo _productions[] =
{
	{ /* 0 */ "fixed_directive_def+ : fixed_directive_def+ fixed_directive_def", "", 2, 320 },
	{ /* 1 */ "fixed_directive_def+ : fixed_directive_def", "", 1, 320 },
	{ /* 2 */ "fixed_directive_def* : fixed_directive_def+", "", 1, 319 },
	{ /* 3 */ "fixed_directive_def* : ", "", 0, 319 },
	{ /* 4 */ "grammar_spec : fixed_directive_def* segment*", "", 2, 322 },
	{ /* 5 */ "segment+ : segment+ segment", "", 2, 317 },
	{ /* 6 */ "segment+ : segment", "", 1, 317 },
	{ /* 7 */ "segment* : segment+", "", 1, 316 },
	{ /* 8 */ "segment* : ", "", 0, 316 },
	{ /* 9 */ "fixed_directive_def : #!' fixed_directive ;'", "", 3, 321 },
	{ /* 10 */ "fixed_directive : mode' mode_type", "", 2, 315 },
	{ /* 11 */ "fixed_directive : language' string_or_ident", "", 2, 315 },
	{ /* 12 */ "mode_type : context-sensitive'", "", 1, 314 },
	{ /* 13 */ "mode_type : sensitive'", "", 1, 314 },
	{ /* 14 */ "mode_type : scannerless'", "", 1, 314 },
	{ /* 15 */ "mode_type : context-insensitive'", "", 1, 314 },
	{ /* 16 */ "mode_type : insensitive'", "", 1, 314 },
	{ /* 17 */ "mode_type : scanner'", "", 1, 314 },
	{ /* 18 */ "segment : code'", "", 1, 318 },
	{ /* 19 */ "segment : definition ;'", "", 2, 318 },
	{ /* 20 */ "segment : unfixed_directive ;'", "", 2, 318 },
	{ /* 21 */ "unfixed_directive : #' directive_parms", "", 2, 311 },
	{ /* 22 */ "userparam : code'", "", 1, 309 },
	{ /* 23 */ "userparam : string", "", 1, 309 },
	{ /* 24 */ "userparam : boolean", "", 1, 309 },
	{ /* 25 */ "userparam : ", "", 0, 309 },
	{ /* 26 */ "directive_parms : whitespaces' symbol_list", "", 2, 310 },
	{ /* 27 */ "directive_parms : lexeme' symbol_list", "", 2, 310 },
	{ /* 28 */ "directive_parms : fixate' symbol_list", "", 2, 310 },
	{ /* 29 */ "directive_parms : left' symbol_list", "", 2, 310 },
	{ /* 30 */ "directive_parms : right' symbol_list", "", 2, 310 },
	{ /* 31 */ "directive_parms : nonassoc' symbol_list", "", 2, 310 },
	{ /* 32 */ "directive_parms : prefix' string", "", 2, 310 },
	{ /* 33 */ "directive_parms : default action' code_opt", "", 2, 310 },
	{ /* 34 */ "directive_parms : default epsilon action' code_opt", "", 2, 310 },
	{ /* 35 */ "directive_parms : default value type' type'", "", 2, 310 },
	{ /* 36 */ "directive_parms : lexeme separation' boolean_opt", "", 2, 310 },
	{ /* 37 */ "directive_parms : case insensitive strings' boolean_opt", "", 2, 310 },
	{ /* 38 */ "directive_parms : reserve terminals' boolean_opt", "", 2, 310 },
	{ /* 39 */ "directive_parms : prologue' code'", "", 2, 310 },
	{ /* 40 */ "directive_parms : epilogue' code'", "", 2, 310 },
	{ /* 41 */ "directive_parms : pcb' code'", "", 2, 310 },
	{ /* 42 */ "option? : option'", "", 1, 303 },
	{ /* 43 */ "option? : ", "", 0, 303 },
	{ /* 44 */ "directive_parms : option? line_number USERDEF' userparam", "", 4, 310 },
	{ /* 45 */ "boolean_opt : boolean", "", 1, 304 },
	{ /* 46 */ "boolean_opt : ", "", 0, 304 },
	{ /* 47 */ "boolean : on'", "", 1, 307 },
	{ /* 48 */ "boolean : off'", "", 1, 307 },
	{ /* 49 */ "symbol_list : symbol_list sym", "", 2, 306 },
	{ /* 50 */ "symbol_list : sym", "", 1, 306 },
	{ /* 51 */ "lhs : identifier'", "", 1, 300 },
	{ /* 52 */ "alt_lhs_list : alt_lhs_list lhs", "", 2, 299 },
	{ /* 53 */ "alt_lhs_list : lhs", "", 1, 299 },
	{ /* 54 */ "alt_regex_sym : alt_regex_sym regex_sym", "", 2, 298 },
	{ /* 55 */ "alt_regex_sym : regex_sym", "", 1, 298 },
	{ /* 56 */ "regex_sym : identifier'", "", 1, 297 },
	{ /* 57 */ "defines : ->'", "", 1, 296 },
	{ /* 58 */ "defines : :'", "", 1, 296 },
	{ /* 59 */ "defines : =>'", "", 1, 296 },
	{ /* 60 */ "defines : :='", "", 1, 296 },
	{ /* 61 */ "definition : lhs goal_mark alt_lhs_list? type' defines productions", "", 6, 312 },
	{ /* 62 */ "alt_lhs_list? : alt_lhs_list", "", 1, 294 },
	{ /* 63 */ "alt_lhs_list? : ", "", 0, 294 },
	{ /* 64 */ "definition : @' alt_regex_sym type' regex code_opt ast_node sym_option*", "", 7, 312 },
	{ /* 65 */ "sym_option+ : sym_option+ sym_option", "", 2, 289 },
	{ /* 66 */ "sym_option+ : sym_option", "", 1, 289 },
	{ /* 67 */ "sym_option* : sym_option+", "", 1, 288 },
	{ /* 68 */ "sym_option* : ", "", 0, 288 },
	{ /* 69 */ "sym_option : #' greedy'", "", 2, 290 },
	{ /* 70 */ "sym_option : #' non-greedy'", "", 2, 290 },
	{ /* 71 */ "sym_option : #' option? line_number USERDEF' userparam", "", 5, 290 },
	{ /* 72 */ "goal_mark : $'", "", 1, 295 },
	{ /* 73 */ "goal_mark : ", "", 0, 295 },
	{ /* 74 */ "productions : productions |' production", "", 3, 293 },
	{ /* 75 */ "productions : production", "", 1, 293 },
	{ /* 76 */ "ast_node : =' identifier'", "", 2, 291 },
	{ /* 77 */ "ast_node : =' string", "", 2, 291 },
	{ /* 78 */ "ast_node : ", "", 0, 291 },
	{ /* 79 */ "production : line_number rhs_opt code_opt_dup ast_node prod_directives*", "", 5, 287 },
	{ /* 80 */ "prod_directives+ : prod_directives+ prod_directives", "", 2, 283 },
	{ /* 81 */ "prod_directives+ : prod_directives", "", 1, 283 },
	{ /* 82 */ "prod_directives* : prod_directives+", "", 1, 282 },
	{ /* 83 */ "prod_directives* : ", "", 0, 282 },
	{ /* 84 */ "rhs_opt : rhs", "", 1, 286 },
	{ /* 85 */ "rhs_opt : ", "", 0, 286 },
	{ /* 86 */ "prod_directives : #' precedence' terminal'", "", 3, 284 },
	{ /* 87 */ "prod_directives : #' option? line_number USERDEF' userparam", "", 5, 284 },
	{ /* 88 */ "rhs : rhs symbol access_name", "", 3, 281 },
	{ /* 89 */ "rhs : symbol access_name", "", 2, 281 },
	{ /* 90 */ "symbol : sym modifier'", "", 2, 280 },
	{ /* 91 */ "symbol : &error'", "", 1, 280 },
	{ /* 92 */ "symbol : &eof'", "", 1, 280 },
	{ /* 93 */ "sym : terminal'", "", 1, 301 },
	{ /* 94 */ "sym : identifier'", "", 1, 301 },
	{ /* 95 */ "sym : type' (' stack_cur_prod productions )'", "", 5, 301 },
	{ /* 96 */ "stack_cur_prod : ", "", 0, 278 },
	{ /* 97 */ "terminal : ccl", "", 1, 329 },
	{ /* 98 */ "terminal : kw", "", 1, 329 },
	{ /* 99 */ "terminal : '@' identifier", "", 2, 329 },
	{ /* 100 */ "modifier : '*'", "", 1, 327 },
	{ /* 101 */ "modifier : '+'", "", 1, 327 },
	{ /* 102 */ "modifier : '?'", "", 1, 327 },
	{ /* 103 */ "modifier : ", "", 0, 327 },
	{ /* 104 */ "access_name : :' identifier'", "", 2, 279 },
	{ /* 105 */ "access_name : :' string_single", "", 2, 279 },
	{ /* 106 */ "access_name : ", "", 0, 279 },
	{ /* 107 */ "regex : re_alt", "", 1, 292 },
	{ /* 108 */ "re_alt : re_alt |' re_expr", "", 3, 275 },
	{ /* 109 */ "re_alt : re_expr", "", 1, 275 },
	{ /* 110 */ "re_expr : re_expr re_modifier", "", 2, 274 },
	{ /* 111 */ "re_expr : re_modifier", "", 1, 274 },
	{ /* 112 */ "re_modifier : re_factor *'", "", 2, 273 },
	{ /* 113 */ "re_modifier : re_factor +'", "", 2, 273 },
	{ /* 114 */ "re_modifier : re_factor ?'", "", 2, 273 },
	{ /* 115 */ "re_modifier : re_factor", "", 1, 273 },
	{ /* 116 */ "re_factor : ccl'", "", 1, 272 },
	{ /* 117 */ "re_factor : kw'", "", 1, 272 },
	{ /* 118 */ "re_factor : .'", "", 1, 272 },
	{ /* 119 */ "re_factor : (' regex )'", "", 3, 272 },
	{ /* 120 */ "string_single+ : string_single+ string_single", "", 2, 271 },
	{ /* 121 */ "string_single+ : string_single", "", 1, 271 },
	{ /* 122 */ "string : string_single+", "", 1, 308 },
	{ /* 123 */ "string_single : ccl_string'", "", 1, 276 },
	{ /* 124 */ "string_single : kw'", "", 1, 276 },
	{ /* 125 */ "ccl : ccl_string", "", 1, 277 },
	{ /* 126 */ "ccl : '!' ccl_string", "", 2, 277 },
	{ /* 127 */ "ccl_string : ''' ccl_str '''", "", 3, 325 },
	{ /* 128 */ "ccl_str : ccl_str ccl_char", "", 2, 270 },
	{ /* 129 */ "ccl_str : ", "", 0, 270 },
	{ /* 130 */ "ccl_char : \\x0-&(-[]-\\uFFFF#", "", 1, 269 },
	{ /* 131 */ "ccl_char : '\\\\' \\x1-\\uFFFF#", "", 2, 269 },
	{ /* 132 */ "kw : '\"' kw_str '\"'", "", 3, 324 },
	{ /* 133 */ "kw_str : kw_str kw_char", "", 2, 266 },
	{ /* 134 */ "kw_str : ", "", 0, 266 },
	{ /* 135 */ "kw_char : \\x0-!#-[]-\\uFFFF#", "", 1, 265 },
	{ /* 136 */ "kw_char : '\\\\' \\x1-\\uFFFF#", "", 2, 265 },
	{ /* 137 */ "type : '<' type_str '>'", "", 3, 323 },
	{ /* 138 */ "type : ", "", 0, 323 },
	{ /* 139 */ "type_str : type_str \\x0-=?-\\uFFFF#", "", 2, 263 },
	{ /* 140 */ "type_str : ", "", 0, 263 },
	{ /* 141 */ "identifier : identifier_start identifier_follow", "", 2, 328 },
	{ /* 142 */ "identifier_start : 'A-Z_a-z'", "", 1, 261 },
	{ /* 143 */ "identifier_follow : identifier_follow 0-9A-Z_a-z#", "", 2, 260 },
	{ /* 144 */ "identifier_follow : ", "", 0, 260 },
	{ /* 145 */ "string_or_ident : string", "", 1, 313 },
	{ /* 146 */ "string_or_ident : identifier'", "", 1, 313 },
	{ /* 147 */ "integer : integer '0-9'", "", 2, 258 },
	{ /* 148 */ "integer : '0-9'", "", 1, 258 },
	{ /* 149 */ "code_opt_dup : code_opt", "", 1, 285 },
	{ /* 150 */ "code_opt : code'", "", 1, 305 },
	{ /* 151 */ "code_opt : ", "", 0, 305 },
	{ /* 152 */ "code : code_begin inner_code_opt \"*]\"", "", 3, 326 },
	{ /* 153 */ "code_begin : \"[*\"", "", 1, 257 },
	{ /* 154 */ "inner_code_opt : inner_code", "", 1, 256 },
	{ /* 155 */ "inner_code_opt : ", "", 0, 256 },
	{ /* 156 */ "inner_code : inner_code anychar", "", 2, 255 },
	{ /* 157 */ "inner_code : anychar", "", 1, 255 },
	{ /* 158 */ "whitespace : ' '", "", 1, 330 },
	{ /* 159 */ "whitespace : '\\t'", "", 1, 330 },
	{ /* 160 */ "whitespace : \"/*\" comment? \"*/\"", "", 3, 330 },
	{ /* 161 */ "comment? : comment", "", 1, 252 },
	{ /* 162 */ "comment? : ", "", 0, 252 },
	{ /* 163 */ "whitespace : \"//\" scomment? '\\n'", "", 3, 330 },
	{ /* 164 */ "scomment? : scomment", "", 1, 250 },
	{ /* 165 */ "scomment? : ", "", 0, 250 },
	{ /* 166 */ "whitespace : '\\r'", "", 1, 330 },
	{ /* 167 */ "whitespace : '\\n'", "", 1, 330 },
	{ /* 168 */ "comment : comment anychar", "", 2, 253 },
	{ /* 169 */ "comment : anychar", "", 1, 253 },
	{ /* 170 */ "anychar : \\x1-\\uFFFF#", "", 1, 254 },
	{ /* 171 */ "scomment : scomment \\x0-\\t\\v-\\uFFFF#", "", 2, 251 },
	{ /* 172 */ "scomment : \\x0-\\t\\v-\\uFFFF#", "", 1, 251 },
	{ /* 173 */ "line_number : ", "", 0, 302 },
	{ /* 174 */ "grammar_spec' : grammar_spec ~&eof", "", 2, 248 },
	{ /* 175 */ "&whitespace : whitespace", "", 1, 247 },
	{ /* 176 */ "&whitespace+ : &whitespace+ &whitespace", "", 2, 246 },
	{ /* 177 */ "&whitespace+ : &whitespace", "", 1, 246 },
	{ /* 178 */ "&whitespace* : &whitespace+", "", 1, 245 },
	{ /* 179 */ "&whitespace* : ", "", 0, 245 },
	{ /* 180 */ "code' : code &whitespace*", "", 2, 244 },
	{ /* 181 */ ";' : ';' &whitespace*", "", 2, 243 },
	{ /* 182 */ "#' : '#' &whitespace*", "", 2, 242 },
	{ /* 183 */ "whitespaces' : \"whitespaces\" &whitespace*", "", 2, 241 },
	{ /* 184 */ "lexeme' : \"lexeme\" &whitespace*", "", 2, 240 },
	{ /* 185 */ "fixate' : \"fixate\" &whitespace*", "", 2, 239 },
	{ /* 186 */ "left' : \"left\" &whitespace*", "", 2, 238 },
	{ /* 187 */ "right' : \"right\" &whitespace*", "", 2, 237 },
	{ /* 188 */ "nonassoc' : \"nonassoc\" &whitespace*", "", 2, 236 },
	{ /* 189 */ "prefix' : \"prefix\" &whitespace*", "", 2, 235 },
	{ /* 190 */ "default action' : \"default action\" &whitespace*", "", 2, 234 },
	{ /* 191 */ "default epsilon action' : \"default epsilon action\" &whitespace*", "", 2, 233 },
	{ /* 192 */ "default value type' : \"default value type\" &whitespace*", "", 2, 232 },
	{ /* 193 */ "type' : type &whitespace*", "", 2, 231 },
	{ /* 194 */ "lexeme separation' : \"lexeme separation\" &whitespace*", "", 2, 230 },
	{ /* 195 */ "case insensitive strings' : \"case insensitive strings\" &whitespace*", "", 2, 229 },
	{ /* 196 */ "reserve terminals' : \"reserve terminals\" &whitespace*", "", 2, 228 },
	{ /* 197 */ "prologue' : \"prologue\" &whitespace*", "", 2, 227 },
	{ /* 198 */ "epilogue' : \"epilogue\" &whitespace*", "", 2, 226 },
	{ /* 199 */ "pcb' : \"pcb\" &whitespace*", "", 2, 225 },
	{ /* 200 */ "USERDEF' : @USERDEF &whitespace*", "", 2, 224 },
	{ /* 201 */ "on' : \"on\" &whitespace*", "", 2, 223 },
	{ /* 202 */ "off' : \"off\" &whitespace*", "", 2, 222 },
	{ /* 203 */ "option' : \"option\" &whitespace*", "", 2, 221 },
	{ /* 204 */ "ccl_string' : ccl_string &whitespace*", "", 2, 220 },
	{ /* 205 */ "kw' : kw &whitespace*", "", 2, 219 },
	{ /* 206 */ "terminal' : terminal &whitespace*", "", 2, 218 },
	{ /* 207 */ "identifier' : identifier &whitespace*", "", 2, 217 },
	{ /* 208 */ "(' : '(' &whitespace*", "", 2, 216 },
	{ /* 209 */ ")' : ')' &whitespace*", "", 2, 215 },
	{ /* 210 */ "|' : '|' &whitespace*", "", 2, 214 },
	{ /* 211 */ "precedence' : \"precedence\" &whitespace*", "", 2, 213 },
	{ /* 212 */ "=' : '=' &whitespace*", "", 2, 212 },
	{ /* 213 */ ":' : ':' &whitespace*", "", 2, 211 },
	{ /* 214 */ "modifier' : modifier &whitespace*", "", 2, 210 },
	{ /* 215 */ "&error' : \"&error\" &whitespace*", "", 2, 209 },
	{ /* 216 */ "&eof' : \"&eof\" &whitespace*", "", 2, 208 },
	{ /* 217 */ "@' : '@' &whitespace*", "", 2, 207 },
	{ /* 218 */ "greedy' : \"greedy\" &whitespace*", "", 2, 206 },
	{ /* 219 */ "non-greedy' : \"non-greedy\" &whitespace*", "", 2, 205 },
	{ /* 220 */ "*' : '*' &whitespace*", "", 2, 204 },
	{ /* 221 */ "+' : '+' &whitespace*", "", 2, 203 },
	{ /* 222 */ "?' : '?' &whitespace*", "", 2, 202 },
	{ /* 223 */ "ccl' : ccl &whitespace*", "", 2, 201 },
	{ /* 224 */ ".' : '.' &whitespace*", "", 2, 200 },
	{ /* 225 */ "->' : \"->\" &whitespace*", "", 2, 199 },
	{ /* 226 */ "=>' : \"=>\" &whitespace*", "", 2, 198 },
	{ /* 227 */ ":=' : \":=\" &whitespace*", "", 2, 197 },
	{ /* 228 */ "$' : '$' &whitespace*", "", 2, 196 },
	{ /* 229 */ "#!' : \"#!\" &whitespace*", "", 2, 195 },
	{ /* 230 */ "mode' : \"mode\" &whitespace*", "", 2, 194 },
	{ /* 231 */ "language' : \"language\" &whitespace*", "", 2, 193 },
	{ /* 232 */ "context-sensitive' : \"context-sensitive\" &whitespace*", "", 2, 192 },
	{ /* 233 */ "sensitive' : \"sensitive\" &whitespace*", "", 2, 191 },
	{ /* 234 */ "scannerless' : \"scannerless\" &whitespace*", "", 2, 190 },
	{ /* 235 */ "context-insensitive' : \"context-insensitive\" &whitespace*", "", 2, 189 },
	{ /* 236 */ "insensitive' : \"insensitive\" &whitespace*", "", 2, 188 },
	{ /* 237 */ "scanner' : \"scanner\" &whitespace*", "", 2, 187 },
	{ /* 238 */ "grammar_spec'' : &whitespace* grammar_spec'", "", 2, 186 },
	{ /* 239 */ "\\x0-=?-\\uFFFF# : \\x0-\\t\\v-=?-\\uFFFF#", "", 1, 262 },
	{ /* 240 */ "\\x0-=?-\\uFFFF# : '\\n'", "", 1, 262 },
	{ /* 241 */ "\\x0-!#-[]-\\uFFFF# : \\x0-\\t\\v-!#-[]-\\uFFFF#", "", 1, 264 },
	{ /* 242 */ "\\x0-!#-[]-\\uFFFF# : '\\n'", "", 1, 264 },
	{ /* 243 */ "\\x1-\\uFFFF# : \\x1-\\t\\v-\\uFFFF#", "", 1, 267 },
	{ /* 244 */ "\\x1-\\uFFFF# : '\\n'", "", 1, 267 },
	{ /* 245 */ "\\x0-&(-[]-\\uFFFF# : \\x0-\\t\\v-&(-[]-\\uFFFF#", "", 1, 268 },
	{ /* 246 */ "\\x0-&(-[]-\\uFFFF# : '\\n'", "", 1, 268 },
	{ /* 247 */ "\\x1-\\t\\v-\\uFFFF# : '\\r'", "", 1, 183 },
	{ /* 248 */ "\\x1-\\t\\v-\\uFFFF# : \\x1-\\t\\v-\\f\\xE-\\uFFFF#", "", 1, 183 },
	{ /* 249 */ "\\x0-\\t\\v-!#-[]-\\uFFFF# : '\\r'", "", 1, 184 },
	{ /* 250 */ "\\x0-\\t\\v-!#-[]-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-!#-[]-\\uFFFF#", "", 1, 184 },
	{ /* 251 */ "\\x0-\\t\\v-=?-\\uFFFF# : '\\r'", "", 1, 185 },
	{ /* 252 */ "\\x0-\\t\\v-=?-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-=?-\\uFFFF#", "", 1, 185 },
	{ /* 253 */ "\\x0-\\t\\v-\\uFFFF# : '\\r'", "", 1, 249 },
	{ /* 254 */ "\\x0-\\t\\v-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-\\uFFFF#", "", 1, 249 },
	{ /* 255 */ "\\x0-\\t\\v-\\f\\xE-=?-\\uFFFF# : '\\t'", "", 1, 179 },
	{ /* 256 */ "\\x0-\\t\\v-\\f\\xE-=?-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-=?-\\uFFFF#", "", 1, 179 },
	{ /* 257 */ "\\x0-\\t\\v-\\f\\xE-!#-[]-\\uFFFF# : '\\t'", "", 1, 180 },
	{ /* 258 */ "\\x0-\\t\\v-\\f\\xE-!#-[]-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-!#-[]-\\uFFFF#", "", 1, 180 },
	{ /* 259 */ "\\x1-\\t\\v-\\f\\xE-\\uFFFF# : '\\t'", "", 1, 181 },
	{ /* 260 */ "\\x1-\\t\\v-\\f\\xE-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\uFFFF#", "", 1, 181 },
	{ /* 261 */ "\\x0-\\t\\v-&(-[]-\\uFFFF# : '\\t'", "", 1, 182 },
	{ /* 262 */ "\\x0-\\t\\v-&(-[]-\\uFFFF# : \\x0-\\b\\v-&(-[]-\\uFFFF#", "", 1, 182 },
	{ /* 263 */ "\\x1-\\b\\v-\\f\\xE-\\uFFFF# : ' '", "", 1, 175 },
	{ /* 264 */ "\\x1-\\b\\v-\\f\\xE-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\x1F!-\\uFFFF#", "", 1, 175 },
	{ /* 265 */ "\\x0-\\b\\v-\\f\\xE-!#-[]-\\uFFFF# : ' '", "", 1, 176 },
	{ /* 266 */ "\\x0-\\b\\v-\\f\\xE-!#-[]-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F!#-[]-\\uFFFF#", "", 1, 176 },
	{ /* 267 */ "\\x0-\\b\\v-\\f\\xE-=?-\\uFFFF# : ' '", "", 1, 177 },
	{ /* 268 */ "\\x0-\\b\\v-\\f\\xE-=?-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F!-=?-\\uFFFF#", "", 1, 177 },
	{ /* 269 */ "\\x0-\\t\\v-\\f\\xE-\\uFFFF# : ' '", "", 1, 178 },
	{ /* 270 */ "\\x0-\\t\\v-\\f\\xE-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-\\x1F!-\\uFFFF#", "", 1, 178 },
	{ /* 271 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!-=?-\\uFFFF# : '0-9'", "", 1, 171 },
	{ /* 272 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!-=?-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F!-/:-=?-\\uFFFF#", "", 1, 171 },
	{ /* 273 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-[]-\\uFFFF# : '0-9'", "", 1, 172 },
	{ /* 274 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-[]-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F!#-/:-[]-\\uFFFF#", "", 1, 172 },
	{ /* 275 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!-\\uFFFF# : '0-9'", "", 1, 173 },
	{ /* 276 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\x1F!-/:-\\uFFFF#", "", 1, 173 },
	{ /* 277 */ "\\x0-\\b\\v-&(-[]-\\uFFFF# : '0-9'", "", 1, 174 },
	{ /* 278 */ "\\x0-\\b\\v-&(-[]-\\uFFFF# : \\x0-\\b\\v-&(-/:-[]-\\uFFFF#", "", 1, 174 },
	{ /* 279 */ "0-9A-Z_a-z# : '0-9'", "", 1, 259 },
	{ /* 280 */ "0-9A-Z_a-z# : 'A-Z_a-z'", "", 1, 259 },
	{ /* 281 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!-/:-\\uFFFF# : 'A-Z_a-z'", "", 1, 167 },
	{ /* 282 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!-/:-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\x1F!-/:-@[-^`{-\\uFFFF#", "", 1, 167 },
	{ /* 283 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-/:-[]-\\uFFFF# : 'A-Z_a-z'", "", 1, 168 },
	{ /* 284 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-/:-[]-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F!#-/:-@[]-^`{-\\uFFFF#", "", 1, 168 },
	{ /* 285 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!-/:-=?-\\uFFFF# : 'A-Z_a-z'", "", 1, 169 },
	{ /* 286 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!-/:-=?-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F!-/:-=?-@[-^`{-\\uFFFF#", "", 1, 169 },
	{ /* 287 */ "\\x0-\\t\\v-\\f\\xE-\\x1F!-\\uFFFF# : 'A-Z_a-z'", "", 1, 170 },
	{ /* 288 */ "\\x0-\\t\\v-\\f\\xE-\\x1F!-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-\\x1F!-@[-^`{-\\uFFFF#", "", 1, 170 },
	{ /* 289 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-/:-@[]-^`{-\\uFFFF# : '>'", "", 1, 164 },
	{ /* 290 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-/:-@[]-^`{-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F!#-/:-=?-@[]-^`{-\\uFFFF#", "", 1, 164 },
	{ /* 291 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!-/:-@[-^`{-\\uFFFF# : '>'", "", 1, 165 },
	{ /* 292 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!-/:-@[-^`{-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\x1F!-/:-=?-@[-^`{-\\uFFFF#", "", 1, 165 },
	{ /* 293 */ "\\x0-\\b\\v-&(-/:-[]-\\uFFFF# : '>'", "", 1, 166 },
	{ /* 294 */ "\\x0-\\b\\v-&(-/:-[]-\\uFFFF# : \\x0-\\b\\v-&(-/:-=?-[]-\\uFFFF#", "", 1, 166 },
	{ /* 295 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!-/:-=?-@[-^`{-\\uFFFF# : '<'", "", 1, 160 },
	{ /* 296 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!-/:-=?-@[-^`{-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\x1F!-/:-;=?-@[-^`{-\\uFFFF#", "", 1, 160 },
	{ /* 297 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-/:-=?-@[]-^`{-\\uFFFF# : '<'", "", 1, 161 },
	{ /* 298 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-/:-=?-@[]-^`{-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F!#-/:-;=?-@[]-^`{-\\uFFFF#", "", 1, 161 },
	{ /* 299 */ "\\x0-\\t\\v-\\f\\xE-\\x1F!-@[-^`{-\\uFFFF# : '<'", "", 1, 162 },
	{ /* 300 */ "\\x0-\\t\\v-\\f\\xE-\\x1F!-@[-^`{-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-\\x1F!-;=-@[-^`{-\\uFFFF#", "", 1, 162 },
	{ /* 301 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!-/:-=?-@[-^`{-\\uFFFF# : '<'", "", 1, 163 },
	{ /* 302 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!-/:-=?-@[-^`{-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F!-/:-;=?-@[-^`{-\\uFFFF#", "", 1, 163 },
	{ /* 303 */ "\\x0-\\t\\v-\\f\\xE-\\x1F!-;=-@[-^`{-\\uFFFF# : '\"'", "", 1, 156 },
	{ /* 304 */ "\\x0-\\t\\v-\\f\\xE-\\x1F!-;=-@[-^`{-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-\\x1F!#-;=-@[-^`{-\\uFFFF#", "", 1, 156 },
	{ /* 305 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!-/:-;=?-@[-^`{-\\uFFFF# : '\"'", "", 1, 158 },
	{ /* 306 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!-/:-;=?-@[-^`{-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\x1F!#-/:-;=?-@[-^`{-\\uFFFF#", "", 1, 158 },
	{ /* 307 */ "\\x0-\\b\\v-&(-/:-=?-[]-\\uFFFF# : '\"'", "", 1, 159 },
	{ /* 308 */ "\\x0-\\b\\v-&(-/:-=?-[]-\\uFFFF# : \\x0-\\b\\v-!#-&(-/:-=?-[]-\\uFFFF#", "", 1, 159 },
	{ /* 309 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!#-/:-;=?-@[-^`{-\\uFFFF# : '\\\\'", "", 1, 153 },
	{ /* 310 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!#-/:-;=?-@[-^`{-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\x1F!#-/:-;=?-@[]-^`{-\\uFFFF#", "", 1, 153 },
	{ /* 311 */ "\\x0-\\t\\v-\\f\\xE-\\x1F!#-;=-@[-^`{-\\uFFFF# : '\\\\'", "", 1, 154 },
	{ /* 312 */ "\\x0-\\t\\v-\\f\\xE-\\x1F!#-;=-@[-^`{-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-\\x1F!#-;=-@[]-^`{-\\uFFFF#", "", 1, 154 },
	{ /* 313 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!-/:-;=?-@[-^`{-\\uFFFF# : '\\\\'", "", 1, 155 },
	{ /* 314 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!-/:-;=?-@[-^`{-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F!-/:-;=?-@[]-^`{-\\uFFFF#", "", 1, 155 },
	{ /* 315 */ "\\x0-\\t\\v-\\f\\xE-\\x1F!#-;=-@[]-^`{-\\uFFFF# : '''", "", 1, 150 },
	{ /* 316 */ "\\x0-\\t\\v-\\f\\xE-\\x1F!#-;=-@[]-^`{-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-\\x1F!#-&(-;=-@[]-^`{-\\uFFFF#", "", 1, 150 },
	{ /* 317 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!#-/:-;=?-@[]-^`{-\\uFFFF# : '''", "", 1, 151 },
	{ /* 318 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!#-/:-;=?-@[]-^`{-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\x1F!#-&(-/:-;=?-@[]-^`{-\\uFFFF#", "", 1, 151 },
	{ /* 319 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-/:-;=?-@[]-^`{-\\uFFFF# : '''", "", 1, 157 },
	{ /* 320 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-/:-;=?-@[]-^`{-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F!#-&(-/:-;=?-@[]-^`{-\\uFFFF#", "", 1, 157 },
	{ /* 321 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!#-&(-/:-;=?-@[]-^`{-\\uFFFF# : '!'", "", 1, 147 },
	{ /* 322 */ "\\x1-\\b\\v-\\f\\xE-\\x1F!#-&(-/:-;=?-@[]-^`{-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\x1F#-&(-/:-;=?-@[]-^`{-\\uFFFF#", "", 1, 147 },
	{ /* 323 */ "\\x0-\\t\\v-\\f\\xE-\\x1F!#-&(-;=-@[]-^`{-\\uFFFF# : '!'", "", 1, 148 },
	{ /* 324 */ "\\x0-\\t\\v-\\f\\xE-\\x1F!#-&(-;=-@[]-^`{-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-\\x1F#-&(-;=-@[]-^`{-\\uFFFF#", "", 1, 148 },
	{ /* 325 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!-/:-;=?-@[]-^`{-\\uFFFF# : '!'", "", 1, 149 },
	{ /* 326 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!-/:-;=?-@[]-^`{-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F\"-/:-;=?-@[]-^`{-\\uFFFF#", "", 1, 149 },
	{ /* 327 */ "\\x0-\\b\\v-!#-&(-/:-=?-[]-\\uFFFF# : '!'", "", 1, 152 },
	{ /* 328 */ "\\x0-\\b\\v-!#-&(-/:-=?-[]-\\uFFFF# : \\x0-\\b\\v- #-&(-/:-=?-[]-\\uFFFF#", "", 1, 152 },
	{ /* 329 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-/:-;=?-@[]-^`{-\\uFFFF# : '.'", "", 1, 143 },
	{ /* 330 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-/:-;=?-@[]-^`{-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F\"--/:-;=?-@[]-^`{-\\uFFFF#", "", 1, 143 },
	{ /* 331 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&(-;=-@[]-^`{-\\uFFFF# : '.'", "", 1, 144 },
	{ /* 332 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&(-;=-@[]-^`{-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-\\x1F#-&(--/-;=-@[]-^`{-\\uFFFF#", "", 1, 144 },
	{ /* 333 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&(-/:-;=?-@[]-^`{-\\uFFFF# : '.'", "", 1, 145 },
	{ /* 334 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&(-/:-;=?-@[]-^`{-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\x1F#-&(--/:-;=?-@[]-^`{-\\uFFFF#", "", 1, 145 },
	{ /* 335 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-&(-/:-;=?-@[]-^`{-\\uFFFF# : '.'", "", 1, 146 },
	{ /* 336 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-&(-/:-;=?-@[]-^`{-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F!#-&(--/:-;=?-@[]-^`{-\\uFFFF#", "", 1, 146 },
	{ /* 337 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&(--/:-;=?-@[]-^`{-\\uFFFF# : '?'", "", 1, 139 },
	{ /* 338 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&(--/:-;=?-@[]-^`{-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\x1F#-&(--/:-;=@[]-^`{-\\uFFFF#", "", 1, 139 },
	{ /* 339 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&(--/-;=-@[]-^`{-\\uFFFF# : '?'", "", 1, 140 },
	{ /* 340 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&(--/-;=-@[]-^`{-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-\\x1F#-&(--/-;=->@[]-^`{-\\uFFFF#", "", 1, 140 },
	{ /* 341 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"--/:-;=?-@[]-^`{-\\uFFFF# : '?'", "", 1, 141 },
	{ /* 342 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"--/:-;=?-@[]-^`{-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F\"--/:-;=@[]-^`{-\\uFFFF#", "", 1, 141 },
	{ /* 343 */ "\\x0-\\b\\v- #-&(-/:-=?-[]-\\uFFFF# : '?'", "", 1, 142 },
	{ /* 344 */ "\\x0-\\b\\v- #-&(-/:-=?-[]-\\uFFFF# : \\x0-\\b\\v- #-&(-/:-=@-[]-\\uFFFF#", "", 1, 142 },
	{ /* 345 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"--/:-;=@[]-^`{-\\uFFFF# : '+'", "", 1, 135 },
	{ /* 346 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"--/:-;=@[]-^`{-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F\"-*,--/:-;=@[]-^`{-\\uFFFF#", "", 1, 135 },
	{ /* 347 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&(--/-;=->@[]-^`{-\\uFFFF# : '+'", "", 1, 136 },
	{ /* 348 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&(--/-;=->@[]-^`{-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-\\x1F#-&(-*,--/-;=->@[]-^`{-\\uFFFF#", "", 1, 136 },
	{ /* 349 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&(--/:-;=@[]-^`{-\\uFFFF# : '+'", "", 1, 137 },
	{ /* 350 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&(--/:-;=@[]-^`{-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\x1F#-&(-*,--/:-;=@[]-^`{-\\uFFFF#", "", 1, 137 },
	{ /* 351 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-&(--/:-;=?-@[]-^`{-\\uFFFF# : '+'", "", 1, 138 },
	{ /* 352 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-&(--/:-;=?-@[]-^`{-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F!#-&(-*,--/:-;=?-@[]-^`{-\\uFFFF#", "", 1, 138 },
	{ /* 353 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&(-*,--/:-;=@[]-^`{-\\uFFFF# : '*'", "", 1, 131 },
	{ /* 354 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&(-*,--/:-;=@[]-^`{-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\x1F#-&(-),--/:-;=@[]-^`{-\\uFFFF#", "", 1, 131 },
	{ /* 355 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&(-*,--/-;=->@[]-^`{-\\uFFFF# : '*'", "", 1, 132 },
	{ /* 356 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&(-*,--/-;=->@[]-^`{-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-\\x1F#-&(-),--/-;=->@[]-^`{-\\uFFFF#", "", 1, 132 },
	{ /* 357 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-*,--/:-;=@[]-^`{-\\uFFFF# : '*'", "", 1, 133 },
	{ /* 358 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-*,--/:-;=@[]-^`{-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F\"-),--/:-;=@[]-^`{-\\uFFFF#", "", 1, 133 },
	{ /* 359 */ "\\x0-\\b\\v- #-&(-/:-=@-[]-\\uFFFF# : '*'", "", 1, 134 },
	{ /* 360 */ "\\x0-\\b\\v- #-&(-/:-=@-[]-\\uFFFF# : \\x0-\\b\\v- #-&(-)+-/:-=@-[]-\\uFFFF#", "", 1, 134 },
	{ /* 361 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-),--/:-;=@[]-^`{-\\uFFFF# : ')'", "", 1, 127 },
	{ /* 362 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-),--/:-;=@[]-^`{-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F\"-(,--/:-;=@[]-^`{-\\uFFFF#", "", 1, 127 },
	{ /* 363 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&(-),--/-;=->@[]-^`{-\\uFFFF# : ')'", "", 1, 128 },
	{ /* 364 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&(-),--/-;=->@[]-^`{-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-\\x1F#-&(,--/-;=->@[]-^`{-\\uFFFF#", "", 1, 128 },
	{ /* 365 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&(-),--/:-;=@[]-^`{-\\uFFFF# : ')'", "", 1, 129 },
	{ /* 366 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&(-),--/:-;=@[]-^`{-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\x1F#-&(,--/:-;=@[]-^`{-\\uFFFF#", "", 1, 129 },
	{ /* 367 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-&(-*,--/:-;=?-@[]-^`{-\\uFFFF# : ')'", "", 1, 130 },
	{ /* 368 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-&(-*,--/:-;=?-@[]-^`{-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F!#-&(*,--/:-;=?-@[]-^`{-\\uFFFF#", "", 1, 130 },
	{ /* 369 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&(,--/:-;=@[]-^`{-\\uFFFF# : '('", "", 1, 123 },
	{ /* 370 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&(,--/:-;=@[]-^`{-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\x1F#-&,--/:-;=@[]-^`{-\\uFFFF#", "", 1, 123 },
	{ /* 371 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&(,--/-;=->@[]-^`{-\\uFFFF# : '('", "", 1, 124 },
	{ /* 372 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&(,--/-;=->@[]-^`{-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-\\x1F#-&,--/-;=->@[]-^`{-\\uFFFF#", "", 1, 124 },
	{ /* 373 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-(,--/:-;=@[]-^`{-\\uFFFF# : '('", "", 1, 125 },
	{ /* 374 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-(,--/:-;=@[]-^`{-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F\"-',--/:-;=@[]-^`{-\\uFFFF#", "", 1, 125 },
	{ /* 375 */ "\\x0-\\b\\v- #-&(-)+-/:-=@-[]-\\uFFFF# : '('", "", 1, 126 },
	{ /* 376 */ "\\x0-\\b\\v- #-&(-)+-/:-=@-[]-\\uFFFF# : \\x0-\\b\\v- #-&)+-/:-=@-[]-\\uFFFF#", "", 1, 126 },
	{ /* 377 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-',--/:-;=@[]-^`{-\\uFFFF# : '='", "", 1, 119 },
	{ /* 378 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-',--/:-;=@[]-^`{-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F\"-',--/:-;@[]-^`{-\\uFFFF#", "", 1, 119 },
	{ /* 379 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&,--/-;=->@[]-^`{-\\uFFFF# : '='", "", 1, 120 },
	{ /* 380 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&,--/-;=->@[]-^`{-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-\\x1F#-&,--/-;>@[]-^`{-\\uFFFF#", "", 1, 120 },
	{ /* 381 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&,--/:-;=@[]-^`{-\\uFFFF# : '='", "", 1, 121 },
	{ /* 382 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&,--/:-;=@[]-^`{-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\x1F#-&,--/:-;@[]-^`{-\\uFFFF#", "", 1, 121 },
	{ /* 383 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-&(*,--/:-;=?-@[]-^`{-\\uFFFF# : '='", "", 1, 122 },
	{ /* 384 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-&(*,--/:-;=?-@[]-^`{-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F!#-&(*,--/:-;?-@[]-^`{-\\uFFFF#", "", 1, 122 },
	{ /* 385 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&,--/:-;@[]-^`{-\\uFFFF# : '|'", "", 1, 115 },
	{ /* 386 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&,--/:-;@[]-^`{-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\x1F#-&,--/:-;@[]-^`{}-\\uFFFF#", "", 1, 115 },
	{ /* 387 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&,--/-;>@[]-^`{-\\uFFFF# : '|'", "", 1, 116 },
	{ /* 388 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&,--/-;>@[]-^`{-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-\\x1F#-&,--/-;>@[]-^`{}-\\uFFFF#", "", 1, 116 },
	{ /* 389 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-',--/:-;@[]-^`{-\\uFFFF# : '|'", "", 1, 117 },
	{ /* 390 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-',--/:-;@[]-^`{-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F\"-',--/:-;@[]-^`{}-\\uFFFF#", "", 1, 117 },
	{ /* 391 */ "\\x0-\\b\\v- #-&)+-/:-=@-[]-\\uFFFF# : '|'", "", 1, 118 },
	{ /* 392 */ "\\x0-\\b\\v- #-&)+-/:-=@-[]-\\uFFFF# : \\x0-\\b\\v- #-&)+-/:-=@-[]-{}-\\uFFFF#", "", 1, 118 },
	{ /* 393 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-',--/:-;@[]-^`{}-\\uFFFF# : '$'", "", 1, 111 },
	{ /* 394 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-',--/:-;@[]-^`{}-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F\"-#%-',--/:-;@[]-^`{}-\\uFFFF#", "", 1, 111 },
	{ /* 395 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&,--/-;>@[]-^`{}-\\uFFFF# : '$'", "", 1, 112 },
	{ /* 396 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#-&,--/-;>@[]-^`{}-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-\\x1F#%-&,--/-;>@[]-^`{}-\\uFFFF#", "", 1, 112 },
	{ /* 397 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&,--/:-;@[]-^`{}-\\uFFFF# : '$'", "", 1, 113 },
	{ /* 398 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#-&,--/:-;@[]-^`{}-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\x1F#%-&,--/:-;@[]-^`{}-\\uFFFF#", "", 1, 113 },
	{ /* 399 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-&(*,--/:-;?-@[]-^`{-\\uFFFF# : '$'", "", 1, 114 },
	{ /* 400 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#-&(*,--/:-;?-@[]-^`{-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F!#%-&(*,--/:-;?-@[]-^`{-\\uFFFF#", "", 1, 114 },
	{ /* 401 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#%-&,--/:-;@[]-^`{}-\\uFFFF# : '@'", "", 1, 107 },
	{ /* 402 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#%-&,--/:-;@[]-^`{}-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\x1F#%-&,--/:-;[]-^`{}-\\uFFFF#", "", 1, 107 },
	{ /* 403 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#%-&,--/-;>@[]-^`{}-\\uFFFF# : '@'", "", 1, 108 },
	{ /* 404 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#%-&,--/-;>@[]-^`{}-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-\\x1F#%-&,--/-;>[]-^`{}-\\uFFFF#", "", 1, 108 },
	{ /* 405 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-#%-',--/:-;@[]-^`{}-\\uFFFF# : '@'", "", 1, 109 },
	{ /* 406 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-#%-',--/:-;@[]-^`{}-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F\"-#%-',--/:-;[]-^`{}-\\uFFFF#", "", 1, 109 },
	{ /* 407 */ "\\x0-\\b\\v- #-&)+-/:-=@-[]-{}-\\uFFFF# : '@'", "", 1, 110 },
	{ /* 408 */ "\\x0-\\b\\v- #-&)+-/:-=@-[]-{}-\\uFFFF# : \\x0-\\b\\v- #-&)+-/:-=A-[]-{}-\\uFFFF#", "", 1, 110 },
	{ /* 409 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-#%-',--/:-;[]-^`{}-\\uFFFF# : ':'", "", 1, 103 },
	{ /* 410 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-#%-',--/:-;[]-^`{}-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F\"-#%-',--/;[]-^`{}-\\uFFFF#", "", 1, 103 },
	{ /* 411 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#%-&,--/-;>[]-^`{}-\\uFFFF# : ':'", "", 1, 104 },
	{ /* 412 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#%-&,--/-;>[]-^`{}-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-\\x1F#%-&,--/-9;>[]-^`{}-\\uFFFF#", "", 1, 104 },
	{ /* 413 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#%-&,--/:-;[]-^`{}-\\uFFFF# : ':'", "", 1, 105 },
	{ /* 414 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#%-&,--/:-;[]-^`{}-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\x1F#%-&,--/;[]-^`{}-\\uFFFF#", "", 1, 105 },
	{ /* 415 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#%-&(*,--/:-;?-@[]-^`{-\\uFFFF# : ':'", "", 1, 106 },
	{ /* 416 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#%-&(*,--/:-;?-@[]-^`{-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F!#%-&(*,--/;?-@[]-^`{-\\uFFFF#", "", 1, 106 },
	{ /* 417 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#%-&,--/;[]-^`{}-\\uFFFF# : '#'", "", 1, 99 },
	{ /* 418 */ "\\x1-\\b\\v-\\f\\xE-\\x1F#%-&,--/;[]-^`{}-\\uFFFF# : \\x1-\\b\\v-\\f\\xE-\\x1F%-&,--/;[]-^`{}-\\uFFFF#", "", 1, 99 },
	{ /* 419 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#%-&,--/-9;>[]-^`{}-\\uFFFF# : '#'", "", 1, 100 },
	{ /* 420 */ "\\x0-\\t\\v-\\f\\xE-\\x1F#%-&,--/-9;>[]-^`{}-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-\\x1F%-&,--/-9;>[]-^`{}-\\uFFFF#", "", 1, 100 },
	{ /* 421 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-#%-',--/;[]-^`{}-\\uFFFF# : '#'", "", 1, 101 },
	{ /* 422 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"-#%-',--/;[]-^`{}-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F\"%-',--/;[]-^`{}-\\uFFFF#", "", 1, 101 },
	{ /* 423 */ "\\x0-\\b\\v- #-&)+-/:-=A-[]-{}-\\uFFFF# : '#'", "", 1, 102 },
	{ /* 424 */ "\\x0-\\b\\v- #-&)+-/:-=A-[]-{}-\\uFFFF# : \\x0-\\b\\v- $-&)+-/:-=A-[]-{}-\\uFFFF#", "", 1, 102 },
	{ /* 425 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"%-',--/;[]-^`{}-\\uFFFF# : ';'", "", 1, 95 },
	{ /* 426 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"%-',--/;[]-^`{}-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F\"%-',--/[]-^`{}-\\uFFFF#", "", 1, 95 },
	{ /* 427 */ "\\x0-\\t\\v-\\f\\xE-\\x1F%-&,--/-9;>[]-^`{}-\\uFFFF# : ';'", "", 1, 96 },
	{ /* 428 */ "\\x0-\\t\\v-\\f\\xE-\\x1F%-&,--/-9;>[]-^`{}-\\uFFFF# : \\x0-\\t\\v-\\f\\xE-\\x1F%-&,--/-9>[]-^`{}-\\uFFFF#", "", 1, 96 },
	{ /* 429 */ "\\x1-\\b\\v-\\f\\xE-\\x1F%-&,--/;[]-^`{}-\\uFFFF# : ';'", "", 1, 97 },
	{ /* 430 */ "\\x1-\\b\\v-\\f\\xE-\\x1F%-&,--/;[]-^`{}-\\uFFFF# : '\\x1-\\b\\v-\\f\\xE-\\x1F%-&,--/[]-^`{}-\\uFFFF'", "", 1, 97 },
	{ /* 431 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#%-&(*,--/;?-@[]-^`{-\\uFFFF# : ';'", "", 1, 98 },
	{ /* 432 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#%-&(*,--/;?-@[]-^`{-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F!#%-&(*,--/?-@[]-^`{-\\uFFFF#", "", 1, 98 },
	{ /* 433 */ "\\x0-\\t\\v-\\f\\xE-\\x1F%-&,--/-9>[]-^`{}-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F%-&,--/[]-^`{}-\\uFFFF#", "", 1, 92 },
	{ /* 434 */ "\\x0-\\t\\v-\\f\\xE-\\x1F%-&,--/-9>[]-^`{}-\\uFFFF# : \\t0-9>#", "", 1, 92 },
	{ /* 435 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"%-',--/[]-^`{}-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F%-&,--/[]-^`{}-\\uFFFF#", "", 1, 93 },
	{ /* 436 */ "\\x0-\\b\\v-\\f\\xE-\\x1F\"%-',--/[]-^`{}-\\uFFFF# : \"'#", "", 1, 93 },
	{ /* 437 */ "\\x0-\\b\\v- $-&)+-/:-=A-[]-{}-\\uFFFF# : \\x0-\\b\\v-\\f\\xE-\\x1F%-&,--/[]-^`{}-\\uFFFF#", "", 1, 94 },
	{ /* 438 */ "\\x0-\\b\\v- $-&)+-/:-=A-[]-{}-\\uFFFF# : \\r $)+.:-=A-Z_a-z#", "", 1, 94 },
	{ /* 439 */ "\\x0-\\b\\v-\\f\\xE-\\x1F%-&,--/[]-^`{}-\\uFFFF# : '\\x1-\\b\\v-\\f\\xE-\\x1F%-&,--/[]-^`{}-\\uFFFF'", "", 1, 90 },
	{ /* 440 */ "\\x0-\\b\\v-\\f\\xE-\\x1F%-&,--/[]-^`{}-\\uFFFF# : '\\x0'", "", 1, 90 },
	{ /* 441 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#%-&(*,--/?-@[]-^`{-\\uFFFF# : '\\x1-\\b\\v-\\f\\xE-\\x1F%-&,--/[]-^`{}-\\uFFFF'", "", 1, 91 },
	{ /* 442 */ "\\x0-\\b\\v-\\f\\xE-\\x1F!#%-&(*,--/?-@[]-^`{-\\uFFFF# : \\x0!#(*?-@|#", "", 1, 91 },
	{ /* 443 */ "\\r $)+.:-=A-Z_a-z# : '\\r'", "", 1, 87 },
	{ /* 444 */ "\\r $)+.:-=A-Z_a-z# :  $)+.:-=A-Z_a-z#", "", 1, 87 },
	{ /* 445 */ "\\t0-9># : '\\t'", "", 1, 89 },
	{ /* 446 */ "\\t0-9># : 0-9>#", "", 1, 89 },
	{ /* 447 */ " $)+.:-=A-Z_a-z# : ' '", "", 1, 85 },
	{ /* 448 */ " $)+.:-=A-Z_a-z# : $)+.:-=A-Z_a-z#", "", 1, 85 },
	{ /* 449 */ "0-9># : '0-9'", "", 1, 84 },
	{ /* 450 */ "0-9># : '>'", "", 1, 84 },
	{ /* 451 */ "$)+.:-=A-Z_a-z# : 'A-Z_a-z'", "", 1, 83 },
	{ /* 452 */ "$)+.:-=A-Z_a-z# : $)+.:-=#", "", 1, 83 },
	{ /* 453 */ "$)+.:-=# : '<'", "", 1, 82 },
	{ /* 454 */ "$)+.:-=# : $)+.:-;=#", "", 1, 82 },
	{ /* 455 */ "\"'# : '\"'", "", 1, 88 },
	{ /* 456 */ "\"'# : '''", "", 1, 88 },
	{ /* 457 */ "\\x0!#(*?-@|# : '!'", "", 1, 86 },
	{ /* 458 */ "\\x0!#(*?-@|# : \\x0#(*?-@|#", "", 1, 86 },
	{ /* 459 */ "$)+.:-;=# : '.'", "", 1, 81 },
	{ /* 460 */ "$)+.:-;=# : $)+:-;=#", "", 1, 81 },
	{ /* 461 */ "\\x0#(*?-@|# : '?'", "", 1, 80 },
	{ /* 462 */ "\\x0#(*?-@|# : \\x0#(*@|#", "", 1, 80 },
	{ /* 463 */ "$)+:-;=# : '+'", "", 1, 79 },
	{ /* 464 */ "$)+:-;=# : $):-;=#", "", 1, 79 },
	{ /* 465 */ "\\x0#(*@|# : '*'", "", 1, 78 },
	{ /* 466 */ "\\x0#(*@|# : \\x0#(@|#", "", 1, 78 },
	{ /* 467 */ "$):-;=# : ')'", "", 1, 77 },
	{ /* 468 */ "$):-;=# : $:-;=#", "", 1, 77 },
	{ /* 469 */ "\\x0#(@|# : '('", "", 1, 76 },
	{ /* 470 */ "\\x0#(@|# : \\x0#@|#", "", 1, 76 },
	{ /* 471 */ "$:-;=# : '='", "", 1, 75 },
	{ /* 472 */ "$:-;=# : $:-;#", "", 1, 75 },
	{ /* 473 */ "\\x0#@|# : '|'", "", 1, 74 },
	{ /* 474 */ "\\x0#@|# : \\x0#@#", "", 1, 74 },
	{ /* 475 */ "$:-;# : '$'", "", 1, 73 },
	{ /* 476 */ "$:-;# : :-;#", "", 1, 73 },
	{ /* 477 */ "\\x0#@# : '@'", "", 1, 72 },
	{ /* 478 */ "\\x0#@# : \\x0##", "", 1, 72 },
	{ /* 479 */ ":-;# : ':'", "", 1, 71 },
	{ /* 480 */ ":-;# : ';'", "", 1, 71 },
	{ /* 481 */ "\\x0## : '#'", "", 1, 70 },
	{ /* 482 */ "\\x0## : '\\x0'", "", 1, 70 }
};

UNICC_STATIC UNICC_SCHAR* _lexem( _pcb* pcb )
{
#if UNICC_WCHAR || !UNICC_UTF8
	pcb->lexem = pcb->buf;
#else
	size_t		size;

	size = wcstombs( (char*)NULL, pcb->buf, 0 );

	if( pcb->lexem )
		free( pcb->lexem );

	if( !( pcb->lexem = (UNICC_SCHAR*)malloc(
			( size + 1 ) * sizeof( UNICC_SCHAR ) ) ) )
	{
		UNICC_OUTOFMEM( pcb );
		return (UNICC_SCHAR*)NULL;
	}

	wcstombs( pcb->lexem, pcb->buf, size + 1 );
#endif

#if UNICC_DEBUG	> 2
	fprintf( stderr, "%s: lexem: pcb->lexem = >" UNICC_SCHAR_FORMAT "<\n",
						UNICC_PARSER, pcb->lexem );
#endif
	return pcb->lexem;
}

UNICC_STATIC _ast* _ast_free( _ast* node )
{
	if( !node )
		return (_ast*)NULL;

	_ast_free( node->child );
	_ast_free( node->next );

	if( node->token )
		free( node->token );

	free( node );
	return (_ast*)NULL;
}

UNICC_STATIC _ast* _ast_create( _pcb* pcb, char* emit,
													UNICC_SCHAR* token )
{
	_ast*	node;

	if( !( node = (_ast*)malloc( sizeof( _ast ) ) ) )
	{
		UNICC_OUTOFMEM( pcb );
		return node;
	}

	memset( node, 0, sizeof( _ast ) );

	node->emit = emit;

	if( token )
	{
		#if !UNICC_WCHAR
		if( !( node->token = strdup( token ) ) )
		{
			UNICC_OUTOFMEM( pcb );
			free( node );
			return (_ast*)NULL;
		}
		#else
		if( !( node->token = wcsdup( token ) ) )
		{
			UNICC_OUTOFMEM( pcb );
			free( node );
			return (_ast*)NULL;
		}
		#endif
	}

	return node;
}

UNICC_STATIC void _ast_print( FILE* stream, _ast* node )
{
	int 		i;
	static int 	rec;

	if( !node )
		return;

	if( !stream )
		stream = stderr;

	while( node )
	{
		for( i = 0; i < rec; i++ )
			fprintf( stream,  " " );

		fprintf( stream, "%s", node->emit );

		if( node->token && strcmp( node->emit, node->token ) != 0 )
			fprintf( stream, " (%s)", node->token );

		fprintf( stream, "\n" );

		rec++;
		_ast_print( stream, node->child );
		rec--;

		node = node->next;
	}
}

UNICC_STATIC int _get_act( _pcb* pcb )
{
	int i;

	for( i = 1; i < _act[ pcb->tos->state ][0] * 3; i += 3 )
	{
		if( _act[ pcb->tos->state ][i] == pcb->sym )
		{
			if( ( pcb->act = _act[ pcb->tos->state ][i+1] )
					== UNICC_ERROR )
				return 0; /* Force parse error! */

			pcb->idx = _act[ pcb->tos->state ][i+2];
			return 1;
		}
	}
	
	/* Default production */
	if( ( pcb->idx = _def_prod[ pcb->tos->state ] ) > -1 )
	{
		pcb->act = 1; /* Reduce */
		return 1;
	}

	return 0;
}

UNICC_STATIC int _get_go( _pcb* pcb )
{
	int i;

	for( i = 1; i < _go[ pcb->tos->state ][0] * 3; i += 3 )
	{
		if( _go[ pcb->tos->state ][i] == pcb->lhs )
		{
			pcb->act = _go[ pcb->tos->state ][ i + 1 ];
			pcb->idx = _go[ pcb->tos->state ][ i + 2 ];
			return 1;
		}
	}

	return 0;
}

UNICC_STATIC int _alloc_stack( _pcb* pcb )
{
	unsigned int	size;

	if( !pcb->stacksize )
	{
		if( !( pcb->tos = pcb->stack = (_tok*)malloc(
				UNICC_MALLOCSTEP * sizeof( _tok ) ) ) )
		{
			UNICC_OUTOFMEM( pcb );
			return -1;
		}

		pcb->stacksize = UNICC_MALLOCSTEP;
	}
	else if( ( size = (unsigned int)( pcb->tos - pcb->stack ) )
				== pcb->stacksize )
	{
		_tok*	ptr;

		if( !( ptr = (_tok*)realloc( pcb->stack,
				( pcb->stacksize + UNICC_MALLOCSTEP )
					* sizeof( _tok ) ) ) )
		{
			UNICC_OUTOFMEM( pcb );

			if( pcb->stack )
				free( pcb->stack );

			return -1;
		}

		pcb->tos = pcb->stack = ptr;

		pcb->stacksize += UNICC_MALLOCSTEP;
		pcb->tos += size;
	}

	return 0;
}

#ifndef UNICC_GETINPUT

#if UNICC_UTF8
static int offsets_utf8[ 6 ] =
{
    0x00000000UL, 0x00003080UL, 0x000E2080UL,
    0x03C82080UL, 0xFA082080UL, 0x82082080UL
};

static int trailbyte_utf8[ 256 ] =
{
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2, 3,3,3,3,3,3,3,3,4,4,4,4,5,5,5,5
};

UNICC_STATIC UNICC_CHAR _utf8_getchar( int (*getfn)() )
{
	UNICC_CHAR	ch	= 0;
	int 		nb;
	int			c;
	
	if( !getfn )
		getfn = getchar;

	switch( ( nb = trailbyte_utf8[ ( c = (*getfn)() ) ] ) )
	{
        case 3:
			ch += c;
			ch <<= 6;
			c = (*getfn)();
        case 2:
			ch += c;
			ch <<= 6;
			c = (*getfn)();
        case 1:
			ch += c;
			ch <<= 6;
			c = (*getfn)();
        case 0:
			ch += c;
			break;
	}
	
	ch -= offsets_utf8[ nb ];
#if UNICC_DEBUG	> 3
	fprintf( stderr, "%s: getchar: %d\n", UNICC_PARSER, ch );
#endif
	return ch;
}
#define UNICC_GETINPUT		_utf8_getchar( getchar )

#else
#define UNICC_GETINPUT		getchar()
#endif

#endif

UNICC_STATIC UNICC_CHAR _get_input( _pcb* pcb, unsigned int offset )
{
#if UNICC_DEBUG	> 2
	fprintf( stderr, "%s: get input: pcb->buf + offset = %p pcb->bufend = %p\n",
				UNICC_PARSER, pcb->buf + offset, pcb->bufend );
#endif

	while( pcb->buf + offset >= pcb->bufend )
	{
#if UNICC_DEBUG	> 2
			fprintf( stderr, "%s: get input: requiring more input\n",
					UNICC_PARSER );
#endif
		if( !pcb->buf )
		{
			pcb->bufend = pcb->buf = (UNICC_CHAR*)malloc(
				( UNICC_MALLOCSTEP + 1 ) * sizeof( UNICC_CHAR ) );

			if( !pcb->buf )
			{
				UNICC_OUTOFMEM( pcb );
				return 0;
			}

			*pcb->buf = 0;
		}
		else if( *pcb->buf && !( ( pcb->bufend - pcb->buf ) %
					UNICC_MALLOCSTEP ) )
		{
			unsigned int 	size	= (unsigned int)( pcb->bufend - pcb->buf );
			UNICC_CHAR*		buf;

			if( !( buf = (UNICC_CHAR*)realloc( pcb->buf,
						( size + UNICC_MALLOCSTEP + 1 )
							* sizeof( UNICC_CHAR ) ) ) )
			{
				UNICC_OUTOFMEM( pcb );

				if( pcb->buf )
					free( pcb->buf );

				return 0;
			}

			pcb->buf = buf;
			pcb->bufend = pcb->buf + size;
		}

		if( pcb->is_eof || ( *( pcb->bufend ) = (UNICC_CHAR)UNICC_GETINPUT )
									== pcb->eof )
		{
#if UNICC_DEBUG	> 2
			fprintf( stderr, "%s: get input: can't get more input, "
						"end-of-file reached\n", UNICC_PARSER );
#endif
			pcb->is_eof = 1;
			return pcb->eof;
		}
#if UNICC_DEBUG	> 2
		fprintf( stderr, "%s: get input: read char >%c< %d\n",
					UNICC_PARSER, (char)*( pcb->bufend ), *( pcb->bufend ) );
#endif

#if UNICC_DEBUG	> 2
		fprintf( stderr, "%s: get input: reading character >%c< %d\n",
					UNICC_PARSER, (char)*( pcb->bufend ), *( pcb->bufend ) );
#endif

		*( ++pcb->bufend ) = 0;
	}

#if UNICC_DEBUG	> 2
	{
		UNICC_CHAR*		chptr;

		fprintf( stderr, "%s: get input: offset = %d\n",
					UNICC_PARSER, offset );
		fprintf( stderr, "%s: get input: buf = >" UNICC_CHAR_FORMAT "<\n",
					UNICC_PARSER, pcb->buf );
		fprintf( stderr, "%s: get input: returning %d\n",
					UNICC_PARSER, *( pcb->buf + offset ) );
	}
#endif

	return pcb->buf[ offset ];
}

UNICC_STATIC void _clear_input( _pcb* pcb )
{
	int		i;

	if( pcb->buf )
	{
		if( pcb->len )
		{
			/* Update counters for line and column */
			for( i = 0; i < pcb->len; i++ )
			{
				if( (char)pcb->buf[i] == '\n' )
				{
					pcb->line++;
					pcb->column = 1;
				}
				else
					pcb->column++;
			}

#if UNICC_DEBUG > 2
	fprintf( stderr, "%s: clear input: "
		"Clearing %d characters (%d bytes)\n",
			UNICC_PARSER, pcb->len, pcb->len * sizeof( UNICC_CHAR ) );
	fprintf( stderr, "%s: clear input: buf = >" UNICC_CHAR_FORMAT "<\n",
			UNICC_PARSER, pcb->buf, sizeof( UNICC_CHAR ) );
	fprintf( stderr, "%s: clear input: pcb->bufend >" UNICC_CHAR_FORMAT "<\n",
			UNICC_PARSER, pcb->bufend );
#endif

			memmove( pcb->buf, pcb->buf + pcb->len,
						( ( pcb->bufend - ( pcb->buf + pcb->len ) ) + 1 + 1 )
							* sizeof( UNICC_CHAR ) );
			pcb->bufend = pcb->buf + ( pcb->bufend - ( pcb->buf + pcb->len ) );

#if UNICC_DEBUG	> 2
	fprintf( stderr, "%s: clear input: now buf = >" UNICC_CHAR_FORMAT "<\n",
				UNICC_PARSER, pcb->buf, sizeof( UNICC_CHAR ) );
	fprintf( stderr, "%s: clear input: now bufend = >" UNICC_CHAR_FORMAT "<\n",
				UNICC_PARSER, pcb->bufend, sizeof( UNICC_CHAR ) );
#endif
		}
		else
		{
			pcb->bufend = pcb->buf;
			*( pcb->buf ) = 0;
		}
	}
	
	pcb->len = 0;
	pcb->sym = -1;
#if UNICC_DEBUG	> 2
	fprintf( stderr, "%s: clear input: symbol cleared\n", UNICC_PARSER );
#endif
}

#if 81
UNICC_STATIC void _lex( _pcb* pcb )
{
	int 			dfa_st	= 0;
	unsigned int	len		= 0;
	int				chr;
	UNICC_CHAR		next;
#if !0
	int				mach	= _dfa_select[ pcb->tos->state ];
#else
	int				mach	= 0;
#endif

	next = _get_input( pcb, len );
#if UNICC_DEBUG	> 1
fprintf( stderr, "%s: lex: next = %d\n", UNICC_PARSER, next );
#endif
	
	if( next == pcb->eof )
	{
		pcb->sym = 0;
		return;
	}

	do
	{
#if UNICC_DEBUG	> 1
fprintf( stderr, "%s: lex: next = %d\n", UNICC_PARSER, next );
#endif

		chr = _dfa_idx[ mach ][ dfa_st ];
#if UNICC_DEBUG	> 1
fprintf( stderr, "%s: lex: chr = %d\n", UNICC_PARSER, chr );
#endif

		dfa_st = -1;
#if UNICC_DEBUG	> 1
fprintf( stderr, "%s: lex: FIRST next = %d _dfa_chars[ chr ] = %d, "
			"_dfa_chars[ chr+1 ] = %d\n", UNICC_PARSER, next,
				_dfa_chars[ chr ], _dfa_chars[ chr + 1 ] );
#endif
		while( _dfa_chars[ chr ] > -1 )
		{
#if UNICC_DEBUG	> 1
fprintf( stderr, "%s: lex: next = %d _dfa_chars[ chr ] = %d, "
		"_dfa_chars[ chr+1 ] = %d\n", UNICC_PARSER, next,
			_dfa_chars[ chr ], _dfa_chars[ chr + 1 ] );
#endif
			if( next >= _dfa_chars[ chr ] &&
				next <= _dfa_chars[ chr+1 ] )
			{
				dfa_st = *( _dfa_trans + ( chr / 2 ) );
#if UNICC_DEBUG	> 1
fprintf( stderr, "%s: lex: dfa_st = %d\n", UNICC_PARSER, dfa_st );
#endif
				if( _dfa_accept[ mach ][ dfa_st ] > 0 )
				{
					pcb->len = len + 1;
					pcb->sym = _dfa_accept[ mach ][ dfa_st ] - 1;

#if UNICC_DEBUG	> 1
fprintf( stderr, "%s: lex: new accepting symbol pcb->sym = %d greedy = %d\n",
			UNICC_PARSER, pcb->sym, _symbols[ pcb->sym ].greedy );
#endif
					if( pcb->sym == 0 )
					{
						dfa_st = -1; /* test! */
						break;
					}

					/* Stop if matched symbol should be parsed nongreedy */
					if( !_symbols[ pcb->sym ].greedy )
					{
						dfa_st = -1;
						break;
					}
				}

				next = _get_input( pcb, ++len );
				break;
			}

			chr += 2;
		}
	}
	while( dfa_st > -1 && next != pcb->eof );
	
	if( pcb->sym > -1 )
	{
#if UNICC_SEMANTIC_TERM_SEL
		/*
			Execute scanner actions, if existing, but with
			UNICC_ON_SHIFT = 0, so that no memory allocation 
			should be performed. This actions should only be
			handled if there are semantic-code dependent
			terminal symbol selections.

			tos is incremented here, if the semantic code
			stores data for the symbol. It won't get lost
			in case of a shift.
		*/
		_alloc_stack( pcb );
		pcb->tos++;

		next = pcb->buf[ pcb->len ];
		pcb->buf[ pcb->len ] = '\0';
		
#define UNICC_ON_SHIFT 	0
		switch( pcb->sym )
		{
#line 257 "parse.par"
				case 40:
				{
					
						( pcb->tos->value.value_0 ) = _lexem( pcb );
					
					;
				}				break;
	

			default:
				break;
		}
#undef UNICC_ON_SHIFT

		pcb->buf[ pcb->len ] = next;

		pcb->tos--;
#endif /* UNICC_SEMANTIC_TERM_SEL */
	}

#if UNICC_DEBUG	> 1
fprintf( stderr, "%s: lex: function exits, pcb->sym = %d, pcb->len = %d\n",
			UNICC_PARSER, pcb->sym, pcb->len );
#endif
}
#endif

UNICC_STATIC int _get_sym( _pcb* pcb )
{
	pcb->sym = -1;
	pcb->len = 0;

#if 0
	do
	{
#endif
#if !0

#if UNICC_DEBUG > 2
		fprintf( stderr, "%s: get sym: state = %d dfa_select = %d\n",
					UNICC_PARSER, pcb->tos->state,
						_dfa_select[ pcb->tos->state ] );
#endif

		if( _dfa_select[ pcb->tos->state ] > -1 )
			_lex( pcb );
		/* 
		 * If there is no DFA state machine,
		 * try to identify the end-of-file symbol.
		 * If this also fails, a parse error will
		 * raise.
		 */
		else if( _get_input( pcb, 0 ) == pcb->eof )
			pcb->sym = 0;
#else
		_lex( pcb );
#endif /* !0 */

#if 0

		if( pcb->sym > -1 && _symbols[ pcb->sym ].whitespace )
		{
			UNICC_CLEARIN( pcb );
			continue;
		}
		
		break;
	}
	while( 1 );
#endif /* 0 */

	return ( pcb->sym > -1 ) ? 1 : 0;
}

#if UNICC_STACKDEBUG
UNICC_STATIC void _dbg_stack( FILE* out,
	_tok* stack, _tok* tos )
{
	fprintf( out, "%s: Stack Dump: ", UNICC_PARSER );

	for( ; stack <= tos; stack++ )
	{
		fprintf( out, "%d%s%s%s ", stack->state,
			stack->symbol ? " (" : "",
			stack->symbol ? stack->symbol->name : "",
			stack->symbol ? ")" : "" );
	}
	
	fprintf( out, "\n" );
}
#endif /* UNICC_STACKDEBUG */

UNICC_STATIC int _handle_error( _pcb* pcb, FILE* _dbg )
{
#if UNICC_DEBUG
	int					i;
#endif

	if( !pcb->error_delay )
	{
#if UNICC_DEBUG
		fprintf( _dbg, "%s: !!!PARSE ERROR!!!\n"
				"%s: error recovery: current token %d (%s)\n",
					UNICC_PARSER, UNICC_PARSER, pcb->sym,
						( ( pcb->sym >= 0 ) ?
							_symbols[ pcb->sym ].name :
								"(null)" ) );

		fprintf( _dbg,
				"%s: error recovery: expecting ", UNICC_PARSER );
				
		for( i = 1; i < _act[ pcb->tos->state ][0] * 3; i += 3 )
		{
			fprintf( _dbg, "%d (%s)%s",
				_act[ pcb->tos->state ][i],
				_symbols[ _act[ pcb->tos->state ][i] ].name,
				( i == _act[ pcb->tos->state ][0] * 3 - 3 ) ?
						"\n" : ", " );
		}
		
		fprintf( _dbg, "\n%s: error recovery: error_delay is %d, %s\n",
					UNICC_PARSER, pcb->error_delay,
					( pcb->error_delay ? "error recovery runs silently" :
						"error is reported before its recover!" ) );
#endif
	}

#if -1 < 0
	/* No error token defined? Then exit here... */

#if UNICC_DEBUG
	fprintf( _dbg,
		"%s: error recovery: No error resync token used by grammar, "
			"exiting parser.\n", UNICC_PARSER );
#endif

	UNICC_PARSE_ERROR( pcb );
	pcb->error_count++;

	return 1;
#else
	/*
	_pcb 		org_pcb;
	*/

#if UNICC_DEBUG
	fprintf( _dbg, "%s: error recovery: "
		"trying to recover...\n", UNICC_PARSER );
#if UNICC_STACKDEBUG
	_dbg_stack( _dbg, pcb->stack, pcb->tos );
#endif
#endif

	#if 0
	/* Create a copy of original parser control block (maybe later...) */
	memcpy( &org_pcb, pcb, sizeof( _pcb ) );
	org_pcb.buf = (char*)malloc( ( strlen( pcb->buf ) / UNICC_MALLOCSTEP +
					( !( strlen( pcb->buf ) % UNICC_MALLOCSTEP ) ? 1 : 0 ) )
							* UNICC_MALLOCSTEP );
	strcpy( org_pcb.buf, pcb->buf );
	#endif

	/* Remember previous symbol, or discard it */
	if( pcb->error_delay != UNICC_ERROR_DELAY )
		pcb->old_sym = pcb->sym;
	else
	{
		pcb->old_sym = -1;
		pcb->len = 1;
		UNICC_CLEARIN( pcb );
	}

	/* Try to shift on error resync */
	pcb->sym = -1;

	while( pcb->tos >= pcb->stack )
	{
#if UNICC_DEBUG
		fprintf( _dbg, "%s: error recovery: in state %d, trying "
				"to shift error resync token...\n",
					UNICC_PARSER, pcb->tos->state );
#if UNICC_STACKDEBUG
		_dbg_stack( _dbg, pcb->stack, pcb->tos );
#endif
#endif
		if( _get_act( pcb ) )
		{
			/* Shift */
			if( pcb->act & UNICC_SHIFT )
			{
#if UNICC_DEBUG
				fprintf( _dbg, "%s: error recovery: "
							"error resync shifted\n", UNICC_PARSER );
#endif
				break;
			}
		}
		
#if UNICC_DEBUG
		fprintf( _dbg, "%s: error recovery: failed, "
					"discarding token '%s'\n", UNICC_PARSER,
						pcb->tos->symbol ?
							pcb->tos->symbol->name : "NULL" );
#endif

		/* Discard one token from stack */
		/* TODO: Discarded token memory (semantic action) */
		pcb->tos--;
	}

	if( pcb->tos <= pcb->stack )
	{
#if UNICC_DEBUG
	fprintf( _dbg, "%s: error recovery: "
				"Can't recover this issue, stack is empty.\n",
					UNICC_PARSER );	
#endif
		UNICC_PARSE_ERROR( pcb );
		pcb->error_count++;

		return 1;
	}
	
#if UNICC_DEBUG
	fprintf( _dbg, "%s: error recovery: "
				"trying to continue with modified parser state\n",
					UNICC_PARSER );	
#endif

	pcb->error_delay = UNICC_ERROR_DELAY + 1;

	return 0;

#endif /* -1 >= 0 */
}

int _parse( _pcb* pcb )
{
	int			ret;
	int					i;

	_ast*		node;
	_ast*		lnode;

#if UNICC_DEBUG
	_vtype*		vptr;
	FILE* 				_dbg;

	_dbg = stderr;
#endif

	/* If there is no Parser Control Block given, allocate your own one! */
	if( !pcb )
	{
		if( !( pcb = (_pcb*)malloc( sizeof( _pcb ) ) ) )
		{
			/* Can't allocate memory */
			UNICC_OUTOFMEM( pcb );
			return (int)0;
		}

		memset( pcb, 0, sizeof( _pcb ) );
		pcb->is_internal = 1;
	}
	else
		pcb->is_internal = 0;

	/* Initialize Parser Control Block */
	pcb->stacksize = 0;
	if( _alloc_stack( pcb ) < 0 )
		return (int)0;

	memset( pcb->tos, 0, sizeof( _tok ) );

	pcb->act = UNICC_SHIFT;
	pcb->sym = -1;
	pcb->old_sym = -1;
	pcb->line = 1;
	pcb->column = 1;

	memset( &pcb->test, 0, sizeof( _vtype ) );

	/* Begin of main parser loop */
	while( 1 )
	{
		/* Reduce */
		while( pcb->act & UNICC_REDUCE )
		{
#if UNICC_DEBUG
			fprintf( _dbg, "%s: << "
					"reducing by production %d (%s)\n",
						UNICC_PARSER, pcb->idx,
							_productions[ pcb->idx ].definition );
#endif
			/* Set default left-hand side */
			pcb->lhs = _productions[ pcb->idx ].lhs;

			/* Run reduction code */
			memset( &( pcb->ret ), 0, sizeof( _vtype ) );

			switch( pcb->idx )
			{
				case 0:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 1:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 2:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 3:
				{
					 pcb->ret.value_5 = 0; 
					;
				}				break;
					case 4:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 5:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 6:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 7:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 8:
				{
					 pcb->ret.value_5 = 0; 
					;
				}				break;
					case 9:
				{
					
					;
				}				break;
					case 10:
				{
					
					;
				}				break;
					case 11:
				{
					#line 202 "parse.par"

							if( !( parser->p_template ) )
								parser->p_template = pstrdup( strbuf );
							else
								print_error( parser, ERR_DIRECTIVE_ALREADY_USED,
									ERRSTYLE_WARNING | ERRSTYLE_FILEINFO,
										parser->filename, line,
											"!language" );
						
					;
				}				break;
					case 12:
				{
					#line 229 "parse.par"
	parser->p_mode = MODE_SCANNERLESS; 
					;
				}				break;
					case 13:
				{
					#line 231 "parse.par"
	parser->p_mode = MODE_SCANNERLESS; 
					;
				}				break;
					case 14:
				{
					#line 233 "parse.par"
	parser->p_mode = MODE_SCANNERLESS; 
					;
				}				break;
					case 15:
				{
					#line 235 "parse.par"
	parser->p_mode = MODE_SCANNER; 
					;
				}				break;
					case 16:
				{
					#line 237 "parse.par"
	parser->p_mode = MODE_SCANNER; 
					;
				}				break;
					case 17:
				{
					#line 239 "parse.par"
	parser->p_mode = MODE_SCANNER; 
					;
				}				break;
					case 18:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 19:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 20:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 21:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 22:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 23:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 24:
				{
					#line 264 "parse.par"

							if( !( ( pcb->tos - 0 )->value.value_1 ) )
								strbuf_append( '1' );
							else
								strbuf_append( '0' );
						
					;
				}				break;
					case 25:
				{
					#line 270 "parse.par"
	reset_strbuf(); 
					;
				}				break;
					case 26:
				{
					#line 274 "parse.par"
	LIST* l;
							SYMBOL* s;

							for( l = ( ( pcb->tos - 0 )->value.value_2 ); l; l = l->next )
							{
								s = l->pptr;

								/* Do not allow nonterminal definitions here
									in conext-free model */
								if( s->type == SYM_NON_TERMINAL &&
									parser->p_mode !=
										MODE_SCANNERLESS )
								{
									print_error( parser, ERR_NONTERM_WS_NOT_ALLOWED,
										ERRSTYLE_FATAL | ERRSTYLE_FILEINFO,
												parser->filename, line,
													s->name );
								}
								else
									s->whitespace = TRUE;
							}

							list_free( ( ( pcb->tos - 0 )->value.value_2 ) );
						
					;
				}				break;
					case 27:
				{
					#line 300 "parse.par"
	LIST* l;
							SYMBOL* s;


							/* Ouput a warning, if this definition
								is effectless */
							if( parser->p_mode != MODE_SCANNERLESS )
							{
								print_error( parser, ERR_NO_EFFECT_IN_MODE,
									ERRSTYLE_WARNING | ERRSTYLE_FILEINFO,
										parser->filename, line, "lexeme" );
							}
							else
							{
								for( l = ( ( pcb->tos - 0 )->value.value_2 ); l; l = l->next )
								{
									s = l->pptr;
									s->lexem = TRUE;
								}
							}

							list_free( ( ( pcb->tos - 0 )->value.value_2 ) );
						
					;
				}				break;
					case 28:
				{
					#line 325 "parse.par"
	LIST* l;
							SYMBOL* s;

							/* Ouput a warning, if this definition
								is effectless */
							if( parser->p_mode != MODE_SCANNERLESS )
							{
								print_error( parser, ERR_NO_EFFECT_IN_MODE,
									ERRSTYLE_WARNING | ERRSTYLE_FILEINFO,
										parser->filename, line, "fixate" );
							}
							else
							{
								for( l = ( ( pcb->tos - 0 )->value.value_2 ); l; l = l->next )
								{
									s = l->pptr;
									s->fixated = TRUE;
								}
							}

							list_free( ( ( pcb->tos - 0 )->value.value_2 ) );

						
					;
				}				break;
					case 29:
				{
					#line 350 "parse.par"
	set_assoc_and_prec( ( ( pcb->tos - 0 )->value.value_2 ), ASSOC_LEFT ); 	
					;
				}				break;
					case 30:
				{
					#line 354 "parse.par"
	set_assoc_and_prec( ( ( pcb->tos - 0 )->value.value_2 ), ASSOC_RIGHT ); 	
					;
				}				break;
					case 31:
				{
					#line 358 "parse.par"
	set_assoc_and_prec( ( ( pcb->tos - 0 )->value.value_2 ), ASSOC_NOASSOC ); 
					;
				}				break;
					case 32:
				{
					#line 361 "parse.par"
	parser->p_prefix = pstrcatstr(
								parser->p_prefix, strbuf, FALSE );	
					;
				}				break;
					case 33:
				{
					#line 365 "parse.par"
	if( !( parser->p_def_action ) )
								parser->p_def_action = pstrdup( strbuf );
							else
								print_error( parser, ERR_DIRECTIVE_ALREADY_USED,
									ERRSTYLE_WARNING | ERRSTYLE_FILEINFO,
										parser->filename, line,
											"default epsilon action" );
						
					;
				}				break;
					case 34:
				{
					#line 375 "parse.par"
	if( !( parser->p_def_action_e ) )
								parser->p_def_action_e = pstrdup( strbuf );
							else
								print_error( parser, ERR_DIRECTIVE_ALREADY_USED,
									ERRSTYLE_WARNING | ERRSTYLE_FILEINFO,
										parser->filename, line,
											"default epsilon action" );
						
					;
				}				break;
					case 35:
				{
					#line 385 "parse.par"
	if( !( parser->p_def_type ) )
								parser->p_def_type = create_vtype(
									parser, (char*)( ( pcb->tos - 0 )->value.value_0 ) );
							else
								print_error( parser, ERR_DIRECTIVE_ALREADY_USED,
									ERRSTYLE_WARNING | ERRSTYLE_FILEINFO,
										parser->filename, line,
											"default value type" );

							pfree( ( ( pcb->tos - 0 )->value.value_0 ) );
						
					;
				}				break;
					case 36:
				{
					#line 398 "parse.par"
	/* Ouput a warning, if this definition
								is effectless */
							if( parser->p_mode != MODE_SCANNERLESS )
							{
								print_error( parser, ERR_NO_EFFECT_IN_MODE,
									ERRSTYLE_WARNING | ERRSTYLE_FILEINFO,
										parser->filename, line,
											"lexem separation" );
							}
							else
								parser->p_lexem_sep = !( ( pcb->tos - 0 )->value.value_1 );
						
					;
				}				break;
					case 37:
				{
					#line 412 "parse.par"
	parser->p_cis_strings = !( ( pcb->tos - 0 )->value.value_1 );	
					;
				}				break;
					case 38:
				{
					#line 415 "parse.par"
	parser->p_reserve_regex = !( ( pcb->tos - 0 )->value.value_1 );		
					;
				}				break;
					case 39:
				{
					#line 418 "parse.par"
	parser->p_header = pstrcatstr(
								parser->p_header, strbuf, FALSE );	
					;
				}				break;
					case 40:
				{
					#line 422 "parse.par"
	parser->p_footer = pstrcatstr(
								parser->p_footer, strbuf, FALSE );	
					;
				}				break;
					case 41:
				{
					#line 425 "parse.par"
	parser->p_pcb = pstrcatstr(
								parser->p_pcb, strbuf, FALSE );	
					;
				}				break;
					case 42:
				{
					
					;
				}				break;
					case 43:
				{
					 pcb->ret.value_5 = 0; 
					;
				}				break;
					case 44:
				{
					#line 429 "parse.par"

							set_option( parser->options,
								( ( pcb->tos - 1 )->value.value_0 ), strbuf, ( ( pcb->tos - 2 )->value.value_5 ) );

							strbuf = (char*)NULL;
						
					;
				}				break;
					case 45:
				{
					 pcb->ret.value_1 = ( ( pcb->tos - 0 )->value.value_1 ); 
					;
				}				break;
					case 46:
				{
					#line 439 "parse.par"
	pcb->ret.value_1 = FALSE; 
					;
				}				break;
					case 47:
				{
					#line 442 "parse.par"
	pcb->ret.value_1 = FALSE; 	
					;
				}				break;
					case 48:
				{
					#line 443 "parse.par"
	pcb->ret.value_1 = TRUE; 		
					;
				}				break;
					case 49:
				{
					#line 447 "parse.par"
	pcb->ret.value_2 = list_push( ( ( pcb->tos - 1 )->value.value_2 ), (void*)( ( pcb->tos - 0 )->value.value_3 ) ); 
					;
				}				break;
					case 50:
				{
					#line 450 "parse.par"
	pcb->ret.value_2 = list_push( (LIST*)NULL, (void*)( ( pcb->tos - 0 )->value.value_3 ) ); 
					;
				}				break;
					case 51:
				{
					#line 454 "parse.par"
	pcb->ret.value_3 = get_symbol( parser,
									strbuf, SYM_NON_TERMINAL, TRUE );
							pcb->ret.value_3->defined = TRUE;
							pcb->ret.value_3->line = line;
						
					;
				}				break;
					case 52:
				{
					#line 463 "parse.par"
	pcb->ret.value_2 = list_push( ( ( pcb->tos - 1 )->value.value_2 ), (void*)( ( pcb->tos - 0 )->value.value_3 ) ); 
					;
				}				break;
					case 53:
				{
					#line 467 "parse.par"
	pcb->ret.value_2 = list_push( (LIST*)NULL, (void*)( ( pcb->tos - 0 )->value.value_3 ) ); 
					;
				}				break;
					case 54:
				{
					#line 472 "parse.par"
	pcb->ret.value_2 = list_push( ( ( pcb->tos - 1 )->value.value_2 ),
									(void*)( ( pcb->tos - 0 )->value.value_3 ) );
							( ( pcb->tos - 0 )->value.value_3 )->derived_from =
								(SYMBOL*)list_access( ( ( pcb->tos - 1 )->value.value_2 ) );
						
					;
				}				break;
					case 55:
				{
					#line 480 "parse.par"
	pcb->ret.value_2 = list_push( (LIST*)NULL,
									(void*)( ( pcb->tos - 0 )->value.value_3 ) );

							current_sym = ( ( pcb->tos - 0 )->value.value_3 );
						
					;
				}				break;
					case 56:
				{
					#line 488 "parse.par"
	pcb->ret.value_3 = get_symbol( parser,
									strbuf, SYM_REGEX_TERMINAL, TRUE );


							if( pcb->ret.value_3->defined )
							{
								print_error( parser, ERR_DOUBLE_TERMINAL_DEF,
									ERRSTYLE_FATAL | ERRSTYLE_FILEINFO,
										parser->filename, line,
											pcb->ret.value_3->name );
							}

							pcb->ret.value_3->defined = TRUE;
							pcb->ret.value_3->line = line;
						
					;
				}				break;
					case 57:
				{
					#line 505 "parse.par"
 pcb->ret.value_1 = FALSE; 
					;
				}				break;
					case 58:
				{
					#line 506 "parse.par"
 pcb->ret.value_1 = FALSE; 
					;
				}				break;
					case 59:
				{
					#line 507 "parse.par"
 pcb->ret.value_1 = TRUE; 
					;
				}				break;
					case 60:
				{
					#line 508 "parse.par"
 pcb->ret.value_1 = TRUE; 
					;
				}				break;
					case 61:
				{
					#line 516 "parse.par"

							LIST* 	l;
							LIST*	m;
							PROD* 	p;
							SYMBOL*	lhs;
							VTYPE*	vt		= (VTYPE*)NULL;

							( ( pcb->tos - 3 )->value.value_2 ) = list_push( ( ( pcb->tos - 3 )->value.value_2 ), (void*)( ( pcb->tos - 5 )->value.value_3 ) );

							/* Value type */
							if( ( ( pcb->tos - 2 )->value.value_0 ) )
							{
								vt = create_vtype( parser,
										(char*)( ( pcb->tos - 2 )->value.value_0 ) );

								pfree( ( ( pcb->tos - 2 )->value.value_0 ) );
							}

							/* Connect left-hand sides */
							for( l = ( ( pcb->tos - 3 )->value.value_2 ); l; l = list_next( l ) )
							{
								lhs = (SYMBOL*)list_access( l );

								LISTFOR( ( ( pcb->tos - 0 )->value.value_2 ), m )
									plist_push( lhs->productions,
										list_access( m ) );

								lhs->vtype = vt;
							}

							/* Link productions with this left-hand sides */
							for( l = ( ( pcb->tos - 0 )->value.value_2 ); l; l = l->next )
							{
								LIST*	m;

								p = (PROD*)list_access( l );

								p->lhs = ( ( pcb->tos - 5 )->value.value_3 );

								LISTFOR( ( ( pcb->tos - 3 )->value.value_2 ), m )
									plist_push( p->all_lhs, list_access( m ) );

								/* AST */
								if( ( ( pcb->tos - 1 )->value.value_1 ) && !p->emit )
									p->emit = pstrdup( ( ( pcb->tos - 5 )->value.value_3 )->name );
							}

							list_free( ( ( pcb->tos - 0 )->value.value_2 ) );
							list_free( ( ( pcb->tos - 3 )->value.value_2 ) );

							/* Goal primary defined? */
							if( ( ( pcb->tos - 4 )->value.value_1 ) )
							{
								if( parser->goal )
								{
									print_error( parser, ERR_MULTIPLE_GOAL_DEF,
										ERRSTYLE_FATAL,
											parser->goal->name );
								}
								else
								{
									parser->goal = ( ( pcb->tos - 5 )->value.value_3 );
									parser->goal->used = TRUE;
								}
							}
						
					;
				}				break;
					case 62:
				{
					 pcb->ret.value_2 = ( ( pcb->tos - 0 )->value.value_2 ); 
					;
				}				break;
					case 63:
				{
					 pcb->ret.value_2 = 0; 
					;
				}				break;
					case 64:
				{
					#line 586 "parse.par"

							SYMBOL*	primary;
							SYMBOL* s;
							LIST* l;
							VTYPE*	vt;

							primary = (SYMBOL*)list_access( ( ( pcb->tos - 5 )->value.value_2 ) );

							primary->ptn = ( ( pcb->tos - 3 )->value.value_6 );
							primary->greedy = greedy;
							primary->emit = ( ( pcb->tos - 1 )->value.value_0 );

							greedy = TRUE;

							/* Attach code */
							if( ( ( pcb->tos - 2 )->value.value_0 ) )
							{
								/* Copy code for every symbol  */
								for( l = ( ( pcb->tos - 5 )->value.value_2 ); l;
									l = list_next( l ) )
								{
									s = (SYMBOL*)list_access( l );

									/*
										Last symbol gets strbuf-pointer,
										all other assignments need to be
										duplicated.
									*/
									if( list_next( l ) )
										s->code = pstrdup( strbuf );
									else
										s->code = strbuf;

									primary->code_at = last_code_begin;
								}

								strbuf = (char*)NULL;
							}

							/* Value type */
							if( ( ( pcb->tos - 4 )->value.value_0 ) )
							{
								vt = create_vtype( parser, ( ( pcb->tos - 4 )->value.value_0 ) );

								for( l = ( ( pcb->tos - 5 )->value.value_2 ); l;
									l = list_next( l ) )
								{
									s = (SYMBOL*)list_access( l );
									s->vtype = vt;
								}

								pfree( ( ( pcb->tos - 4 )->value.value_0 ) );
							}

							/* re_dbg_print_nfa( s->nfa_def,
								parser->p_universe ); */

							/* Assign the list of all possible symbols to
								the primary symbol */
							LISTFOR( ( ( pcb->tos - 5 )->value.value_2 ), l )
								plist_push( primary->all_sym,
									list_access( l ) );

							current_sym = (SYMBOL*)NULL;
						
					;
				}				break;
					case 65:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 66:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 67:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 68:
				{
					 pcb->ret.value_5 = 0; 
					;
				}				break;
					case 69:
				{
					#line 655 "parse.par"

							greedy = TRUE;
						
					;
				}				break;
					case 70:
				{
					#line 661 "parse.par"

							greedy = FALSE;
						
					;
				}				break;
					case 71:
				{
					#line 668 "parse.par"

							set_option( current_sym->options, ( ( pcb->tos - 1 )->value.value_0 ),
											strbuf, ( ( pcb->tos - 2 )->value.value_5 ) );

							strbuf = (char*)NULL;
						
					;
				}				break;
					case 72:
				{
					#line 677 "parse.par"
	pcb->ret.value_1 = TRUE; 
					;
				}				break;
					case 73:
				{
					#line 679 "parse.par"
	pcb->ret.value_1 = FALSE; 
					;
				}				break;
					case 74:
				{
					#line 683 "parse.par"
	pcb->ret.value_2 = list_push( ( ( pcb->tos - 2 )->value.value_2 ), ( ( pcb->tos - 0 )->value.value_4 ) ); 
					;
				}				break;
					case 75:
				{
					#line 686 "parse.par"
	pcb->ret.value_2 = list_push( (LIST*)NULL, ( ( pcb->tos - 0 )->value.value_4 ) ); 
					;
				}				break;
					case 76:
				{
					#line 689 "parse.par"
 pcb->ret.value_0 = pstrdup( strbuf ); 
					;
				}				break;
					case 77:
				{
					#line 690 "parse.par"
 pcb->ret.value_0 = pstrdup( strbuf ); 
					;
				}				break;
					case 78:
				{
					#line 691 "parse.par"
 pcb->ret.value_0 = (char*)NULL; 
					;
				}				break;
					case 79:
				{
					#line 697 "parse.par"

							( ( pcb->tos - 3 )->value.value_4 )->line = ( ( pcb->tos - 4 )->value.value_5 );

							if( ( ( pcb->tos - 2 )->value.value_0 ) )
							{
								( ( pcb->tos - 3 )->value.value_4 )->code = ( ( pcb->tos - 2 )->value.value_0 );
								( ( pcb->tos - 3 )->value.value_4 )->code_at = last_code_begin;
							}

							( ( pcb->tos - 3 )->value.value_4 )->emit = ( ( pcb->tos - 1 )->value.value_0 );

							pcb->ret.value_4 = ( ( pcb->tos - 3 )->value.value_4 );

							current_prod = (PROD*)NULL;
						
					;
				}				break;
					case 80:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 81:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 82:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 83:
				{
					 pcb->ret.value_5 = 0; 
					;
				}				break;
					case 84:
				{
					 pcb->ret.value_4 = ( ( pcb->tos - 0 )->value.value_4 ); 
					;
				}				break;
					case 85:
				{
					#line 716 "parse.par"
	pcb->ret.value_4 = create_production( parser,
								(SYMBOL*)NULL );
						
					;
				}				break;
					case 86:
				{
					#line 723 "parse.par"
	current_prod->prec = ( ( pcb->tos - 0 )->value.value_3 )->prec; 
					;
				}				break;
					case 87:
				{
					#line 727 "parse.par"
 	set_option( current_prod->options,
								( ( pcb->tos - 1 )->value.value_0 ), strbuf, ( ( pcb->tos - 2 )->value.value_5 ) );

							strbuf = (char*)NULL;
						
					;
				}				break;
					case 88:
				{
					#line 737 "parse.par"
	append_to_production( ( ( pcb->tos - 2 )->value.value_4 ), ( ( pcb->tos - 1 )->value.value_3 ),
								( *strbuf == '\0' ? (char*)NULL :
											pstrdup( strbuf ) ) );
									pcb->ret.value_4 = ( ( pcb->tos - 2 )->value.value_4 );
						
					;
				}				break;
					case 89:
				{
					#line 745 "parse.par"
	pcb->ret.value_4 = current_prod =
								create_production( parser,
									(SYMBOL*)NULL );

							append_to_production( pcb->ret.value_4, ( ( pcb->tos - 1 )->value.value_3 ),
								( *strbuf == '\0' ? (char*)NULL :
									pstrdup( strbuf ) ) );
						
					;
				}				break;
					case 90:
				{
					#line 757 "parse.par"

							switch( ( ( pcb->tos - 0 )->value.value_5 ) )
							{
								case '*':
									pcb->ret.value_3 = kleene_closure( parser, ( ( pcb->tos - 1 )->value.value_3 ) );
									break;
								case '+':
									pcb->ret.value_3 = positive_closure( parser, ( ( pcb->tos - 1 )->value.value_3 ) );
									break;
								case '?':
									pcb->ret.value_3 = optional_closure( parser, ( ( pcb->tos - 1 )->value.value_3 ) );
									break;
								default:
									pcb->ret.value_3 = ( ( pcb->tos - 1 )->value.value_3 );
									break;
							}
						
					;
				}				break;
					case 91:
				{
					#line 777 "parse.par"
	pcb->ret.value_3 = get_symbol( parser,
									P_ERROR_RESYNC, SYM_SYSTEM_TERMINAL,
										TRUE );
						
					;
				}				break;
					case 92:
				{
					#line 784 "parse.par"
	pcb->ret.value_3 = get_symbol( parser,
									P_END_OF_FILE, SYM_SYSTEM_TERMINAL,
										TRUE );
						
					;
				}				break;
					case 93:
				{
					 pcb->ret.value_3 = ( ( pcb->tos - 0 )->value.value_3 ); 
					;
				}				break;
					case 94:
				{
					#line 794 "parse.par"
	pcb->ret.value_3 = get_symbol( parser,
									strbuf, SYM_NON_TERMINAL, TRUE );
							pcb->ret.value_3->used = TRUE;

							if( pcb->ret.value_3->line < 0 )
								pcb->ret.value_3->line = line;
						
					;
				}				break;
					case 95:
				{
					#line 805 "parse.par"

							char	temp_nonterm[ ONE_LINE + 1 ];
							PROD*	prod;
							LIST*	l;

							sprintf( temp_nonterm, P_EMBEDDED,
									embedded_count++ );

							pcb->ret.value_3 = get_symbol( parser,
									temp_nonterm, SYM_NON_TERMINAL,
										TRUE );
							pcb->ret.value_3->defined = TRUE;
							pcb->ret.value_3->used = TRUE;
							pcb->ret.value_3->generated = TRUE;

							/* Value type */
							if( ( ( pcb->tos - 4 )->value.value_0 ) )
							{
								VTYPE*	vt;

								vt = create_vtype( parser,
										(char*)( ( pcb->tos - 4 )->value.value_0 ) );
								pcb->ret.value_3->vtype = vt;

								pfree( ( ( pcb->tos - 4 )->value.value_0 ) );
							}

							/* Associate the productions */
							current_prod = ( ( pcb->tos - 2 )->value.value_4 );

							/* Link productions with this left-hand side */
							for( l = ( ( pcb->tos - 1 )->value.value_2 ); l; l = list_next( l ) )
							{
								prod = (PROD*)list_access( l );

								prod->lhs = pcb->ret.value_3;
								plist_push( pcb->ret.value_3->productions, prod );
								plist_push( prod->all_lhs, pcb->ret.value_3 );
								make_semantic_rhs( prod );
							}
						
					;
				}				break;
					case 96:
				{
					#line 849 "parse.par"
 	pcb->ret.value_4 = current_prod;
							current_prod = (PROD*)NULL;
						
					;
				}				break;
					case 97:
				{
					#line 856 "parse.par"
	pccl*		ccl;

							ccl = pccl_create( -1, -1, strbuf );
							if( ( ( pcb->tos - 0 )->value.value_1 ) )
								pccl_negate( ccl );

							pcb->ret.value_3 = get_symbol( parser, (void*)ccl,
									SYM_CCL_TERMINAL, TRUE );

							pcb->ret.value_3->defined = TRUE;
							pcb->ret.value_3->used = TRUE;

							if( pcb->ret.value_3->line < 0 )
								pcb->ret.value_3->line = line;
						
					;
				}				break;
					case 98:
				{
					#line 874 "parse.par"
	pcb->ret.value_3 = get_symbol( parser,
									strbuf, SYM_REGEX_TERMINAL, TRUE );

							pcb->ret.value_3->used = TRUE;
							pcb->ret.value_3->defined = TRUE;
							pcb->ret.value_3->keyword = TRUE;
							pcb->ret.value_3->emit = pstrdup( strbuf );

							pcb->ret.value_3->ptn = pregex_ptn_create_string( strbuf,
										parser->p_cis_strings ?
											PREGEX_COMP_INSENSITIVE : 0 );

							if( pcb->ret.value_3->line < 0 )
								pcb->ret.value_3->line = line;
						
					;
				}				break;
					case 99:
				{
					#line 892 "parse.par"
	pcb->ret.value_3 = get_symbol( parser,
									strbuf, SYM_REGEX_TERMINAL, TRUE );

							/* pcb->ret.value_3->defined = TRUE;
							DO NOT SET DEFINED! */
							pcb->ret.value_3->used = TRUE;

							if( pcb->ret.value_3->line < 0 )
								pcb->ret.value_3->line = line;
						
					;
				}				break;
					case 100:
				{
					#line 905 "parse.par"
	pcb->ret.value_5 = (int)'*';	
					;
				}				break;
					case 101:
				{
					#line 908 "parse.par"
	pcb->ret.value_5 = (int)'+'; 	
					;
				}				break;
					case 102:
				{
					#line 911 "parse.par"
	pcb->ret.value_5 = (int)'?';	
					;
				}				break;
					case 103:
				{
					#line 914 "parse.par"
	pcb->ret.value_5 = 0; 		
					;
				}				break;
					case 104:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 105:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 106:
				{
					#line 920 "parse.par"
	reset_strbuf(); 
					;
				}				break;
					case 107:
				{
					 pcb->ret.value_6 = ( ( pcb->tos - 0 )->value.value_6 ); 
					;
				}				break;
					case 108:
				{
					#line 929 "parse.par"

							pcb->ret.value_6 = pregex_ptn_create_alt(
									( ( pcb->tos - 2 )->value.value_6 ), ( ( pcb->tos - 0 )->value.value_6 ), (pregex_ptn*)NULL );
						
					;
				}				break;
					case 109:
				{
					 pcb->ret.value_6 = ( ( pcb->tos - 0 )->value.value_6 ); 
					;
				}				break;
					case 110:
				{
					#line 940 "parse.par"

							pcb->ret.value_6 = pregex_ptn_create_seq(
									( ( pcb->tos - 1 )->value.value_6 ), ( ( pcb->tos - 0 )->value.value_6 ), (pregex_ptn*)NULL );
						
					;
				}				break;
					case 111:
				{
					 pcb->ret.value_6 = ( ( pcb->tos - 0 )->value.value_6 ); 
					;
				}				break;
					case 112:
				{
					#line 952 "parse.par"

							pcb->ret.value_6 = pregex_ptn_create_kle( ( ( pcb->tos - 1 )->value.value_6 ) );
						
					;
				}				break;
					case 113:
				{
					#line 958 "parse.par"

							pcb->ret.value_6 = pregex_ptn_create_pos( ( ( pcb->tos - 1 )->value.value_6 ) );
						
					;
				}				break;
					case 114:
				{
					#line 964 "parse.par"

							pcb->ret.value_6 = pregex_ptn_create_opt( ( ( pcb->tos - 1 )->value.value_6 ) );
						
					;
				}				break;
					case 115:
				{
					 pcb->ret.value_6 = ( ( pcb->tos - 0 )->value.value_6 ); 
					;
				}				break;
					case 116:
				{
					#line 974 "parse.par"

						pccl*		ccl;

						ccl = pccl_create( -1, -1, strbuf );
						if( ( ( pcb->tos - 0 )->value.value_1 ) )
							pccl_negate( ccl );

						pcb->ret.value_6 = pregex_ptn_create_char( ccl );
					
					;
				}				break;
					case 117:
				{
					#line 986 "parse.par"

						pcb->ret.value_6 = pregex_ptn_create_string( strbuf, 0 );
					
					;
				}				break;
					case 118:
				{
					#line 992 "parse.par"

						pccl*	ccl;
						greedy = FALSE;

						ccl = pccl_create( -1, -1, (char*)NULL );

						pccl_addrange( ccl, PCCL_MIN, PCCL_MAX );

						pcb->ret.value_6 = pregex_ptn_create_char( ccl );
					
					;
				}				break;
					case 119:
				{
					#line 1005 "parse.par"

						pcb->ret.value_6 = pregex_ptn_create_sub( ( ( pcb->tos - 1 )->value.value_6 ) );
					
					;
				}				break;
					case 120:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 121:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 122:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 123:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 124:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 125:
				{
					#line 1019 "parse.par"
	pcb->ret.value_1 = FALSE; 
					;
				}				break;
					case 126:
				{
					#line 1023 "parse.par"
	pcb->ret.value_1 = TRUE; 
					;
				}				break;
					case 127:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 2 )->value.value_5 ); 
					;
				}				break;
					case 128:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 129:
				{
					#line 1032 "parse.par"
	reset_strbuf(); 
					;
				}				break;
					case 130:
				{
					#line 1036 "parse.par"
	strbuf_append( ( ( pcb->tos - 0 )->value.value_5 ) ); 
					;
				}				break;
					case 131:
				{
					#line 1039 "parse.par"
 	strbuf_append( (char)'\\' );
						strbuf_append( ( ( pcb->tos - 0 )->value.value_5 ) ); 	  
					;
				}				break;
					case 132:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 2 )->value.value_5 ); 
					;
				}				break;
					case 133:
				{
					#line 1047 "parse.par"
 	strbuf_append( ( ( pcb->tos - 0 )->value.value_5 ) ); 
					;
				}				break;
					case 134:
				{
					#line 1048 "parse.par"
	reset_strbuf(); 
					;
				}				break;
					case 135:
				{
					#line 1052 "parse.par"
 	strbuf_append( ( ( pcb->tos - 0 )->value.value_5 ) ); 
					;
				}				break;
					case 136:
				{
					#line 1055 "parse.par"
 	strbuf_append( (char)'\\' );
						strbuf_append( ( ( pcb->tos - 0 )->value.value_5 ) );
					
					;
				}				break;
					case 137:
				{
					#line 1061 "parse.par"
	pcb->ret.value_0 = pstrdup( strbuf ); 
					;
				}				break;
					case 138:
				{
					#line 1062 "parse.par"
	pcb->ret.value_0 = (char*)NULL; 
					;
				}				break;
					case 139:
				{
					#line 1066 "parse.par"
 	strbuf_append( ( ( pcb->tos - 0 )->value.value_5 ) ); 
					;
				}				break;
					case 140:
				{
					#line 1067 "parse.par"
 	reset_strbuf(); 
					;
				}				break;
					case 141:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 142:
				{
					#line 1085 "parse.par"
 	reset_strbuf();
						strbuf_append( ( ( pcb->tos - 0 )->value.value_5 ) );
					
					;
				}				break;
					case 143:
				{
					#line 1092 "parse.par"
	strbuf_append( ( ( pcb->tos - 0 )->value.value_5 ) );  
					;
				}				break;
					case 144:
				{
					 pcb->ret.value_5 = 0; 
					;
				}				break;
					case 145:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 146:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 147:
				{
					#line 1104 "parse.par"
	strbuf_append( ( ( pcb->tos - 0 )->value.value_5 ) ); 
					;
				}				break;
					case 148:
				{
					#line 1107 "parse.par"
 	reset_strbuf();
						strbuf_append( ( ( pcb->tos - 0 )->value.value_5 ) );
					
					;
				}				break;
					case 149:
				{
					#line 1115 "parse.par"
 	pcb->ret.value_0 = pstrdup( ( ( pcb->tos - 0 )->value.value_0 ) );
						reset_strbuf();
					
					;
				}				break;
					case 150:
				{
					#line 1121 "parse.par"
	pcb->ret.value_0 = strbuf; 
					;
				}				break;
					case 151:
				{
					#line 1122 "parse.par"
	reset_strbuf();
						pcb->ret.value_0 = (char*)NULL; 
					;
				}				break;
					case 152:
				{
					#line 1127 "parse.par"

						if( !parser->p_template )
						{
							print_error( parser,
								ERR_NO_TARGET_TPL_SUPPLY,
									ERRSTYLE_WARNING | ERRSTYLE_IMPORTANT
									        | ERRSTYLE_FILEINFO,
								        parser->filename, last_code_begin );

							reset_strbuf();
						}
					
					;
				}				break;
					case 153:
				{
					#line 1143 "parse.par"
 last_code_begin = line; 
					;
				}				break;
					case 154:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 155:
				{
					#line 1147 "parse.par"
	reset_strbuf(); 
					;
				}				break;
					case 156:
				{
					#line 1151 "parse.par"
	strbuf_append( ( ( pcb->tos - 0 )->value.value_5 ) );		
					;
				}				break;
					case 157:
				{
					#line 1154 "parse.par"
	reset_strbuf();
						strbuf_append( ( ( pcb->tos - 0 )->value.value_5 ) );
					
					;
				}				break;
					case 161:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 162:
				{
					 pcb->ret.value_5 = 0; 
					;
				}				break;
					case 163:
				{
					#line 1164 "parse.par"
 line++;	
					;
				}				break;
					case 164:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 165:
				{
					 pcb->ret.value_5 = 0; 
					;
				}				break;
					case 167:
				{
					#line 1168 "parse.par"
 line++; 	
					;
				}				break;
					case 168:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 169:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 170:
				{
					#line 1176 "parse.par"
	if( ( ( pcb->tos - 0 )->value.value_5 ) == '\n' )
							line++;
						pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 );
					
					;
				}				break;
					case 171:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 172:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 173:
				{
					#line 1186 "parse.par"
 pcb->ret.value_5 = line; 
					;
				}				break;
					case 174:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 180:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 181:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 182:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 183:
				{
					
					;
				}				break;
					case 184:
				{
					
					;
				}				break;
					case 185:
				{
					
					;
				}				break;
					case 186:
				{
					
					;
				}				break;
					case 187:
				{
					
					;
				}				break;
					case 188:
				{
					
					;
				}				break;
					case 189:
				{
					
					;
				}				break;
					case 190:
				{
					
					;
				}				break;
					case 191:
				{
					
					;
				}				break;
					case 192:
				{
					
					;
				}				break;
					case 193:
				{
					 pcb->ret.value_0 = ( ( pcb->tos - 1 )->value.value_0 ); 
					;
				}				break;
					case 194:
				{
					
					;
				}				break;
					case 195:
				{
					
					;
				}				break;
					case 196:
				{
					
					;
				}				break;
					case 197:
				{
					
					;
				}				break;
					case 198:
				{
					
					;
				}				break;
					case 199:
				{
					
					;
				}				break;
					case 200:
				{
					 pcb->ret.value_0 = ( ( pcb->tos - 1 )->value.value_0 ); 
					;
				}				break;
					case 201:
				{
					
					;
				}				break;
					case 202:
				{
					
					;
				}				break;
					case 203:
				{
					
					;
				}				break;
					case 204:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 205:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 206:
				{
					 pcb->ret.value_3 = ( ( pcb->tos - 1 )->value.value_3 ); 
					;
				}				break;
					case 207:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 208:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 209:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 210:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 211:
				{
					
					;
				}				break;
					case 212:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 213:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 214:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 215:
				{
					
					;
				}				break;
					case 216:
				{
					
					;
				}				break;
					case 217:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 218:
				{
					
					;
				}				break;
					case 219:
				{
					
					;
				}				break;
					case 220:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 221:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 222:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 223:
				{
					 pcb->ret.value_1 = ( ( pcb->tos - 1 )->value.value_1 ); 
					;
				}				break;
					case 224:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 225:
				{
					
					;
				}				break;
					case 226:
				{
					
					;
				}				break;
					case 227:
				{
					
					;
				}				break;
					case 228:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 229:
				{
					
					;
				}				break;
					case 230:
				{
					
					;
				}				break;
					case 231:
				{
					
					;
				}				break;
					case 232:
				{
					
					;
				}				break;
					case 233:
				{
					
					;
				}				break;
					case 234:
				{
					
					;
				}				break;
					case 235:
				{
					
					;
				}				break;
					case 236:
				{
					
					;
				}				break;
					case 237:
				{
					
					;
				}				break;
					case 238:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 1 )->value.value_5 ); 
					;
				}				break;
					case 239:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 240:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 241:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 242:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 243:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 244:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 245:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 246:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 247:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 248:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 249:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 250:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 251:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 252:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 253:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 254:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 255:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 256:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 257:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 258:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 259:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 260:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 261:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 262:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 263:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 264:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 265:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 266:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 267:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 268:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 269:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 270:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 271:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 272:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 273:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 274:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 275:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 276:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 277:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 278:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 279:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 280:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 281:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 282:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 283:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 284:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 285:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 286:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 287:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 288:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 289:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 290:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 291:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 292:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 293:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 294:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 295:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 296:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 297:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 298:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 299:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 300:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 301:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 302:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 303:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 304:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 305:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 306:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 307:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 308:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 309:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 310:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 311:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 312:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 313:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 314:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 315:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 316:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 317:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 318:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 319:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 320:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 321:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 322:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 323:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 324:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 325:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 326:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 327:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 328:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 329:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 330:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 331:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 332:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 333:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 334:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 335:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 336:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 337:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 338:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 339:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 340:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 341:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 342:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 343:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 344:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 345:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 346:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 347:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 348:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 349:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 350:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 351:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 352:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 353:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 354:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 355:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 356:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 357:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 358:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 359:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 360:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 361:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 362:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 363:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 364:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 365:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 366:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 367:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 368:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 369:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 370:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 371:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 372:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 373:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 374:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 375:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 376:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 377:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 378:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 379:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 380:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 381:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 382:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 383:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 384:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 385:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 386:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 387:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 388:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 389:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 390:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 391:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 392:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 393:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 394:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 395:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 396:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 397:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 398:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 399:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 400:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 401:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 402:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 403:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 404:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 405:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 406:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 407:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 408:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 409:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 410:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 411:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 412:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 413:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 414:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 415:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 416:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 417:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 418:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 419:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 420:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 421:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 422:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 423:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 424:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 425:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 426:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 427:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 428:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 429:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 430:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 431:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 432:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 433:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 434:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 435:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 436:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 437:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 438:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 439:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 440:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 441:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 442:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 443:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 444:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 445:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 446:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 447:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 448:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 449:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 450:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 451:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 452:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 453:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 454:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 455:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 456:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 457:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 458:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 459:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 460:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 461:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 462:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 463:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 464:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 465:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 466:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 467:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 468:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 469:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 470:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 471:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 472:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 473:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 474:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 475:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 476:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 477:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 478:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 479:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 480:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 481:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
					case 482:
				{
					 pcb->ret.value_5 = ( ( pcb->tos - 0 )->value.value_5 ); 
					;
				}				break;
	
			}

			/* Drop right-hand side */
			/* TODO: Destructor callbacks? */
			for( i = 0, node = (_ast*)NULL;
					i < _productions[ pcb->idx ].length;
						i++ )
			{
				if( pcb->tos->node )
				{
					if( node )
					{
						while( node->prev )
							node = node->prev;

						node->prev = pcb->tos->node;
						pcb->tos->node->next = node;
					}

					node = pcb->tos->node;
					pcb->tos->node = (_ast*)NULL;
				}

				pcb->tos--;
			}

			/* This could be done if no AST construction would be done: */
			/* pcb->tos -= _productions[ pcb->idx ].length; */

			if( node )
			{
				if( lnode = pcb->tos->node )
				{
					while( lnode->next )
						lnode = lnode->next;

					lnode->next = node;
					node->prev = lnode;
				}
				else
					pcb->tos->node = node;
			}

			if( *_productions[ pcb->idx ].emit )
			{
				if( ( node = _ast_create( pcb,
								_productions[ pcb->idx ].emit,
									(UNICC_SCHAR*)NULL ) ) )
				{
					node->child = pcb->tos->node;
					pcb->tos->node = node;
				}
			}

			/* Enforced error in semantic actions? */
			if( pcb->act == UNICC_ERROR )
				break;

			/* Goal symbol reduced, and stack is empty? */
			if( pcb->lhs == 186 && pcb->tos == pcb->stack )
			{
				memcpy( &( pcb->tos->value ), &( pcb->ret ),
							sizeof( _vtype ) );
				pcb->ast = pcb->tos->node;

				UNICC_CLEARIN( pcb );

				pcb->act = UNICC_SUCCESS;

				#if UNICC_DEBUG
				fprintf( stderr, "%s: goal symbol reduced, exiting parser\n",
						UNICC_PARSER );
				#endif
				break;
			}

			#if UNICC_DEBUG
			fprintf( _dbg, "%s: after reduction, "
						"shifting nonterminal %d (%s)\n",
							UNICC_PARSER, pcb->lhs,
								_symbols[ pcb->lhs ].name );
			#endif

			_get_go( pcb );

			pcb->tos++;
			pcb->tos->node = (_ast*)NULL;

			memcpy( &( pcb->tos->value ), &( pcb->ret ),
						sizeof( _vtype ) );
			pcb->tos->symbol = &( _symbols[ pcb->lhs ] );
			pcb->tos->state = ( pcb->act & UNICC_REDUCE ) ? -1 : pcb->idx;
			pcb->tos->line = pcb->line;
			pcb->tos->column = pcb->column;
		}

		if( pcb->act == UNICC_SUCCESS || pcb->act == UNICC_ERROR )
			break;

		/* If in error recovery, replace old-symbol */
		if( pcb->error_delay == UNICC_ERROR_DELAY
				&& ( pcb->sym = pcb->old_sym ) < 0 )
		{
			/* If symbol is invalid, try to find new token */
			#if UNICC_DEBUG
			fprintf( _dbg, "%s: error recovery: "
				"old token invalid, requesting new token\n",
						UNICC_PARSER );
			#endif

			while( !_get_sym( pcb ) )
			{
				/* Skip one character */
				pcb->len = 1;

				UNICC_CLEARIN( pcb );
			}

			#if UNICC_DEBUG
			fprintf( _dbg, "%s: error recovery: "
				"new token %d (%s)\n", UNICC_PARSER, pcb->sym,
					_symbols[ pcb->sym ].name );
			#endif
		}
		else
		{
			_get_sym( pcb );
		}

#if UNICC_DEBUG
		fprintf( _dbg, "%s: current token %d (%s)\n",
					UNICC_PARSER, pcb->sym,
						( pcb->sym < 0 ) ? "(null)" :
							_symbols[ pcb->sym ].name );
#endif

		/* Get action table entry */
		if( !_get_act( pcb ) )
		{
			/* Error state, try to recover */
			if( _handle_error( pcb,
#if UNICC_DEBUG
					_dbg
#else
					(FILE*)NULL
#endif
					) )
				break;
		}

#if UNICC_DEBUG
		fprintf( _dbg,
			"%s: sym = %d (%s) [len = %d] tos->state = %d act = %s idx = %d\n",
				UNICC_PARSER, pcb->sym,
					( ( pcb->sym >= 0 ) ?
						_symbols[ pcb->sym ].name :
							"(invalid symbol id)" ),
					pcb->len, pcb->tos->state,
						( ( pcb->act == UNICC_SHIFT & UNICC_REDUCE ) ?
								"shift/reduce" :
							( pcb->act & UNICC_SHIFT ) ?
									"shift" : "reduce" ), pcb->idx );
#if UNICC_STACKDEBUG
		_dbg_stack( _dbg, pcb->stack, pcb->tos );
#endif
#endif

		/* Shift */
		if( pcb->act & UNICC_SHIFT )
		{
			pcb->next = pcb->buf[ pcb->len ];
			pcb->buf[ pcb->len ] = '\0';

#if UNICC_DEBUG
			fprintf( _dbg, "%s: >> shifting terminal %d (%s)\n",
			UNICC_PARSER, pcb->sym, _symbols[ pcb->sym ].name );
#endif

			if( _alloc_stack( pcb ) < 0 )
				return (int)0;

			pcb->tos++;
			pcb->tos->node = (_ast*)NULL;

			/*
				Execute scanner actions, if existing.
				Here, UNICC_ON_SHIFT is set to 1, so that shifting-
				related operations will be performed.
			*/
#define UNICC_ON_SHIFT	1
			switch( pcb->sym )
			{
#line 257 "parse.par"
				case 40:
				{
					
						( pcb->tos->value.value_0 ) = _lexem( pcb );
					
					;
				}				break;
	

				default:
					( ( pcb->tos - 0 )->value.value_5 ) = _get_input( pcb, 0 );
					break;
			}
#undef UNICC_ON_SHIFT

			pcb->tos->state = ( pcb->act & UNICC_REDUCE ) ? -1 : pcb->idx;
			pcb->tos->symbol = &( _symbols[ pcb->sym ] );
			pcb->tos->line = pcb->line;
			pcb->tos->column = pcb->column;

			if( *pcb->tos->symbol->emit )
				pcb->tos->node = _ast_create( pcb,
									pcb->tos->symbol->emit,
										_lexem( pcb ) );
			else
				pcb->tos->node = (_ast*)NULL;

			pcb->buf[ pcb->len ] = pcb->next;

			/* Perform the shift on input */
			if( pcb->sym != 0 && pcb->sym != -1 )
			{
				UNICC_CLEARIN( pcb );
				pcb->old_sym = -1;
			}

			if( pcb->error_delay )
				pcb->error_delay--;
		}
	}

	#if UNICC_DEBUG
	fprintf( _dbg, "%s: parse completed with %d errors\n",
		UNICC_PARSER, pcb->error_count );
	#endif

	/* Save return value */
	ret = ( ( pcb->tos - 0 )->value.value_5 );

	/* Clean up parser control block */
	if( pcb->buf )
		free( pcb->buf );
	if( pcb->stack )
		free( pcb->stack );
#if UNICC_UTF8
	if( pcb->lexem )
		free( pcb->lexem );
#endif

	/* Clean memory of self-allocated parser control block */
	if( pcb->is_internal )
		free( pcb );

	return ret;
}



static void parse_error( _pcb* pcb )
{
	int		i;
	char**	vptr;
	char**	valid;
	char*	cur;

	if( !( vptr = valid =
			(char**)pmalloc( ( _act[ pcb->tos->state ][0] + 1 )
						* sizeof( char* ) ) ) )
		OUTOFMEM;

	for( i = 1; i < _act[ pcb->tos->state ][0] * 3; i += 3 )
		*( vptr++ ) = _symbols[ _act[ pcb->tos->state ][i] ].name;

	*vptr = (char*)NULL;

	if( pcb->sym == -1 )
		cur = pcb->lexem;
	else
		cur = _symbols[ pcb->sym ].name;

	print_error( parser, ERR_PARSE_ERROR,
				ERRSTYLE_FATAL | ERRSTYLE_FILEINFO,
					parser->filename, pcb->line, cur, valid );
}

int parse_grammar( PARSER* p, char* src )
{
	_pcb pcb;

	line = 1;
	prec_cnt = 1;
	embedded_count = 0;
	memset( &pcb, 0, sizeof( pcb ) );

	if( p && src )
	{
		parser = p;
		strbuf_append( '\0' );

		src_ptr = src;

		_parse( &pcb );

		pfree( strbuf );
	}

	return pcb.error_count + error_count;
}



/* Create Main? */
#if 926 == 0
	#ifndef UNICC_MAIN
	#define UNICC_MAIN 	1
	#endif
#else
	#ifndef UNICC_MAIN
	#define UNICC_MAIN 	0
	#endif
#endif

#if UNICC_MAIN

int main( int argc, char** argv )
{
#define UNICCMAIN_SILENT		1
#define UNICCMAIN_ENDLESS		2
#define UNICCMAIN_LINEMODE		4
#define UNICCMAIN_SYNTAXTREE	8
#define UNICCMAIN_AUGSYNTAXTREE	16

	char*			opt;
	int				flags	= 0;
	int				i;
	_pcb	pcb;

#ifdef LC_ALL
	setlocale( LC_ALL, "" );
#endif

	/* Get command-line options */
	for( i = 1; i < argc; i++ )
	{
		if( *(argv[i]) == '-' )
		{
			opt = argv[i] + 1;

			/* Long option coming? */
			if( *opt == '-' )
			{
				opt++;

				if( !strcmp( opt, "silent" ) )
					flags |= UNICCMAIN_SILENT;
				else if( !strcmp( opt, "endless" ) )
					flags |= UNICCMAIN_ENDLESS;
				else if( !strcmp( opt, "line-mode" ) )
					flags |= UNICCMAIN_LINEMODE;
				else
				{
					fprintf( stderr, "Unknown option '--%s'\n", argv[i] );
					return 1;
				}
			}

			for( ; *opt; opt++ )
			{
				if( *opt == 's' )
					flags |= UNICCMAIN_SILENT;
				else if( *opt == 'e' )
					flags |= UNICCMAIN_ENDLESS;
				else if( *opt == 'l' )
					flags |= UNICCMAIN_LINEMODE;
				else
				{
					fprintf( stderr, "Unknown option '-%c'\n", *opt );
					return 1;
				}
			}
		}
	}

	/* Parser invocation loop */
	do
	{
		if( !( flags & UNICCMAIN_SILENT ) )
			printf( "\nok\n" );

		/* Invoke parser */
		memset( &pcb, 0, sizeof( _pcb ) );

		if( flags & UNICCMAIN_LINEMODE )
			pcb.eof = '\n';
		else
			pcb.eof = EOF;

		_parse( &pcb );

		/* Print AST */
		if( pcb.ast )
		{
			_ast_print( stderr, pcb.ast );
			_ast_free( pcb.ast );
		}
	}
	while( flags & UNICCMAIN_ENDLESS );

	return 0;
}
#endif

